Package: abseqR
Type: Package
Title: Reporting and data analysis functionalities for Rep-Seq datasets
        of antibody libraries
Version: 1.30.0
Authors@R: c(
    person("JiaHong", "Fong", email = "jiahfong@gmail.com", role = c("cre", "aut")),
    person("Monther", "Alhamdoosh", email = "m.hamdoosh@gmail.com", role = "aut"))
Description: AbSeq is a comprehensive bioinformatic pipeline for the analysis of sequencing datasets 
    generated from antibody libraries and abseqR is one of its packages. abseqR empowers the users 
    of abseqPy (https://github.com/malhamdoosh/abseqPy) with plotting and reporting capabilities and
    allows them to generate interactive HTML reports for the convenience of viewing and sharing with 
    other researchers. Additionally, abseqR extends abseqPy to compare multiple
    repertoire analyses and perform further downstream analysis on its output.
License: GPL-3 | file LICENSE
Encoding: UTF-8
Depends: R (>= 3.5.0)
Imports: ggplot2, RColorBrewer, circlize, reshape2, VennDiagram, plyr,
        flexdashboard, BiocParallel (>= 1.1.25), png, grid, gridExtra,
        rmarkdown, knitr, vegan, ggcorrplot, ggdendro, plotly,
        BiocStyle, stringr, utils, methods, grDevices, stats, tools,
        graphics
VignetteBuilder: knitr
RoxygenNote: 6.1.0
Collate: 'accessors-AbSeq.R' 'AbSeqCRep.R' 'util.R' 'distributions.R'
        'upstreamAnalysis.R' 'productivityAnalysis.R'
        'primerAnalysis.R' 'diversityAnalysis.R' 'annotationAnalysis.R'
        'abundanceAnalysis.R' 'plotter.R' 'AbSeqRep.R' 'abseqReport.R'
        'statistics.R' 'pairwise.R'
SystemRequirements: pandoc (>= 1.19.2.1)
URL: https://github.com/malhamdoosh/abseqR
BugReports: https://github.com/malhamdoosh/abseqR/issues
biocViews: Sequencing, Visualization, ReportWriting, QualityControl,
        MultipleComparison
Suggests: testthat
git_url: https://git.bioconductor.org/packages/abseqR
git_branch: RELEASE_3_23
git_last_commit: b90f5f9
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.23
Date/Publication: 2026-04-28
NeedsCompilation: no
Packaged: 2026-04-28 20:33:23 UTC; biocbuild
Author: JiaHong Fong [cre, aut],
  Monther Alhamdoosh [aut]
Maintainer: JiaHong Fong <jiahfong@gmail.com>

# abseqR: reporting functions and downstream analysis of antibody libraries Rep-Seq

`AbSeq` is a comprehensive bioinformatic pipeline for the analysis of sequencing datasets generated from antibody libraries and `abseqR` is one of its packages.


`abseqR` empowers the users of [`abseqPy`](https://github.com/malhamdoosh/abseqPy) with
plotting and reporting capabilities and
allows them to generate interactive HTML reports for the convenience of viewing and sharing with other researchers. Additionally, `abseqR` extends `abseqPy` to __compare__ multiple
repertoire analyses and perform further downstream analysis on its output.

Note that `abseqR` does not require `abseqPy` to be installed to work but the output of `abseqPy` must be already present to invoke `abseqR`'s functions.

## Developers

- AbSeq is developed by JiaHong Fong and Monther Alhamdoosh

- For comments and suggestions, email jiahfong \<at\> gmail \<dot\> com

## Installation

### System requirements

[pandoc](http://pandoc.org/installing.html) is highly
recommended. If `abseqR` fails to detect `pandoc` in your
system's `PATH` variable, it will not be able to generate a collated HTML report yet you can still access individual plots.

> Make sure `pandoc` is at least version 1.19.2.1

### Installation

#### Install from Bioconductor

As soon as `abseqR` is available in the [Bioconductor](http://bioconductor.org/)
project, it can be installed from R console as follows:
```r
if (!require("BiocManager"))
    install.packages("BiocManager")
BiocManager::install("abseqR")
```

#### Install from GitHub

To install the development version of `abseqR`
from GitHub, type the following commands in R Console:
```r
if (!require("BiocManager"))
    install.packages("BiocManager")
BiocManager::install("malhamdoosh/abseqR")
```

## Quick start

Assuming `abseqPy` has completed an analysis and the output directory was
named `output`, a basic usage of `abseqR` is:

```r
library(abseqR)
abseqReport("/path/to/output")
```

This will generate an interctive report of the analysis results. Please refer to the package's main vignette for more advanced use cases.


## Features

`abseqR` generates numerous plots for the quality control analysis of antibody libraries
and collates the results into an interactive HTML report.

<div align="center">
    <img src="man/figures/abseq_gif.gif" width=791 height=474>
</div>

Additional plots along with documentation can be found in `abseqR`'s main vignette.

In R console, type:

```r
browseVignettes("abseqR")
```

This directory has been left empty intentionally.

This directory should contain HDF files but they are too large to be stored here, and serve no purpose
in demonstrating abseqR exanples in the vignette. However, this directory should still exist
as this directory is expected to be present in a normal AbSeq analysis.

# single plot uses light blue colour
BLUEHEX <- "#56B4E9"

# plot sizes
V_WIDTH <- 8
V_HEIGHT <- 5
H_WIDTH <- 5
H_HEIGHT <- 8
VENN_WIDTH <- 8
VENN_HEIGHT <- 8
V_WIDTH_L <- 12
V_HEIGHT_L <- 7.5

# AbSeq's output directory structure(s)
RESULT_DIR <- "auxiliary"
AUX_DIR <- "hdf"
# AbSeq's analysis directory names
ABSEQ_DIR_ANNOT <- "annot"
ABSEQ_DIR_PROD <- "productivity"
ABSEQ_DIR_ABUN <- "abundance"
ABSEQ_DIR_DIV <- "diversity"
ABSEQ_DIR_PAIR <- "clonotype_analysis"
ABSEQ_DIR_PRIM <- "primer_specificity"
ABSEQ_DIR_5UTR <- "utr5"
ABSEQ_DIR_SEC <- "secretion"
ABSEQ_HTML_DIR <- "report"
ABSEQ_NESTED_HTML_DIR <- "html_files"

# parameter file from AbSeq's run
ANALYSIS_PARAMS <- "analysis.params"

# AbSeq's summary file about the repertoire - raw/annot/prod counts
ABSEQ_SUMMARY <- "summary.txt"

# These are the "key"s from ABSEQ_SUMMARY file
# They should be in the format of: (for example)
# RawReads:<number>
# AnnotatedReads:<number>
ABSEQ_RAW_READ_COUNT_KEY <- "RawReads"
ABSEQ_ANNOT_READ_COUNT_KEY <- "AnnotatedReads"
ABSEQ_FILT_READ_COUNT_KEY <- "FilteredReads"
ABSEQ_PROD_READ_COUNT_KEY <- "ProductiveReads"


#' Checks if abseqPy has a metadata line that suggests
#' the orientation
#'
#' @param filename csv filename
#'
#' @return True if CSV metadata says "plot vertically"
.checkVert <- function(filename) {
    f <- file(filename, "r")
    res <- grepl("vert", readLines(f, n = 1), fixed = TRUE)
    close(f)
    return(res)
}

#' Get total number of samples (n)
#'
#' @description Often enough, the CSV values supplied do not contain
#' raw counts but percentages (so this value will let us know exactly
#' the sample size).
#'
#' @param filename csv filename
#'
#' @return string, sample size.
.getTotal <- function(filename) {
    f <- file(filename, "r")
    res <- unlist(strsplit(readLines(f, n = 1), "="))[2]
    close(f)
    return(res)
}

.listFilesInOrder <- function(path, pattern, expectedRet = c(1)) {
    # Returns files in order of path.
    # i.e overrides list.files' behaviour of sorted files
    # This is crucial because we are assuming sampleNames is
    # in 1-1 correspondance with dataframes.
    # This can be achieved by manually iterating over all sample path
    # in the provided vector of path and appending to a vector.
    # Sometimes, (like abundance) list.files will return more that one
    # matching file (gene, family, variant), so expectedRet is there to ensure
    # that we aren't doing something silly. expectRet is a vector because
    # sometimes there might be more than one possible configuration.
    # EG: abundance plot may or maynot have D gene when analyzing heavy/light
    # chains
    # Returns: ordered vector of files (according to provided path's ordering)
    orderedFiles <- c()
    for (p in path) {
        retval <- list.files(
            path = p,
            pattern = pattern,
            full.names = TRUE,
            recursive = TRUE
        )
        # short circuit once at least one of the paths don't have the required
        # file. (Can't compare all the samples if one of them is missing!)
        if (length(retval) == 0) {
            return(c())
        }
        if (!(length(retval) %in% expectedRet)) {
            stop("Expected either ", paste(expectedRet, collapse = ", "),
                 " files to be found, but only ",
                 length(retval),
                 " were found.")
        }
        orderedFiles <- c(orderedFiles,  retval)
    }
    return(orderedFiles)
}

#' Returns all samples found under \code{sampleDirectory}
#'
#' @param sampleDirectory string, path to sample directory.
#'
#' @return un-normalized path to all samples under \code{sampleDirectory}
.inferAnalyzed <- function(sampleDirectory) {
    everything <- list.files(sampleDirectory)
    fullPath <- lapply(everything, function(x) {
        file.path(sampleDirectory, x)
    })
    return(everything[unlist(lapply(fullPath, dir.exists))])
}

#' Helper function to capitalize the first letter of \code{str}
#'
#' @param str string type
#'
#' @return string, \code{str} capitalized
.capitalize <- function(str) {
    firstLetter <- substr(str, 1, 1)
    rest <- substr(str, 2, nchar(str))
    return(paste0(toupper(firstLetter), rest))
}

#' Summary of dataframe
#'
#' @description Gives count, mean, standard deviation,
#' standard error of the mean, and confidence interval (default 95\%).
#'
#' adapted from http://www.cookbook-r.com/Graphs/Plotting_means_and_error_bars_(ggplot2)/#Helper functions
#'
#' @param data a data frame.
#' @param measurevar the name of a column that contains the variable to be summariezed
#' @param groupvars a vector containing names of columns that contain grouping variables
#' @param na.rm a boolean that indicates whether to ignore NA's
#' @param conf.interval the percent range of the confidence interval (default is 95\%)
#' @param .drop logical.
#'
#' @import plyr stats
#'
#' @return dataframe
.summarySE <-
    function(data = NULL,
             measurevar,
             groupvars = NULL,
             na.rm = FALSE,
             conf.interval = .95,
             .drop = TRUE) {
        # New version of length which can handle NA's: if na.rm==T, don't count them
        length2 <- function(x, na.rm = FALSE) {
            if (na.rm) {
                sum(!is.na(x))
            } else {
                length(x)
            }
        }

        # This does the summary. For each group's data frame, return a vector with
        # N, mean, and sd
        datac <- ddply(
            data,
            groupvars,
            .drop = .drop,
            .fun = function(xx, col) {
                c(
                    N    = length2(xx[[col]], na.rm = na.rm),
                    mean = mean   (xx[[col]], na.rm = na.rm),
                    sd   = sd     (xx[[col]], na.rm = na.rm)
                )
            },
            measurevar
        )

        # Rename the "mean" column
        datac <- rename(datac, c("mean" = measurevar))

        datac$se <-
            datac$sd / sqrt(datac$N)  # Calculate standard error of the mean

        # Confidence interval multiplier for standard error
        # Calculate t-statistic for confidence interval:
        # e.g., if conf.interval is .95, use .975 (above/below), and use df=N-1
        ciMult <- qt(conf.interval / 2 + .5, datac$N - 1)
        datac$ci <- datac$se * ciMult

        return(datac)
    }

#' Helper function to return line types by importance based on provided
#' CD/Fs regions
#'
#' @description In the aesthetics of diversity plots (rarefaction, recapture,
#' and duplication), the line types should emphasise the most important
#' antibody region, they're ranked in ascending order of:
#' "FR4", "FR1", "FR2", "FR3", "CDR1", "CDR2", "CDR3", "V".
#'
#' @param regions a list/vector of strings (regions)
#'
#' @return vector of strings, each corresponding to the appropriate line type
#' for \code{regions}.
.getLineTypes <- function(regions) {
    if (length(regions) > 6) {
        stop("No line types for regions with length > 6 ")
    }
    regions <- unlist(lapply(regions, toupper))
    # order of importance: min -> max
    lvls <-
        c("FR4", "FR1", "FR2", "FR3", "CDR1", "CDR2", "CDR3", "V")
    # order of importance: max -> min
    lines <-
        c("solid",
          "twodash",
          "dotted",
          "dotdash",
          "longdash",
          "dashed")

    factorRegions <- factor(regions, levels = lvls)
    return(lines[order(factorRegions, decreasing = TRUE)])
}


#' Saves ggplot object as a Rdata file.
#'
#' @description It's a convinient function that does the check and saves
#' at the same time, for brevity within other areas of the code (to eliminate
#' repeated if checks).
#'
#' @import tools
#'
#' @param .save logical type. Whether or not we should save.
#' @param filename string.
#' @param plot ggplot object.
#'
#' @return nothing
.saveAs <- function(.save, filename, plot) {
    if (.save) {
        fname <- sub(tools::file_ext(filename), "Rdata", filename)
        save(file = fname, list = c("plot"))
    }
}


#' Return value specifed by key from AbSeq's summary file
#'
#' @param sampleRoot sample's root directory. For example,
#' \code{/path/to/<outputdir>/reports/<sample_name>}.
#' @param key character type. Possible values are (though they might change)
#' \itemize{
#'    \item{RawReads}
#'    \item{AnnotatedReads}
#'    \item{FilteredReads}
#'    \item{ProductiveReads}
#' }
#' @return value associated with key from summary file. "NA" (in string) if the field
#' is not available refer to util.R for the key values
.readSummary <- function(sampleRoot, key) {
    fname <- file.path(sampleRoot, ABSEQ_SUMMARY)
    con <- file(fname, "r")
    lines <- readLines(con)
    close(con)
    for (line in lines) {
        if (grepl(key, line, fixed = TRUE)) {
            return(strsplit(line, ":")[[1]][2])
        }
    }
    return("NA")
}


#' Substitutes the first occurance of `key` with `value` in `filename`
#'
#' @param filename character type
#' @param key character type
#' @param value character type
#' @param fixed logical type
#'
#' @return None
.substituteStringInFile <-
    function(filename, key, value, fixed = FALSE) {
        con <- file(filename, "r")
        lines <- readLines(con)
        close(con)
        lines <- sub(key, value, lines, fixed = fixed)
        con <- file(filename, "w")
        cat(lines, file = con, sep = "\n")
        close(con)
    }


#' Creates and returns an empty plot
#'
#' @import ggplot2
#'
#' @return empty ggplot2 object
.emptyPlot <- function() {
    # placeholder plot - prints nothing at all
    # https://www.r-bloggers.com/ggplot2-cheatsheet-for-visualizing-distributions/
    # https://github.com/mikessh/vdjtools/blob/master/src/main/resources/rscripts/intersect_pair_scatter.r
    g <- ggplot() + geom_point(aes(1, 1), colour = "white") +
        theme(
            plot.background = element_blank(),
            panel.grid.major = element_blank(),
            panel.grid.minor = element_blank(),
            panel.border = element_blank(),
            panel.background = element_blank(),
            axis.title.x = element_blank(),
            axis.title.y = element_blank(),
            axis.text.x = element_blank(),
            axis.text.y = element_blank(),
            axis.ticks = element_blank(),
            plot.margin = unit(c(3, -5.5, 4, 3), "mm")
        )
    return(g)
}


#' Given a dataframe with the columns "from", "to", and value.var, return
#' a symmetric matrix (with diagonal values = diag). I.e. a call to
#' isSymmetric(return_value_of_this_function) will always be TRUE.
#'
#'
#' @import reshape2
#'
#' @param dataframe dataframe with 3 required columns, namely:
#' +---------------------------------------+
#' | from | to | value.var | ...           |
#' +---------------------------------------+
#' |      |    |           |               |
#' +---------------------------------------+
#' where value.var is the string provided in the function parameter
#' @param value.var the column to use as the matrix value
#' @param diag what should the diagonal values be if the dataframe doesn't provide them
#' @param unidirectional logical type. If the dataframe provided has the reverse
#' pairs (i.e. a from-to pair AND a to-from pair with the save values in the
#' value.var column), then this should be FALSE. Otherwise, this function will
#' flip the from-to columns to generate a symmetric dataframe (and hence, a
#' symmetric matrix).
#'
#' @return a symmetric matrix with rownames(mat) == colnames(mat)
#' The diagonal values are filled with diag if the dataframe itself doesn't have
#' diagonal data
.loadMatrixFromDF <-
    function(dataframe,
             value.var,
             diag,
             unidirectional = TRUE) {
        if (unidirectional) {
            # swap the columns "from" and "to", while the others remain the same
            df.r <-
                dataframe[, c(2, 1, tail(seq_along(names(dataframe)), -2))]
            # rename the columns (after swapping, it's to - from, need it to be from - to)
            names(df.r) <- names(dataframe)
            # rowbind the dataframes into one
            df.f <- rbind(dataframe, df.r)
        } else {
            # bidirectional dataframe doesn't require mirror-ing
            df.f <- dataframe
        }
        mat <-
            reshape2::acast(df.f, from ~ to, value.var = value.var, fill = diag)
        # make sure the matrix is symmetric
        mat <- mat[, rownames(mat)]
        stopifnot(isSymmetric(mat))
        mat
    }


#' Given a directory = <abseqPy_outputdir>/RESULT_DIR/, returns the directories (repositories) in
#' 'directory'. That is, will not return any sample_vs_sample directories.
#' This is done by asserting that a 'repository'
#' must have an (analysis.params) file, and a summary.txt file.
#'
#' A sample_vs_sample directory will not have these files.
#'
#' @param directory string. Path up until <abseqPy_outputdir>/RESULT_DIR/
#'
#' @return vector of strings that are samples in 'directory', note, this is NOT
#' a full path, but just the sample/repertoire name itself
.findRepertoires <- function(directory) {
    repos <- list.files(directory, full.names = TRUE)
    # given a directory (d), return True if d is a repository
    .isRepo <- function(d) {
        all(c("analysis.params", "summary.txt") %in% list.files(d))
    }
    vapply(Filter(.isRepo, repos), basename, USE.NAMES = FALSE, FUN.VALUE = "")
}

#' Annotation analysis
#'
#' @import ggplot2
#' @include util.R
#' @include distributions.R
#'
#' @param annotDirectories list type. List of sample directories
#' @param annotOut string type. Output directory
#' @param sampleNames vector type. 1-1 with annotDirectories
#' @param mashedNames string type. File output "mashed" sample names
#' @param .save logical type. Saves ggplot object
#'
#' @return none
.annotAnalysis <- function(annotDirectories,
                           annotOut,
                           sampleNames,
                           mashedNames,
                           .save = TRUE) {
    # with outliers
    searchFiles <-
        .listFilesInOrder(path = annotDirectories,
                          pattern = ".*_all_clones_len_dist\\.csv(\\.gz)?$")
    message("Starting annotation plot")
    # plotSpectratype names the sample(s) for us in the title
    if (length(searchFiles) > 0) {
        g <- .plotSpectratype(
            lapply(searchFiles, read.csv),
            sampleNames,
            title = "Sequence lengths",
            xlabel = "Sequence Length (bp)",
            ylabel = "Proportion",
            showLabel = FALSE
        )
        fname <- file.path(annotOut,
                           paste0(mashedNames, "_all_clones_len_dist.png"))
        ggsave(fname,
               plot = g,
               width = V_WIDTH,
               height = V_HEIGHT)
        .saveAs(.save, fname, g)
    } else {
        warning("Cannot find clone length distribution file from samples ",
                paste(sampleNames, collapse = ", "))
    }

    # without outliers
    searchFiles <-
        .listFilesInOrder(path = annotDirectories,
                          pattern = ".*_all_clones_len_dist_no_outliers\\.csv(\\.gz)?$")

    # plotSpectratype names the sample(s) for us in the title
    if (length(searchFiles) > 0) {
        g <- .plotSpectratype(
            lapply(searchFiles, read.csv),
            sampleNames,
            title = "Sequence lengths",
            xlabel = "Sequence Length (bp)",
            ylabel = "Proportion",
            showLabel = FALSE
        )
        fname <- file.path(annotOut,
                           paste0(mashedNames,
                                  "_all_clones_len_dist_no_outliers.png"))
        ggsave(fname,
               plot = g,
               width = V_WIDTH,
               height = V_HEIGHT)
        .saveAs(.save, fname, g)
    } else {
        warning("Cannot find clone length (no outliers) ",
                "distribution file from samples ",
                paste(sampleNames, collapse = ", "))
    }
}

#' Bar plotter
#' @description  Plots barplot for all sample in dataframes.
#' If length(sampleNames) == 1, then the bars will also have
#' y-values (or x if horizontal plot) labels on them.
#' Use 'perc' to control if the values are percentages.
#'
#' @include util.R
#' @import ggplot2
#'
#' @param dataframes  list type. List of dataframes
#' @param sampleNames vector type. 1-1 correspondence to dataframes.
#' @param plotTitle string type.
#' @param vert boolean type. True if the plot should be vertical
#' @param xlabel string type
#' @param ylabel string type
#' @param perc boolean type. True if data's axis is a percentage
#' proportion (instead of 0-1) only used if length(sampleNames) == 1
#' @param subs string type
#' @param sorted boolean type. True if bar plot should be sorted in descending
#' order
#' @param cutoff int type. Number of maximum ticks to show (x on vert plots,
#' y on hori plots).
#' @param legendPos string type. Where to position legend (see ggplot's theme())
#'
#' @return ggplot2 object
.plotDist <-
    function(dataframes,
             sampleNames,
             plotTitle,
             vert = TRUE,
             xlabel = "",
             ylabel = "",
             perc = TRUE,
             subs = "",
             sorted = TRUE,
             cutoff = 15,
             legendPos = "right") {
        frames <- length(dataframes)
        # sanity check
        if (length(sampleNames) != frames) {
            stop("Expected equal number of sample names and dataframes, got ",
                 length(sampleNames), " samples and ", frames, " dataframes.")
        }

        # If there was a cutoff, caps will display the right message,
        #  by default it's empty
        caps <- ""

        # if it was percentage, put a % sign in labels, otherwise just normal values
        if (perc) {
            placeholder <- "%0.2f%%"
        } else {
            placeholder <- "%0.2f"
        }

        # ------------  cleaning & transforming data   ----------- #
        for (i in seq_len(frames)) {
            df <- dataframes[[i]]

            # for each dataframe, append a new column 'sample'
            # to indicate where this df came from
            df$sample <- sampleNames[i]

            # sort the values by descending order (strictly speaking,
            # not necessary because it's already sorted
            # - but better be safe than sorry)
            if (sorted) {
                if (vert) {
                    dataframes[[i]] <- df[with(df, order(-y)),]
                } else {
                    dataframes[[i]] <- df[with(df, order(-x)),]
                }
            } else {
                dataframes[[i]] <- df
            }

            # canonicalize NaN, NA, and N/As to NA.
            dataframes[[i]][is.na(dataframes[[i]])] <- "NA"
            dataframes[[i]][dataframes[[i]] == "N/A"] <- "NA"
        }

        # keep a copy of the original list of dataframes without cutoff applied
        originals <- dataframes

        # make sure only the top cutoff is considered
        for (i in seq_len(frames)) {
            df <- dataframes[[i]]
            if (nrow(df) > cutoff) {
                caps <- "Cutoff at top 15"
                dataframes[[i]] <- head(df, cutoff)
            }
        }

        # --------- complete: cleaning & transforming data -------- #


        # merge dataframes into one
        df.union <- do.call("rbind", dataframes)


        # need to compensate for topN in each dataframe
        # 1. gather unique x/y
        # 2. if x/y is in original table but not in top N table,
        #    append row to df.union
        # 3. otherwise, do nothing

        if (frames > 1) {
            colName <- if (vert) 'x' else 'y'
            topN <- unique(df.union[[colName]])
            for (maybeMissing in topN) {
                for (j in seq_len(frames)) {
                    ori <- originals[[j]]
                    if (maybeMissing %in% ori[[colName]]
                        && !(maybeMissing %in% dataframes[[j]][[colName]])) {
                        newRow <- ori[ori[[colName]] == maybeMissing, ]
                        df.union <- rbind(df.union, newRow)
                    } # else, do nothing
                }
            }
        }

        if (missing(ylabel)) {
            ylabel <- "Proportion"
            if (perc) {
                ylabel <- paste(ylabel, "(%)")
            }
        }

        # start plotting --------------------------------

        # abseqPy will flip the x and y values when the plot is "horizontal"
        if (!vert) {
            colnames(df.union)[colnames(df.union) == "x"] <- "xold"
            colnames(df.union)[colnames(df.union) == "y"] <- "x"
            colnames(df.union)[colnames(df.union) == "xold"] <- "y"
        }

        if (sorted) {
            # horizontal: decreasing order from top to bottom
            # vertical: decreasing order from left to right
            coeff <- if (vert) -1 else 1
            g <- ggplot(df.union,
                        aes(x = reorder(x, y * coeff),
                            y = y,
                            label = sprintf(placeholder, y)))
        } else {
            df.union$x <- factor(df.union$x, levels = unique(df.union$x))
            g <- ggplot(df.union, aes(x, y, label = sprintf(placeholder, y)))
        }

        if (!vert) {
            g <- g + coord_flip()
        }

        if (frames == 1) {
            # only maually add fill colour and geom_text if it's a
            # single sample
            g <- g +  geom_bar(stat = 'identity',
                               fill = BLUEHEX,
                               show.legend = FALSE)
            if (vert) {
                g <- g + geom_text(vjust = -0.5, size = 3)
            } else {
                g <- g + geom_text(hjust = 0.50,
                                   vjust = -0.5,
                                   size = 3,
                                   angle = -90)
            }
        } else {
            g <- g + geom_bar(stat = 'identity', aes(fill = sample),
                              position = 'dodge')
        }

        g <- g + theme(text = element_text(size = 10),
                       legend.position = legendPos) +
            labs(
                title = plotTitle,
                subtitle = subs,
                x = xlabel,
                y = ylabel,
                caption = caps
            )
        return(g)
    }


#' Spectratype plotter
#' @description Plots length distribution
#'
#' @import ggplot2
#'
#' @param dataframes list type. List of dataframes.
#' @param sampleNames vector type. 1-1 correspondance with dataframes
#' @param region string type. Region that will be displayed in the plot title.
#' This specifies which region this spectratype belongs to. If not supplied,
#' a default (start, end) range will be displayed instead
#' @param title string type. Ignored if region is specified.
#' @param subtitle string type
#' @param xlabel string type
#' @param ylabel string type
#' @param showLabel bool type. Show geom_text? - Ignored if samples > 1
#'
#' @return ggplot2 object
.plotSpectratype <- function(dataframes,
                             sampleNames,
                             region,
                             title = "Spectratype",
                             subtitle = "",
                             xlabel = "Length(AA)",
                             ylabel = "Distribution",
                             showLabel = FALSE) {
    nsample <- length(dataframes)
    if (nsample != length(sampleNames)) {
        stop("Expected equal number of sample names and dataframes, got ",
             length(sampleNames), " samples and ", nsample, " dataframes.")
    }

    # pre-processing
    for (i in seq_len(nsample)) {
        df <- dataframes[[i]]
        df$sample <- sampleNames[i]
        df$percent <- df$count / sum(df$count)
        dataframes[[i]] <- df
    }

    # merge
    df.union <- do.call("rbind", dataframes)

    # title logic
    # if reion is not missing, it's a spectratype for FR/CDRs
    # else, it's a 'general' spectratype plot.
    # Can be reused for other length distributions E.G.: whole seq length
    subtitle <-
        paste(subtitle, paste(unlist(lapply(dataframes, function(x) {
            sum(x$count)
        })), collapse = ", "), "sequences with")
    if (!missing(region)) {
        plotTitle <- paste(region, "amino acid spectratype")
        plotSubTitle <- paste(
            subtitle ,
            "distribution of",
            region,
            "amino acid lengths",
            min(df.union$length),
            "to",
            max(df.union$length)
        )
    } else {
        plotTitle <- title
        plotSubTitle <-
            paste(subtitle,
                  "lengths",
                  min(df.union$length),
                  "to",
                  max(df.union$length))
    }
    # Always name your sample(s)!
    plotTitle <-
        paste(plotTitle, "in", paste(sampleNames, collapse = ", "))

    g <- ggplot(df.union, aes(length, percent))

    if (nsample == 1) {
        g <- g + geom_bar(
            stat = "identity",
            show.legend = FALSE,
            fill = BLUEHEX
        )
        if (showLabel) {
            g <- g + geom_text(aes(label = count),
                               vjust = -1,
                               size = 3)
        }
    } else {
        g <- g + geom_bar(stat = "identity",
                          aes(fill = sample),
                          position = "dodge")
    }
    g <- g + labs(
        title = plotTitle,
        subtitle = plotSubTitle,
        x = xlabel,
        y = ylabel
    )
    #geom_smooth(aes(colour=round), se=FALSE,
    # method="glm", formula=y~ns(x, 3), lwd=0.7)+
    #geom_text_repel(aes(label = count), size = 3) +
    #geom_text(aes(label = count), vjust=-1, size = 3) +
    return(g)
}


#' Creates a box plot
#'
#' @import ggplot2
#'
#' @param dataframes list type. List of sample dataframes
#' @param sampleNames vector type. 1-1 with dataframes
#' @param plotTitle string type
#' @param xlabel string type
#' @param ylabel string type
#' @param subs string type
#'
#' @return ggplot2 object
.boxPlot <- function(dataframes,
                     sampleNames,
                     plotTitle,
                     xlabel = "",
                     ylabel = "",
                     subs = "") {
    frames <- length(dataframes)

    if (length(sampleNames) != frames) {
        stop("Expected equal number of sample names and dataframes, got ",
             length(sampleNames), " samples and ", frames, " dataframes.")
    }

    # add samplename into new "sample" column
    dataframes <- Map(cbind, dataframes, sample = sampleNames)

    # merge
    df.union <- do.call("rbind", dataframes)

    if (frames == 1) {
        g <- ggplot(df.union,
                    aes(x = x, y = y)) +
            geom_boxplot(varwidth = TRUE, fill = BLUEHEX)
    } else {
        g <- ggplot(df.union, aes(x = sample, y = y)) +
            geom_boxplot(varwidth = TRUE, fill = BLUEHEX) +
            facet_grid( ~ x) +
            theme(axis.text.x = element_text(angle = 75, hjust = 1))
    }
    g <-
        g + labs(
            title = plotTitle,
            sutitle = subs,
            x = xlabel,
            y = ylabel
        )
    return(g)
}

#' Collect primer names from FASTA
#'
#' @param primerFile string type. Path to primer file
#'
#' @return vector of primer names as seen in primerFile
.allPrimerNames <- function(primerFile) {
    primers <- c()
    fp = file(primerFile, open = "r")
    while (TRUE) {
        line = readLines(fp, n = 1)
        if (!length(line)) {
            break
        }
        if (startsWith(line, ">")) {
            primers <- c(primers, gsub("^>\\s*", "", line))
        }
    }
    close(fp)
    return(primers)
}

#' Convert file names to human friendly text
#'
#' @include util.R
#'
#' @param str string type
#'
#' @return string
.canonicalizeTitle <- function(str) {
    if (str == "outframe") {
        return("Out-of-frame")
    } else if (str == "indel_pos") {
        return("Abundance of Indel Positions in")
    } else if (str == "indelled") {
        return("Abundance of Indelled")
    } else {
        return(.capitalize(str))
    }
}

#' Collect the intersection of all primer names within a collection
#' of primer files
#'
#' @param primerFiles list / vector type. Collection of primer files
#'
#' @return vector type. Vector of primerNames that are present in ALL
#' primerFiles. NULL if there's no intersection at all
.commonPrimerNames <- function(primerFiles) {
    unionPrimers <- lapply(primerFiles, function(f) {
        if (file.exists(f)) {
            return(.allPrimerNames(f))
        } else {
            return(c())
        }
    })
    return(Reduce(intersect, unionPrimers))
}


#' Conducts primer specificity analysis
#'
#' @include util.R
#' @include distributions.R
#' @import ggplot2
#'
#' @param primerDirectories string type. Path to primer analysis directory
#' @param primer5Files vector / list type. 5' end primer files
#' @param primer3Files vector / list type. 3' end primer files
#' @param primerOut string type. output directory
#' @param sampleNames vector type. 1-1 with primerDirectories
#' @param combinedNames string type. Title friendly "combined" sample names
#' @param mashedNames string type. File friendly "mashed-up" sample names
#' @param .save logical type. Save Rdata?
#'
#' @return None
.primerAnalysis <- function(primerDirectories,
                            primer5Files,
                            primer3Files,
                            primerOut,
                            sampleNames,
                            combinedNames,
                            mashedNames,
                            .save = TRUE) {

    message("Starting primer analysis for ", combinedNames)

    primer5 <- .commonPrimerNames(primer5Files)
    primer3 <- .commonPrimerNames(primer3Files)

    allPrimers <- Filter(function(x) !is.null(x),
                         list("5" = primer5, "3" = primer3))

    category <- c("all", "productive", "outframe")
    primerIntegrityTypes <- c("stopcodon", "integrity", "indelled", "indel_pos")

    # all primer plots are repeated for productive and out-of-frame sequences
    lapply(category, function(ctg) {
        # each primer analysis is split to 5' and 3' ends (if exists)
        lapply(seq_along(allPrimers), function(i) {
            # get vector of primer names
            primerNames <- allPrimers[[i]]
            pend <- names(allPrimers)[[i]]
            message("Primers found across all samples ",
                   combinedNames,
                   " for ",
                   pend,
                    "'",
                   " end are: ",
                   paste(primerNames, collapse = ", "))

            lapply(X = primerNames, FUN = .plotPrimerIGVStatus, pend, ctg,
                   primerDirectories, sampleNames,
                   primerOut, combinedNames, mashedNames, .save)

            lapply(X = primerIntegrityTypes, FUN = .plotPrimerIntegrity, pend,
                   ctg, primerDirectories, sampleNames,
                   primerOut, combinedNames, mashedNames, .save)
        })
    })
}

#' Plots, for a given \code{category} and \code{pend}, the \code{primer}
#' IGV indelled distribution in a bar plot
#'
#' @description Plots the abundace of indelled primers relative to IGV germlines
#'
#' @include util.R
#' @include distributions.R
#' @import ggplot2
#'
#' @param primer string, primer name
#' @param pend string, either 3 or 5 (primer end)
#' @param category string, either "all", "productive", or "outframe"
#' @param primerDirectories string type. Path to primer analysis directory
#' @param sampleNames vector type. 1-1 with primerDirectories
#' @param primerOut string type. output directory
#' @param combinedNames string type. Title friendly "combined" sample names
#' @param mashedNames string type. File friendly "mashed-up" sample names
#' @param .save logical type. Save Rdata?
#'
#' @return None
.plotPrimerIGVStatus <- function(primer, pend, category,
                                 primerDirectories, sampleNames,
                                 primerOut, combinedNames, mashedNames,
                                 .save = TRUE) {
    files <-
        .listFilesInOrder(path = primerDirectories,
                          pattern = paste0( ".*_", category, "_",
                                      pend, "end_", primer,
                                      "_igv_dist\\.csv(\\.gz)?$"))
    # there is a slight chance that the user provided primer
    # has no hit, hence, not dist files
    # (AbSEq (obviously) doesn't plot something empty)
    if (length(files) == 0) {
        # nothing left to do
        return()
    }
    subtitle <- paste("Total is",
                      paste(lapply(files, function(x) {
                          as.integer(.getTotal(x))
                      }), collapse = ', '))
    vertical <- .checkVert(files[[1]])
    if (vertical) {
        plotWidth <- V_WIDTH
        plotHeight <- V_HEIGHT
    } else {
        plotWidth <- H_WIDTH
        plotHeight <- H_HEIGHT
    }
    primPlot <- .plotDist(lapply(files, read.csv, skip = 1),
                          sampleNames,
                          paste(paste0(
                              "IGV Abundance of indelled ",
                              primer, " (",
                              .canonicalizeTitle(category), ") in "),
                              combinedNames ),
                          vertical,
                          subs = subtitle)
    saveName <-
        file.path(primerOut, paste0(mashedNames, "_", category, "_",
                                    pend, "end_", primer, "_igv_dist.png"))
    ggsave(saveName, plot = primPlot, width = plotWidth, height = plotHeight)
    .saveAs(.save, saveName, plot = primPlot)
}

#' Plots the distribution of primer integrity for a given \code{category} and
#' 5' or 3' \code{pend}
#'
#' @include util.R
#' @include distributions.R
#' @import ggplot2
#'
#' @param primerIntegrity string. One of "stopcodon", "integrity",
#' "indelled", "indel_pos"
#' @param pend string, either 3 or 5 (primer end)
#' @param category string, either "all", "productive", or "outframe"
#' @param primerDirectories string type. Path to primer analysis directory
#' @param sampleNames vector type. 1-1 with primerDirectories
#' @param primerOut string type. output directory
#' @param combinedNames string type. Title friendly "combined" sample names
#' @param mashedNames string type. File friendly "mashed-up" sample names
#' @param .save logical type. Save Rdata?
#'
#' @return None
.plotPrimerIntegrity <- function(primerIntegrity, pend, category,
                                 primerDirectories, sampleNames, primerOut,
                                 combinedNames, mashedNames, .save = TRUE) {
    files <-
        .listFilesInOrder(path = primerDirectories,
                          pattern = paste0( ".*_", category, "_",
                                            pend, "end_",
                                            primerIntegrity,
                                            "_dist\\.csv(\\.gz)?$"))
    # there is a slight chance that the user provided
    # primer has no hit, hence, not dist files
    # (AbSEq (obviously) doesn't plot something empty)
    if (length(files) == 0) {
        # nothing left to do
        return()
    }

    subtitle <- paste("Total is",
                      paste(lapply(files, function(x) {
                          as.integer(.getTotal(x))
                      }), collapse = ', '))

    vertical <- .checkVert(files[[1]])
    if (vertical) {
        plotWidth <- V_WIDTH
        plotHeight <- V_HEIGHT
    } else {
        plotWidth <- H_WIDTH
        plotHeight <- H_HEIGHT
    }

    primPlot <- .plotDist(lapply(files, read.csv, skip = 1),
                          sampleNames,
                          paste(paste0(
                              .canonicalizeTitle(primerIntegrity),
                              " ", pend,
                              "'-end Primer Sequence (",
                              .canonicalizeTitle(category),
                              ") in" ),
                              combinedNames ),
                          vertical,
                          subs = subtitle)
    saveName <- file.path(primerOut,
                          paste0(mashedNames, "_", category, "_", pend,
                                 "end_", primerIntegrity, "_dist.png"))
    ggsave(saveName, plot = primPlot, width = plotWidth, height = plotHeight)
    .saveAs(.save, saveName, plot = primPlot)
}

#' Summary of productivity
#'
#' @description Shows the percentage of 1. productivity, 2. non-functional +
#' reason for being unproductive,
#' i.e. "Stop Codon" or "Out of frame" or "Stop & Out"
#'
#' @import ggplot2
#'
#' @param dataframes list type. List of sample dataframes
#' @param sampleNames vector type. 1-1 with dataframes
#'
#' @return ggplot2 object
.productivityPlot <- function(dataframes, sampleNames) {
    nsamples <- length(dataframes)
    if (length(sampleNames) != nsamples) {
        stop("Expected equal number of sample names and dataframes, got ",
             length(sampleNames),
             " samples and ", nsamples, " dataframes.")
    }

    message("Plotting productivity summary plot for ",
            paste(sampleNames, collapse = ", "))

    #   ---- clean & pre-processing ----
    unusedCols <- c("X")
    # label each row with sample name and drop unused columns
    for (i in seq_len(nsamples)) {
        df <- dataframes[[i]]
        df$sample <- sampleNames[i]
        df[df == "Both"] <- "Stop & Out"
        dataframes[[i]] <- df[, !(names(df) %in% unusedCols)]
    }
    #   ---- done: clean & pre-processing ----

    # merge all samples
    df.union <- do.call("rbind", dataframes)

    # plot!
    g <- ggplot(df.union, aes(sample, Percentage)) +
        geom_bar(stat = "identity", aes(fill = Reason), width = 0.5) +
        facet_wrap(~Productivity) +
        labs(
            title = "Productivity proportions",
            subtitle = "Percentage of unproductive reads due to stop codons and frameshifts",
            y = "Percentage (%)"
        ) +
        coord_cartesian(ylim = c(0, 100)) +
        geom_text(position = position_stack(vjust = 0.5),
                  aes(label = sprintf("%0.2f%%", Percentage),
                      group = Reason)) +
        theme(axis.text.x = element_text(angle = 55, hjust = 1),
              legend.title = element_blank(), axis.title.x = element_blank())
    return(g)
}

#' Plots a distribution plot for different productivity analysis files
#'
#' @description A wrapper for plotDist
#'
#' @include util.R
#' @include distributions.R
#' @import ggplot2
#'
#' @param productivityDirectories vector type.
#' directories where all productivity csv
#' files lives (usually <samplename>/productivity/)
#' @param sampleNames vector type.
#' @param title string type.
#' @param reg string type. Regular expression to find the right files
#' for this particular distribution plot
#' @param outputFileName string type.
#' Vector of file names to save in the order of \code{regions}
#' @param region string type. Most of the dist plots are
#' regional based. use "" if no regions are involved
#' @param .save logical type. Save Rdata?
#'
#' @return None
.prodDistPlot <-
    function(productivityDirectories,
             sampleNames, title, reg, outputFileName,
             region, .save = TRUE) {
    fs <- .listFilesInOrder(path = productivityDirectories,
                            pattern = paste0(".*", region, reg))
    if (length(fs)) {
        dataframes <- lapply(fs, read.csv,
                             stringsAsFactors = FALSE, skip = 1)
        plotTitle <- paste(title, toupper(region), "in",
                           paste(sampleNames, collapse = ", "))
        subtitle <-
            paste("Total is" , paste(lapply(fs, function(x) {
                as.integer(.getTotal(x))
            }), collapse = ", "))
        g <- .plotDist(dataframes,
                       sampleNames,
                       plotTitle,
                       .checkVert(fs[[1]]),
                       subs = subtitle)
        ggsave(outputFileName, plot = g, width = V_WIDTH, height = V_HEIGHT)
        .saveAs(.save, outputFileName, g)
    }
}

#' Plots the error distribution for each region: CDRs, FRs, IGV, IGD, and IGJ
#'
#' @description Plots the distribution of indels (gaps), indels in
#' out-of-frame sequences, and the distribution of mismatches for CDRs,
#' FRs, IGV, IGD, and IGJ.
#'
#' @include util.R
#' @include distributions.R
#' @import ggplot2
#'
#' @param productivityDirectories list type. List of directories
#' @param prodOut string type. Output directory
#' @param sampleNames vector type. 1-1 with productivity directories
#' @param combinedNames string type. Title friendly "combined" sample names
#' @param mashedNames string type. File friendly "mashed-up" sample names
#' @param .save logical type. Save Rdata?
#'
#' @return None
.plotErrorDist <- function(productivityDirectories, prodOut,
                           sampleNames, combinedNames,
                           mashedNames, .save = TRUE) {
    regions <-
        c("cdr1", "cdr2", "cdr3", "fr1", "fr2", "fr3", "igv", "igd", "igj")

    # gaps_dist plots only ---------------------------------------------------
    message("Plotting indel distributions for ", combinedNames)
    lapply(regions, function(region) {
        .prodDistPlot(
            productivityDirectories,
            sampleNames,
            "Gaps in",
            "_gaps_dist\\.csv(\\.gz)?$",
            file.path(prodOut, paste0(mashedNames, "_",
                                      region,
                                      "_gaps_dist.png")),
            region, .save = .save)
    })

    # gaps_out_of_frame plots only (no igv, igd, ihj plots for this) ---------
    subregions <- head(regions, n = 6)
    message("Plotting indel out of frame distributions for ", combinedNames)

    lapply(subregions, function(region) {
        .prodDistPlot(
            productivityDirectories,
            sampleNames,
            "Gaps in",
            "_gaps_dist_out_of_frame\\.csv(\\.gz)?$",
            file.path(prodOut, paste0(mashedNames, "_", region,
                                      "_gaps_dist_out_of_frame.png")),
            region, .save = .save)
    })

    # mismatch dist only -----------------------------------------------------
    message("Plotting mismatches distributions for ", combinedNames)
    lapply(regions, function(region) {
        .prodDistPlot(
            productivityDirectories,
            sampleNames,
            "Mismatches in",
            "_mismatches_dist\\.csv(\\.gz)?$",
            file.path(prodOut, paste0(mashedNames,
                                      "_", region, "_mismatches_dist.png")),
            region, .save = .save)
    })
}


#' Plots the error distribution for IGV germlines
#'
#' @description Plots the distribution of in-frame unproductive,
#' out-of-frame unproductive, and productive IGV germlines.
#'
#' @include util.R
#' @include distributions.R
#' @import ggplot2
#'
#' @param productivityDirectories list type. List of directories
#' @param prodOut string type. Output directory
#' @param sampleNames vector type. 1-1 with productivity directories
#' @param combinedNames string type. Title friendly "combined" sample names
#' @param mashedNames string type. File friendly "mashed-up" sample names
#' @param .save logical type, save Rdata?
#'
#' @return None
.plotIGVErrors <- function(productivityDirectories, prodOut, sampleNames,
                           combinedNames, mashedNames, .save = TRUE) {
    # in frame unprod ----------
    message("Plotting inframe unproductive distributions for ", combinedNames)

    .prodDistPlot(
        productivityDirectories,
        sampleNames,
        "Abundance of In-frame Unproductive Clones in",
        "_dist_inframe_unproductive\\.csv(\\.gz)?$",
        file.path(prodOut, paste0(mashedNames,
                                  "_igv_dist_inframe_unproductive.png")),
        "igv", .save = .save)

    # out of frame unprod --------
    message("Plotting out of frame clones distributions for ", combinedNames)
    .prodDistPlot(
        productivityDirectories,
        sampleNames,
        "Abundance of Out-Of-Frame Clones in",
        "_dist_out_of_frame\\.csv(\\.gz)?$",
        file.path(prodOut, paste0(mashedNames, "_igv_dist_out_of_frame.png")),
        "igv", .save = .save)

    # productive ----------------
    message("Plotting out IGV productive distributions for ", combinedNames)
    .prodDistPlot(
        productivityDirectories,
        sampleNames,
        "Abundance of Productive Clones in",
        "_dist_productive\\.csv(\\.gz)?$",
        file.path(prodOut, paste0(mashedNames, "_igv_dist_productive.png")),
        "igv", .save = .save)
}


#' Conducts productivty analysis
#'
#' @include util.R
#' @include distributions.R
#' @import ggplot2
#'
#' @param productivityDirectories list type. List of directories
#' @param prodOut string type. Output directory
#' @param sampleNames vector type. 1-1 with productivity directories
#' @param combinedNames string type. Title friendly "combined" sample names
#' @param mashedNames string type. File friendly "mashed-up" sample names
#' @param .save logical type. Save Rdata
#'
#' @return None
.productivityAnalysis <- function(productivityDirectories,
                                  prodOut,
                                  sampleNames,
                                  combinedNames,
                                  mashedNames,
                                  .save = TRUE) {
    message("Commencing productivity analysis")

    # summary productivity file
    prodFiles <- .listFilesInOrder(path = productivityDirectories,
                                   pattern = ".*_productivity\\.csv(\\.gz)?$")


    if (length(prodFiles)) {
        g <- .productivityPlot(lapply(prodFiles, read.csv,
                                      stringsAsFactors = FALSE),
                               sampleNames)
        saveName <- file.path(prodOut, paste0(mashedNames, "_productivity.png"))
        ggsave(saveName, plot = g, width = V_WIDTH, height = V_HEIGHT)
        .saveAs(.save, saveName, g)
    }

    # plot the distribution of indels and mismatches -------------------------
    .plotErrorDist(productivityDirectories, prodOut,
                   sampleNames, combinedNames, mashedNames, .save = .save)

    # stop codon dist plot ---------------------------------------------------
    message("Plotting stop codon in-frame distributions for ", combinedNames)
    .prodDistPlot(
        productivityDirectories,
        sampleNames,
        "Stop codon in In-frame Clones",
        "_stopcodon_dist_in_frame\\.csv(\\.gz)?$",
        file.path(prodOut, paste0(mashedNames, "_stopcodon_dist_in_frame.png")),
        "", .save = .save) # no regions

    # vjframe plot -----------------------------------------------------------
    message("Plotting vjframe distributions for ", combinedNames)
    .prodDistPlot(
        productivityDirectories,
        sampleNames,
        "V-D-J Rearrangement",
        "_vjframe_dist\\.csv(\\.gz)?$",
        file.path(prodOut, paste0(mashedNames, "_vjframe_dist.png")),
        "", .save = .save) # no regions

    # 3 special cases for IGV region -----------------------------------------
    # igv - inframe_unproductive, out of frame, productive
    .plotIGVErrors(productivityDirectories, prodOut,
                   sampleNames, combinedNames, mashedNames, .save = .save)


    # stop codon in FR/CDR region proportion plot ----------------------------
    message("Plotting stop codon region distributions for ", combinedNames)
    lapply(c("inframe", "outframe"), function(framestat) {
        stopCodonRegionFiles <-
            .listFilesInOrder(
                path = productivityDirectories,
                pattern = paste0(".*_stopcodon_region_",
                                 framestat, "\\.csv(\\.gz)?$")
            )
        if (length(stopCodonRegionFiles)) {
            vert = .checkVert(stopCodonRegionFiles[[1]])
            subtitle <- paste("Total is",
                              paste(
                                  lapply(stopCodonRegionFiles, function(x) {
                                      as.integer(.getTotal(x))
                                  }),
                                  collapse = ", "
                              ))

            stopcodonRegion <- .plotDist(
                lapply(stopCodonRegionFiles, read.csv, skip = 1),
                sampleNames,
                paste("Stop codon in FRs and CDRs of",
                      if (framestat == "inframe") "In-frame" else "Out-of-frame",
                      "sequences in",
                      combinedNames),
                vert,
                subs = subtitle,
                sorted = FALSE)
            saveName <- file.path(prodOut, paste0(mashedNames,
                                                  "_stopcodon_region_",
                                                  framestat, ".png"))
            if (vert) {
                ggsave(saveName, plot = stopcodonRegion,
                       width = V_WIDTH, height = V_HEIGHT)
            } else {
                ggsave(saveName, plot = stopcodonRegion,
                       width = H_WIDTH, height = H_HEIGHT)
            }
            .saveAs(.save, saveName, stopcodonRegion)
        } else {
            warning("Could not find stop codon region distribution plot ",
                    "for samples ", combinedNames)
        }
    })
}

#' Monolith AbSeq Plot function - the "driver" program
#'
#' @include abundanceAnalysis.R
#' @include annotationAnalysis.R
#' @include distributions.R
#' @include diversityAnalysis.R
#' @include primerAnalysis.R
#' @include productivityAnalysis.R
#' @include upstreamAnalysis.R
#' @include util.R
#'
#' @import ggplot2
#'
#'
#' @param sampleNames vector type. Vector of sample names in strings
#' @param directories vector type. Vector of directories in strings, must be
#' 1-1 with sampleNames
#' @param analysis vector / list type. What analysis to plot for. If sampleNames
#' or directories is > 1 (i.e. AbSeqCRep), then make sure that it's
#' an intersection of all analysis conducted by the repertoires, otherwise, it
#' wouldn't make sense
#' @param outputDir string type. Where to dump the output
#' @param primer5Files vector / list type. Collection of strings that the sample
#' used for primer5 analysis. If sample N doesn't have a primer 5 file,
#' leave it as anthing but a valid file path.
#' @param primer3Files vector / list type. Collection of strings that the sample
#' used for primer 3 analysis. If sample N doesn't have a primer 3 file,
#' leave it as anthing but a valid file path.
#' @param upstreamRanges list type. Collection of "None"s or vector
#' denoting upstreamStart and upstreamEnd for each sample.
#' @param skipDgene logical type. Whether or not to skip D gene distribution plot
#'
#' @return none
.plotSamples <-
    function(sampleNames,
             directories,
             analysis,
             outputDir,
             primer5Files,
             primer3Files,
             upstreamRanges,
             skipDgene = FALSE) {
        if (!dir.exists(outputDir)) {
            dir.create(outputDir)
        }
        # mashedNames are "file-system" friendly names, we collapse them
        # with an underscore (from here on out, all plot names will be
        # <mashedNames>_<...>.png)
        mashedNames <- paste(sampleNames, collapse = "_")

        # combinedNames are "human" friendly names, we combine them with
        # commas (from here on out, plot titles will be
        # "<combinedNames> <...>")
        combinedNames <- paste(sampleNames, collapse = ", ")

        ##################################################
        #                                                #
        #               ANNOTATION PLOTS                 #
        #                                                #
        ##################################################
        if (ABSEQ_DIR_ANNOT %in% analysis) {
            annotOut <- file.path(outputDir, ABSEQ_DIR_ANNOT)
            if (!file.exists(annotOut)) {
                dir.create(annotOut)
            }
            annotDirectories <-
                vapply(directories, file.path, ABSEQ_DIR_ANNOT,
                       USE.NAMES = FALSE, FUN.VALUE = "")
            .annotAnalysis(annotDirectories, annotOut, sampleNames, mashedNames)
        }

        ##################################################
        #                                                #
        #               ABUNDANCE PLOTS                  #
        #                                                #
        ##################################################
        if (ABSEQ_DIR_ABUN %in% analysis) {
            abunOut <- file.path(outputDir, ABSEQ_DIR_ABUN)
            if (!file.exists(abunOut)) {
                dir.create(abunOut)
            }
            abundanceDirectories <-
                vapply(directories, file.path, ABSEQ_DIR_ABUN,
                       USE.NAMES = FALSE, FUN.VALUE = "")
            .abundanceAnalysis(
                abundanceDirectories,
                abunOut,
                sampleNames,
                combinedNames,
                mashedNames,
                skipDgene = skipDgene
            )
        }

        ##################################################
        #                                                #
        #              PRODUCTIVITY PLOTS                #
        #                                                #
        ##################################################
        if (ABSEQ_DIR_PROD %in% analysis) {
            prodOut <- file.path(outputDir, ABSEQ_DIR_PROD)
            if (!file.exists(prodOut)) {
                dir.create(prodOut)
            }
            productivityDirectories <-
                vapply(directories, file.path,
                       ABSEQ_DIR_PROD, USE.NAMES = FALSE, FUN.VALUE = "")
            .productivityAnalysis(productivityDirectories,
                                  prodOut,
                                  sampleNames,
                                  combinedNames,
                                  mashedNames)
        }

        ##################################################
        #                                                #
        #               DIVERSITY PLOTS                  #
        #                                                #
        ##################################################
        if (ABSEQ_DIR_DIV %in% analysis) {
            diversityOut <- file.path(outputDir, ABSEQ_DIR_DIV)
            if (!file.exists(diversityOut)) {
                dir.create(diversityOut)
            }
            diversityDirectories <-
                vapply(directories, file.path,
                       ABSEQ_DIR_DIV, USE.NAMES = FALSE, FUN.VALUE = "")
            .diversityAnalysis(diversityDirectories,
                               diversityOut,
                               sampleNames,
                               mashedNames)
        }

        ##################################################
        #                                                #
        #               CLONOTYPE PLOTS                  #
        #                                                #
        ##################################################
        # pairwise clonotype comparison analyses only occurs when there's
        # > 1 sample
        if (length(sampleNames) > 1 &&
            ABSEQ_DIR_DIV %in% analysis) {
            pairwiseOut <- file.path(outputDir, ABSEQ_DIR_PAIR)
            if (!file.exists(pairwiseOut)) {
                dir.create(pairwiseOut)
            }
            diversityDirectories <- vapply(directories, file.path,
                                           ABSEQ_DIR_DIV, USE.NAMES = FALSE,
                                           FUN.VALUE = "")
            .clonotypeAnalysis(diversityDirectories,
                               pairwiseOut,
                               sampleNames,
                               mashedNames)
        }

        ##################################################
        #                                                #
        #               PRIMER.S  PLOTS                  #
        #                                                #
        ##################################################
        if (ABSEQ_DIR_PRIM %in% analysis) {
            primerOut <- file.path(outputDir, ABSEQ_DIR_PRIM)
            if (!file.exists(primerOut)) {
                dir.create(primerOut)
            }
            primerDirectories <- vapply(directories,
                                        file.path,
                                        ABSEQ_DIR_PRIM,
                                        USE.NAMES = FALSE,
                                        FUN.VALUE = "")
            .primerAnalysis(
                primerDirectories,
                primer5Files,
                primer3Files,
                primerOut,
                sampleNames,
                combinedNames,
                mashedNames
            )
        }

        ##################################################
        #                                                #
        #               UPSTREAM 5UTR PLOTS              #
        #                                                #
        ##################################################
        if (ABSEQ_DIR_5UTR %in% analysis) {
            utr5Out <- file.path(outputDir, ABSEQ_DIR_5UTR)
            if (!file.exists(utr5Out)) {
                dir.create(utr5Out)
            }
            utr5Directories <-
                vapply(directories, file.path, ABSEQ_DIR_5UTR,
                       USE.NAMES = FALSE, FUN.VALUE = "")
            .UTR5Analysis(
                utr5Directories,
                utr5Out,
                sampleNames,
                combinedNames,
                mashedNames,
                upstreamRanges
            )
        }

        ##################################################
        #                                                #
        #               UPSTREAM SEC.S PLOTS             #
        #                                                #
        ##################################################
        if (ABSEQ_DIR_SEC %in% analysis) {
            secOut <- file.path(outputDir, ABSEQ_DIR_SEC)
            if (!file.exists(secOut)) {
                dir.create(secOut)
            }
            secDirectories <-
                vapply(directories, file.path, ABSEQ_DIR_SEC,
                       USE.NAMES = FALSE, FUN.VALUE = "")
            .secretionSignalAnalysis(
                secDirectories,
                secOut,
                sampleNames,
                combinedNames,
                mashedNames,
                upstreamRanges
            )
        }
    }

#' Accessor for the \code{name} slot
#'
#' @param object AbSeqRep object
#'
#' @return character type, the sample name of this object.
.asRepertoireName <- function(object) {
    object@name
}


#' Accessor for the \code{outdir} slot
#'
#' @param object AbSeqRep object
#'
#' @return character type, the output directory of this object
.asRepertoireDir <- function(object) {
    object@outdir
}


#' Accessor for \linkS4class{AbSeqCRep}'s list of \linkS4class{AbSeqRep} objects
#'
#' @param object AbSeqCRep object
#'
#' @return list type, list of \linkS4class{AbSeqRep} objects that together,
#' compose this \linkS4class{AbSeqCRep} object.
.asRepertoireList <- function(object) {
    object@repertoires
}


#' Accessor for \code{chain} slot
#'
#' @param object AbSeqRep object
#'
#' @return character type, the chain type of this sample
.asRepertoireChain <- function(object) {
    object@chain
}


#' Accessor for \code{bitscore} slot
#'
#' @param object AbSeqRep object
#' @param collapse character type, collapse the range using this string.
#'
#' @return character type. If collapse is a string, then the ranges are represented
#' as `start - end` in a string, if collapse is NULL,
#' returns a character vector of length
#' two, denoting the start and end value respectively.
.asRepertoireBitscore <- function(object, collapse = " - ") {
    if (is.null(collapse)) {
        return(object@bitscore)
    }
    return(paste(object@bitscore, collapse = collapse))
}


#' Accessor for \code{qstart} slot
#'
#' @param object AbSeqRep object
#' @param collapse character type, collapse the range using this string.
#'
#' @return character type. If collapse is a string, then the ranges
#' are represented as `start - end` in a string, if collapse is NULL,
#' returns a character vector of length
#' two, denoting the start and end value respectively.
.asRepertoireQueryStart <- function(object, collapse = " - ") {
    if (is.null(collapse)) {
        return(object@qstart)
    }
    return(paste(object@qstart, collapse = collapse))
}


#' Accessor for \code{alignlen} slot
#'
#' @param object AbSeqRep object
#' @param collapse character type, collapse the range using this string.
#'
#' @return character type. If collapse is a string, then the ranges
#' are represented as `start - end` in a string, if collapse is NULL,
#' returns a character vector of length
#' two, denoting the start and end value respectively.
.asRepertoireAlignLen <- function(object, collapse = " - ") {
    if (is.null(collapse)) {
        return(object@alignlen)
    }
    return(paste(object@alignlen, collapse = collapse))
}


#' Accessor for \code{sstart} slot
#'
#' @param object AbSeqRep object
#' @param collapse character type, collapse the range using this string.
#'
#' @return character type. If collapse is a string, then the ranges
#' are represented as `start - end` in a string, if collapse is NULL,
#' returns a character vector of length
#' two, denoting the start and end value respectively.
.asRepertoireSubjectStart <- function(object, collapse = " - ") {
    if (is.null(collapse)) {
        return(object@sstart)
    }
    return(paste(object@sstart, collapse = collapse))
}


#' Accessor for the \code{primer5end} slot
#'
#' @param object AbSeqRep object
#'
#' @return character type, the FASTA file name for primer 5' end sequences
.asRepertoirePrimer5 <- function(object) {
    object@primer5end
}

#' Accessor for the \code{primer3end} slot
#'
#' @param object AbSeqRep object
#'
#' @return character type, the FASTA file name for primer 3' end sequences
.asRepertoirePrimer3 <- function(object) {
    object@primer3end
}

#' Accessor for the \code{upstream} slot
#'
#' @param object AbSeqRep object
#'
#' @return character type
.asRepertoireUpstream <- function(object) {
    object@upstream
}

context("AbSeqCRep S4 class")

## Wed Oct 24 12:08:01 AEDT 2018
## This test file will test
##      1. abseqReport
##      2. The instantiation of AbSeqCRep using the "+" operator

# Load example data -- ex -------------------------------------------------
tmpdir <- tempdir()
exdata <- system.file("extdata", "ex", package = "abseqR")
file.copy(exdata, tmpdir, recursive = TRUE)
ex <- file.path(tmpdir, "ex")


# Test S4 class -----------------------------------------------------------
test_that("AbSeqCRep is correctly instantiated", {
    samples <- abseqReport(ex, report = 0)
    expect_length(samples, 3)
    expect_named(samples,
                 c("PCR1", "PCR2", "PCR3"),
                 ignore.order = FALSE,
                 ignore.case = FALSE)
    csamples <- Reduce("+", samples)
    expect_true(isS4(csamples))
    expect_equal(class(csamples)[[1]], "AbSeqCRep")
})

test_that("AbSeqCRep is correctly instantiated when 3 samples are combined", {
    samples <- abseqReport(ex, report = 0)
    expect_length(samples, 3)
    expect_named(samples,
                 c("PCR1", "PCR2", "PCR3"),
                 ignore.order = FALSE,
                 ignore.case = FALSE)
    csamples <- Reduce("+", samples)
    expect_length(.asRepertoireList(csamples), 3)
})

test_that("AbSeqCRep is correctly instantiated during partial addition", {
    samples <- abseqReport(ex, report = 0)
    expect_length(samples, 3)
    pcr1_pcr2 <- samples[["PCR1"]] + samples[["PCR3"]]
    expect_length(.asRepertoireList(pcr1_pcr2), 2)
    expect_equal(
        unlist(lapply(.asRepertoireList(pcr1_pcr2), .asRepertoireName)),
        c("PCR1", "PCR3"),
        ignore.order = FALSE,
        ignore.case = FALSE)
})

#' Plot upstream distribution
#'
#' @include util.R
#' @include distributions.R
#'
#' @import ggplot2
#'
#' @param upstreamDirectories list type. List of sample directories
#' @param upstreamOut string type. Output directory
#' @param expectedLength int type. Expected length of upstream sequences.
#' (i.e. upstream_end - upstream_start + 1).
#' @param upstreamLengthRange string type. start_end format
#' @param sampleNames vector type. 1-1 with upstream directories
#' @param combinedNames string type. Title friendly "combined" sample names
#' @param mashedNames string type. File friendly "mashed-up" sample names
#' @param .save logical type. Save Rdata?
#'
#' @return None
.plotUpstreamLength <-
    function(upstreamDirectories, upstreamOut, expectedLength,
             upstreamLengthRange, sampleNames,
             combinedNames, mashedNames, .save = TRUE) {
        message("Plotting upstream distributions for ", combinedNames)

        # full lengthed upstream sequences and upstream seqs
        # that are shorter than the expected length
        if (!is.infinite(expectedLength)) {
            lengths <- c("", "_short")
        } else {
            # Expected length is Inf
            lengths <- c("")
        }

        lapply(lengths, function(lengthType) {
            .plotUpstreamLengthDist(upstreamDirectories, upstreamOut,
                                    upstreamLengthRange, lengthType,
                                    sampleNames, combinedNames,
                                    mashedNames, .save = .save)

            .plotIGVUpstreamLenDist(upstreamDirectories, upstreamOut,
                                    upstreamLengthRange, lengthType,
                                    sampleNames, combinedNames,
                                    mashedNames, .save = .save)

            .plotIGVUpstreamLenDistDetailed(upstreamDirectories, upstreamOut,
                                            upstreamLengthRange, lengthType,
                                            sampleNames, combinedNames,
                                            mashedNames, .save = .save)
        })
}


#' Plots the validity of upstream sequences
#'
#' @description Plots the distribution of valid, faulty, and missing start
#' codon in IGV germlines (repeated for gene and family levels).
#'
#' @include util.R
#' @include distributions.R
#' @import ggplot2
#'
#' @param upstreamDirectories list type. List of sample directories
#' @param upstreamOut string type. Output directory
#' @param expectedLength int type. Expected length of upstream sequences.
#' (i.e. upstream_end - upstream_start + 1). If this is infinite, no plots
#' will be generated.
#' @param upstreamLengthRange string type. start_end format
#' @param sampleNames vector type. 1-1 with upstream directories
#' @param combinedNames string type. Title friendly "combined" sample names
#' @param mashedNames string type. File friendly "mashed-up" sample names
#' @param .save logical type. Save Rdata?
#'
#' @return None
.analyzeUpstreamValidity <- function(upstreamDirectories, upstreamOut,
                                     expectedLength, upstreamLengthRange,
                                     sampleNames, combinedNames, mashedNames,
                                     .save = TRUE) {

    message("Starting upstream analysis on ", combinedNames)

    if (!is.infinite(expectedLength)) {
        lapply(c("gene", "family"), function(lvl) {
            lapply(c("valid", "faulty", "no_atg"), function(status) {
                requestedFiles <-
                    .listFilesInOrder(path = upstreamDirectories,
                                      pattern = paste0( ".*_(secsig|5utr)_",
                                                        upstreamLengthRange,
                                                        "_", status, "_", lvl,
                                                        '\\.csv(\\.gz)?$'))
                if (length(requestedFiles)) {
                    fname <-  if (grepl("secsig", requestedFiles[[1]])) {
                        "secsig"
                    } else {
                        stopifnot(grepl("5utr", requestedFiles[[1]]))
                        "5utr"
                    }
                    if (status == "valid") {
                        if (fname == "secsig") {
                            title <- "Valid Secretion Signals"
                        } else {
                            title <- "Valid 5'-UTRs"
                        }
                    } else if (status == 'faulty') {
                        title <- "Faulty Translations"
                    } else {
                        title <- "Upstream sequences without start codon"
                    }

                    subtitle <- paste("Total is ",
                                      paste(lapply(requestedFiles, function(x) {
                                          as.integer(.getTotal(x))
                                      }), collapse = ", "))

                    plotVert <- .checkVert(requestedFiles[[1]])
                    g <- .plotDist(lapply(requestedFiles, read.csv, skip = 1),
                                   sampleNames, title, vert = plotVert,
                                   subs = subtitle)
                    if (plotVert) {
                        width <- V_WIDTH
                        height <- V_HEIGHT
                    } else {
                        width <- H_WIDTH
                        height <- H_WIDTH
                    }
                    saveName <-
                        file.path(upstreamOut,
                                  paste0(mashedNames, "_", fname, "_",
                                         upstreamLengthRange, "_", status, "_",
                                         lvl, ".png"))

                    ggsave(saveName, plot = g, width = width, height = height)
                    .saveAs(.save, saveName, plot = g)
                } else {
                    warning("Could not find ",
                            status,
                            " distribution for ",
                            lvl,
                            " for ",
                            combinedNames)
                }
            })
        })
    }
}


#' 5' UTR analysis
#'
#' @description Generates all the required plots for 5' UTR analysis. This
#' includes upstream length distributions and upstream sequence validity.
#'
#' @param utr5Directories list type. 5UTR directories where files are located
#' @param utr5Out string type. Where to dump output
#' @param sampleNames vector type. 1-1 with utr5Directories
#' @param combinedNames string type. Title friendly string
#' @param mashedNames string type. File name friendly string
#' @param upstreamRanges list type. Upstream ranges for each sample.
#' If length(utr5Directories) > 1, the plots will only be generated for
#' upstream ranges that are present in ALL samples. (i.e the intersection)
#' @param .save logical type, save Rdata?
#'
#' @return none
.UTR5Analysis <- function(utr5Directories,
                          utr5Out,
                          sampleNames,
                          combinedNames,
                          mashedNames,
                          upstreamRanges,
                          .save = TRUE) {
    message("Starting 5'UTR analysis on samples ", combinedNames)
    upstreamRange <- unique(upstreamRanges)
    if (length(upstreamRange) == 1 && is.numeric(upstreamRange[[1]])) {
        upRange <- upstreamRange[[1]]
        START <- 1
        END <- 2

        if (length(upRange) != 2) {
            stop("Expected range to only have start and stop values, but got ",
                 upRange, " instead.")
        }

        expectedLength <-
            as.numeric(upRange[END]) - as.numeric(upRange[START]) + 1

        if (is.infinite(expectedLength)) {
            upRangeString <- paste0(upRange[START], "_", "inf")
        } else {
            upRangeString <- paste0(expectedLength, "_", expectedLength)
        }

        .plotUpstreamLength(utr5Directories, utr5Out, expectedLength,
                            paste0(upRange[START], "_", upRange[END]),
                            sampleNames, combinedNames,
                            mashedNames, .save = .save)

        .analyzeUpstreamValidity(utr5Directories, utr5Out, expectedLength,
                                 upRangeString, sampleNames, combinedNames,
                                 mashedNames, .save = .save)

    } else if (length(upstreamRange) > 1) {
        warning("Found multiple different upstream ranges for samples ",
                combinedNames,
                ": ",
                upstreamRange,
                ". Will not plot comparisons.")
    } else {
        warning("UpstreamRange is not numeric for sample ", combinedNames)
    }
}



#' Secretion signal analysis
#'
#' @description Generates all the required plots for Secretion signal analysis.
#' This includes upstream length distributions and upstream sequence validity.
#'
#' @param secDirectories list type. Secretion signal directories where files
#' are located
#' @param secOut string type. Where to dump output
#' @param sampleNames vector type. 1-1 with secDirectories
#' @param combinedNames string type. Title friendly string
#' @param mashedNames string type. File name friendly string
#' @param upstreamRanges list type. Upstream ranges for each sample.
#' If length(secDirectories) > 1, the plots will only be generated for
#' upstream ranges that are present in ALL samples. (i.e. the intersection)
#' @param .save logical type, save Rdata?
#'
#' @return none
.secretionSignalAnalysis <-
    function(secDirectories,
             secOut,
             sampleNames,
             combinedNames,
             mashedNames,
             upstreamRanges,
             .save = TRUE) {
        message("Starting secretion signal analysis on samples ", combinedNames)
        upstreamRange <- unique(upstreamRanges)
        if (length(upstreamRange) == 1 && is.numeric(upstreamRange[[1]])) {

            upRange <- upstreamRange[[1]]
            START <- 1
            END <- 2

            if (length(upRange) != 2) {
                stop("Expected range to only have start and stop values,",
                     " but got ", upRange, " instead.")
            }

            expectedLength <-
                as.numeric(upRange[END]) - as.numeric(upRange[START]) + 1

            if (is.infinite(expectedLength)) {
                upRangeString <- paste0(upRange[START], "_", "inf")
            } else {
                upRangeString <- paste0(expectedLength, "_", expectedLength)
                upRangeTrimmedString <- paste0("1_", expectedLength - 1)
            }

            .plotUpstreamLength(secDirectories, secOut, expectedLength,
                                paste0(upRange[START], "_", upRange[END]),
                                sampleNames, combinedNames,
                                mashedNames, .save = .save)
            .analyzeUpstreamValidity(secDirectories, secOut, expectedLength,
                                     upRangeString, sampleNames, combinedNames,
                                     mashedNames, .save = .save)
            if (!is.infinite(expectedLength)) {
                .analyzeUpstreamValidity(secDirectories, secOut,
                                         expectedLength, upRangeTrimmedString,
                                         sampleNames, combinedNames,
                                         mashedNames, .save = .save)
            }

        } else if (length(upstreamRange) > 1) {
            warning("Found multiple different upstream ranges for samples ",
                    combinedNames,
                    ": ",
                    upstreamRange,
                    ". Will not plot comparisons.")
        } else {
            warning("UpstreamRange is not numeric for sample ", combinedNames)
        }
    }


#' Plot upstream sequence length distribution for upstream sequences (5'UTR or
#' secretion signal) for a given \code{upstreamLengthRange}
#'
#' @description Given an upstream length range, plot the
#' distribution of upstream sequence lengths.
#'
#' @param upstreamDirectories list type. List of sample directories
#' @param upstreamOut string type. Output directory
#' @param upstreamLengthRange The range of upstream sequences to be included in
#' this plot. This is usually determined by abseqPy and the format should be as
#' follows: "min_max", e.g.: 1_15 means range(1, 15) inclusive.string type.
#' @param lengthType string type. "" (the empty string) denotes everything
#' and "_short" denotes a short sequence. abseqPy dictates this because it's
#' used for locating the files.
#' @param sampleNames vector type. 1-1 with upstream directories
#' @param combinedNames string type. Title friendly "combined" sample names
#' @param mashedNames string type. File friendly "mashed-up" sample names
#' @param .save logical type. Save Rdata?
#'
#' @return None
.plotUpstreamLengthDist <- function(upstreamDirectories, upstreamOut,
                                    upstreamLengthRange, lengthType,
                                    sampleNames, combinedNames,
                                    mashedNames, .save) {
    seqLengthFiles <- .listFilesInOrder(path = upstreamDirectories,
                                        pattern = paste0(".*_(secsig|5utr)_",
                                                         upstreamLengthRange,
                                                         "_dist", lengthType,
                                                         "\\.csv(\\.gz)?$"))
    if (length(seqLengthFiles)) {
        # fname is either secsig or 5utr for now
        fname <- if (grepl("secsig", seqLengthFiles[[1]])) {
            "secsig"
        } else {
            stopifnot(grepl("5utr", seqLengthFiles[[1]]))
            "5utr"
        }

        g <- .plotSpectratype(lapply(seqLengthFiles, read.csv),
                              sampleNames, title = "Sequence lengths",
                              xlabel = "Sequence Length(bp)",
                              ylabel = "Distribution")
        saveName <- file.path(upstreamOut,
                              paste0(mashedNames, "_", fname,
                                     "_", upstreamLengthRange,
                                     "_dist", lengthType, ".png"))
        ggsave(saveName , plot = g, width = V_WIDTH, height = V_HEIGHT)
        .saveAs(.save, saveName, plot = g)
    } else {
        warning("Can't find upstream dist file for range ",
                 upstreamLengthRange,
                " for samples ",
                 combinedNames)
    }
}


#' Plot IGV family distribution for a given \code{upstreamLengthRange}
#'
#' @description Given an upstream length range,
#' plot the distributions of IGV family without showing their actual lengths. If
#' their actual lengths matter, refer
#' to \code{\link{.plotIGVUpstreamLenDistDetailed}}.
#'
#' @param upstreamDirectories list type. List of sample directories
#' @param upstreamOut string type. Output directory
#' @param upstreamLengthRange The range of upstream sequences to be included in
#' this plot. This is usually determined by abseqPy and the format should be as
#' follows: "min_max", e.g.: 1_15 means range(1, 15) inclusive.string type.
#' @param lengthType string type. "" (the empty string) denotes everything
#' and "_short" denotes a short sequence. abseqPy dictates this because it's
#' used for locating the files.
#' @param sampleNames vector type. 1-1 with upstream directories
#' @param combinedNames string type. Title friendly "combined" sample names
#' @param mashedNames string type. File friendly "mashed-up" sample names
#' @param .save logical type. Save Rdata?
#'
#' @return None
.plotIGVUpstreamLenDist <- function(upstreamDirectories, upstreamOut,
                                    upstreamLengthRange, lengthType,
                                    sampleNames, combinedNames,
                                    mashedNames, .save = TRUE) {

    seqClassLengthFiles <-
        .listFilesInOrder(path = upstreamDirectories,
                          pattern = paste0( ".*_(secsig|5utr)_",
                                            upstreamLengthRange,
                                            "_dist", lengthType, "_class",
                                            "\\.csv(\\.gz)?$"))
    if (length(seqClassLengthFiles)) {
        fname <- if (grepl("secsig", seqClassLengthFiles[[1]])) {
            "secsig"
        } else {
            stopifnot(grepl("5utr", seqClassLengthFiles[[1]]))
            "5utr"
        }

        subtitle <- paste("Total is ", paste(
            lapply(seqClassLengthFiles,
                   function(x) {
                       as.integer(.getTotal(x))
                   }),
            collapse = ", "
        ))

        plotVert <- .checkVert(seqClassLengthFiles[[1]])

        g <- .plotDist(lapply(seqClassLengthFiles, read.csv, skip = 1),
                       sampleNames,
                       paste("IGV Abundance in Sample", combinedNames),
                       plotVert, subs = subtitle)
        if (plotVert) {
            plotWidth <- V_WIDTH
            plotHeight <- V_HEIGHT
        } else {
            plotWidth <- H_WIDTH
            plotHeight <- H_HEIGHT
        }
        saveName <-
            file.path(upstreamOut, paste0(mashedNames, "_", fname, "_",
                                          upstreamLengthRange,
                                          "_dist", lengthType,
                                          "_class", ".png"))
        ggsave(saveName, plot = g,
               width = plotWidth, height = plotHeight)
        .saveAs(.save, saveName, plot = g)
    } else {
        warning("Can't find upstream dist file for samples ", combinedNames)
    }
}



#' Plots the detailed length distribution for IGV families
#'
#' @description A boxplot for each IGV families showing the IQR of upstream
#' lengths. In contrast to \code{\link{.plotIGVUpstreamLenDist}},
#' which only shows the distribution of IGV families
#' over \code{upstreamLengthRange}.
#'
#' @param upstreamDirectories list type. List of sample directories
#' @param upstreamOut string type. Output directory
#' @param upstreamLengthRange The range of upstream sequences to be included in
#' this plot. This is usually determined by abseqPy and the format should be as
#' follows: "min_max", e.g.: 1_15 means range(1, 15) inclusive.string type.
#' @param lengthType string type. "" (the empty string) denotes everything
#' and "_short" denotes a short sequence. abseqPy dictates this because it's
#' used for locating the files.
#' @param sampleNames vector type. 1-1 with upstream directories
#' @param combinedNames string type. Title friendly "combined" sample names
#' @param mashedNames string type. File friendly "mashed-up" sample names
#' @param .save logical type. Save Rdata?
#'
#' @return None
.plotIGVUpstreamLenDistDetailed <- function(upstreamDirectories,
                                            upstreamOut, upstreamLengthRange,
                                            lengthType, sampleNames,
                                            combinedNames, mashedNames,
                                            .save = TRUE) {

    # Plot upstream lengths for each IGV family ----------------------
    seqClassLengthBoxFiles <-
        .listFilesInOrder(path = upstreamDirectories,
                          pattern = paste0(".*_(5utr|secsig)_",
                                           upstreamLengthRange, "_dist",
                                           lengthType, "_class",
                                           "_box\\.csv(\\.gz)?$"))
    if (length(seqClassLengthBoxFiles)) {
        fname <- if (grepl("secsig", seqClassLengthBoxFiles[[1]])) {
            "secsig"
        } else {
            stopifnot(grepl("5utr", seqClassLengthBoxFiles[[1]]))
            "5utr"
        }

        g <- .boxPlot(lapply(seqClassLengthBoxFiles, read.csv),
                      sampleNames, paste("Sequence Lengths in",
                                         combinedNames))

        saveName <- file.path(upstreamOut,
                              paste0(mashedNames, "_", fname, "_",
                                     upstreamLengthRange, "_dist", lengthType,
                                     "_class", "_box.png"))

        ggsave(saveName, plot = g, width = V_WIDTH, height = V_HEIGHT)
        .saveAs(.save, saveName, plot = g)
    } else {
        warning("Can't find upstream dist files for samples ", combinedNames)
    }
}

#' Visualize all analysis conducted by abseqPy
#'
#' @description Plots all samples in the output directory supplied to abseqPy's
#' \code{--outdir} or \code{-o} argument. Users can optionally specify
#' which samples in \code{directory} should be compared. Doing so generates
#' additional plots for clonotype comparison and the usual plots will also
#' conveniently include these samples using additional \code{aes}thetics.
#'
#' Calling this function with a valid \code{directory} will always return a
#' named \code{list} of objects; these individual objects can be
#' combined using the \code{+} operator to form a new comparison, in which the
#' \link{report} function accepts as its first parameter.
#'
#' @include util.R
#' @include AbSeqRep.R
#' @include accessors-AbSeq.R
#' @import BiocParallel
#'
#' @param directory string type. directory as specified in
#' \code{-o} or \code{--outdir} in abseqPy. This tells AbSeq where to look for
#' abseqPy's output.
#' @param report (optional) integer type. The possible values are:
#' \itemize{
#'   \item{0 - does nothing (returns named list of \linkS4class{AbSeqRep} objects)}
#'   \item{1 - generates plots for csv files}
#'   \item{2 - generates a report that collates all plots}
#'   \item{3 - generates interactive plots in report (default)}
#' }
#' each higher value also does what the previous values do. For example, \code{report = 2}
#' will return a named list of \linkS4class{AbSeqRep} objects, plot csv files,
#' and generate a (non-interactive)HTML report that collates all the plots together.
#' @param compare (optional) vector of strings. From the samples in found in \code{directory}
#' directory, they can be selected and compared against each other. For example,
#'  to compare "sample1" with "sample2" and "sample3" with "sample4",
#'  \code{compare} should be c("sample1,sample2", "sample3,sample4"). An error
#'  will be thrown if the samples specified in this parameter are not found in
#'  \code{directory}.
#' @param BPPARAM (optional) BiocParallel backend. Configures the parallel implementation.
#' Refer to \href{https://bioconductor.org/packages/release/bioc/html/BiocParallel.html}{BiocParallel}
#' for more information. By default, use all available cores.
#'
#' @return named list. List of \linkS4class{AbSeqRep} objects. The names of
#' the list elements are taken directly from the repertoire object itself.
#' This return value is consistent with the return value of \code{\link{report}}.
#'
#' @seealso \linkS4class{AbSeqRep}
#'
#' @export
#'
#' @seealso \code{\link{report}}. Analogous function, but takes input from
#' an \linkS4class{AbSeqRep} or \linkS4class{AbSeqCRep} object instead.
#'
#' @examples
#' # Use example data from abseqR as abseqPy's output, substitute this
#' # with your own abseqPy output directory
#' abseqPyOutput <- tempdir()
#' file.copy(system.file("extdata", "ex", package = "abseqR"), abseqPyOutput, recursive=TRUE)
#'
#' ### 1. The `report` parameter usage example:
#'
#' # report = 0; don't plot, don't collate a HTML report, don't show anything interactive
#' samples <- abseqReport(file.path(abseqPyOutput, "ex"), report = 0)
#' # samples is now a named list of AbSeqRep objects
#'
#' # report = 1; just plot pngs; don't collate a HTML report; nothing interactive
#' # samples <- abseqReport(file.path(abseqPyOutput, "ex"), report = 1)
#' # samples is now a named list of AbSeqRep objects
#'
#' # report = 2; plot pngs; collate a HTML report; HTML report will NOT be interactive
#' # samples <- abseqReport(file.path(abseqPyOutput, "ex"), report = 2)
#' # samples is now a named list of AbSeqRep objects
#'
#' # report = 3 (default); plot pngs; collate a HTML report; HTML report will be interactive
#' # samples <- abseqReport(file.path(abseqPyOutput, "ex"), report = 3)
#' # samples is now a named list of AbSeqRep objects
#'
#' ### 2. Using the return value of abseqReport:
#'
#' # NOTE, often, this is used to load multiple samples from different directories
#' # using abseqReport (with report = 0), then the samples are added together
#' # before calling the report function. This is most useful when the samples
#' # live in different abseqPy output directory.
#'
#' # Note that the provided example data has PCR1, PCR2, and PCR3
#' # samples contained within the directory
#' stopifnot(names(samples) == c("PCR1", "PCR2", "PCR3"))
#'
#' # as a hypothetical example, say we found something
#' # interesting in PCR1 and PCR3, and we want to isolate them:
#' # we want to explicitly compare PCR1 with PCR3
#' pcr13 <- samples[["PCR1"]] + samples[["PCR3"]]
#'
#' # see abseqR::report for more information.
#' # abseqR::report(pcr13)      # uncomment this line to run
#'
#' ### BPPARAM usage:
#'
#' # 4 core machine, use all cores -  use whatever value that suits you
#' nproc <- 4
#' # samples <- abseqReport(file.path(abseqPyOutput, "ex"),
#' #                        BPPARAM = BiocParallel::MulticoreParam(nproc))
#'
#'
#' # run sequentially - no multiprocessing
#' # samples <- abseqReport(file.path(abseqPyOutput, "ex"),
#' #                        BPPARAM = BiocParallel::SerialParam())
#'
#'# see https://bioconductor.org/packages/release/bioc/html/BiocParallel.html
#'# for more information about how to use BPPARAM and BiocParallel in general.
abseqReport <- function(directory, report, compare, BPPARAM) {
    #  ------ sanitize function arguments ---------
    root <- normalizePath(directory)
    if (!(all(c(RESULT_DIR, AUX_DIR) %in% list.files(root)))) {
        stop("Expected to find ", RESULT_DIR, " and ", AUX_DIR, " in ", root,
             " but they are missing. This directory should be the output ",
             "directory as specified in abseqPy. Aborting.")
    }

    if (missing(report)) {
        report <- 3
    }

    if (missing(BPPARAM)) {
        BPPARAM <- BiocParallel::bpparam()
    }

    if (missing(compare)) {
        # if user didn't specify which to compare, don't compare, just load
        # all samples in root/RESULT_DIR, EXCLUDING sample comparisons
        compare <- .findRepertoires(file.path(root, RESULT_DIR))
    } else {
        # make sure samples in "compare" actually exists
        availSamples <- .findRepertoires(file.path(root, RESULT_DIR))
        lapply(compare, function(s) {
            user.sample.name <- unlist(lapply(strsplit(s, ","), trimws))
            lapply(user.sample.name, function(si) {
                if (!(si %in% availSamples)) {
                    stop("Sample ", si, " in the 'compare' argument cannot ",
                         "be found in ", file.path(root, RESULT_DIR))
                }
            })
        })
        compare <- unique(c(availSamples, compare))
    }

    # TODO: sanitize 'report' properly using constants/functions
    stopifnot(report %in% c(0, 1, 2, 3))
    # convert number to meaningful variables
    if (report == 0) {
        report <- FALSE
        interactivePlot <- FALSE
        loop <- FALSE
    } else if (report == 1) {
        report <- FALSE
        interactivePlot <- FALSE
        loop <- TRUE
    } else if (report == 2) {
        report <- TRUE
        interactivePlot <- FALSE
        loop <- TRUE
    } else {
        report <- TRUE
        interactivePlot <- TRUE
        loop <- TRUE
    }

    if (loop) {
        bplapply(compare, function(pair) {
            sampleNames <- unlist(lapply(strsplit(pair, ","), trimws))

            # depending on the number of samples requested to plot, outputDir
            # is either a <sample>_vs_<sample> format or just <sample>
            # meanwhile, samples will either be a AbSeqCRep or just AbSeqRep.
            outputDir <- file.path(root, RESULT_DIR,
                          paste(sampleNames, collapse = "_vs_"))
            samples <- .loadSamplesFromString(sampleNames,
                                              root,
                                              warnMove = FALSE)
            # due to the cache/shared user issue (see issue)
            # https://github.com/rstudio/rmarkdown/issues/499
            # we delay the report generation until AFTER the multiprocessing part
            # has completed, that is, we will generate the report one by one
            # TODO: improve this, this is taking way too long to render
            abseqR::report(samples,
                           outputDir,
                           report = 1)   # always plot, but DO NOT GENERATE REPORT!
        }, BPPARAM = BPPARAM)
    }

    # whether or not we generate the report, always return a list of all
    # the samples found in "root"
    if (report) {
        return(.generateDelayedReport(root, compare, interactivePlot))
    } else {
        listOfSamples <- list()
        for (pair in compare) {
            sampleNames <- unlist(lapply(strsplit(pair, ","), trimws))
            if (length(sampleNames) == 1) {
                outputDir <- file.path(root, RESULT_DIR, sampleNames[1])
                sample <- .loadSamplesFromString(sampleNames, root,
                                                  warnMove = TRUE)
                listOfSamples[[.asRepertoireName(sample)]] <- sample
            }
        }
        return(listOfSamples)
    }
}


#' Collate all HTML reports into a single directory and cretate an entry
#' \code{index.html} file that redirects to all collated HTML files
#'
#' @include accessors-AbSeq.R
#' @import flexdashboard png knitr BiocStyle
#' @importFrom rmarkdown render pandoc_available
#'
#' @param reports list/vector type. Collection of strings that are path(s)
#' to <sample>_report.html
#' @param individualSamples list type. list of AbSeqRep objects. Used to
#' extract filtering information and \% read counts.
#' @param outputDirectory string type. Where should the report be placed.
#'
#' @return Nothing
.collateReports <-
    function(reports,
             individualSamples,
             outputDirectory) {
        message("Collating report into index.html")

        # get relative links for HTML report (instead of absolute paths)
        relLinks <- lapply(reports, function(pth) {
            return(file.path(ABSEQ_NESTED_HTML_DIR, basename(pth)))
        })

        # define a mask to filter reports based on comparative or single report
        multiSampleMask <- grepl(".*_vs_.*", names(reports))

        # define rmarkdown params
        chains <- paste(lapply(individualSamples, .asRepertoireChain),
                        collapse = ",")

        rawReads <- paste(lapply(individualSamples, function(x) {
            .readSummary(file.path(.asRepertoireDir(x),
                                   RESULT_DIR,
                                   .asRepertoireName(x)),
                         ABSEQ_RAW_READ_COUNT_KEY)
        }), collapse = ",")

        annotReads <- paste(lapply(individualSamples, function(x) {
            .readSummary(file.path(.asRepertoireDir(x),
                                   RESULT_DIR,
                                   .asRepertoireName(x)),
                         ABSEQ_ANNOT_READ_COUNT_KEY)
        }), collapse = ",")

        filtReads <- paste(lapply(individualSamples, function(x) {
            .readSummary(file.path(.asRepertoireDir(x),
                                   RESULT_DIR,
                                   .asRepertoireName(x)),
                         ABSEQ_FILT_READ_COUNT_KEY)
        }), collapse = ",")

        prodReads <- paste(lapply(individualSamples, function(x) {
            .readSummary(file.path(.asRepertoireDir(x),
                                   RESULT_DIR,
                                   .asRepertoireName(x)),
                         ABSEQ_PROD_READ_COUNT_KEY)
        }), collapse = ",")

        filterSplitter <- "?"
        filters <- paste(lapply(individualSamples, function(x) {
            paste(
                paste0("Bitscore: ", .asRepertoireBitscore(x)),
                paste0("V alignment length: ", .asRepertoireAlignLen(x)),
                paste0("Query start: ", .asRepertoireQueryStart(x)),
                paste0("Subject start: ", .asRepertoireSubjectStart(x)),
                sep = ","
            )
        }), collapse = filterSplitter)

        templateFile <-
            system.file("extdata", "index.Rmd", package = "abseqR")
        renderParams <- list(
            singleSamples = paste(names(reports)[!multiSampleMask], collapse = ","),
            multiSamples = paste(names(reports)[multiSampleMask], collapse = ","),
            singleSampleLinks = paste(relLinks[!multiSampleMask], collapse = ","),
            multiSampleLinks = paste(relLinks[multiSampleMask], collapse = ","),
            chains = chains,
            rawReads = rawReads,
            filtReads = filtReads,
            annotReads = annotReads,
            prodReads = prodReads,
            filters = filters,
            filterSplitter = filterSplitter,
            analysisParams = file.path(
                .asRepertoireDir(individualSamples[[1]]),
                RESULT_DIR,
                .asRepertoireName(individualSamples[[1]]),
                ANALYSIS_PARAMS
            )
        )
        if (rmarkdown::pandoc_available()) {
            rmarkdown::render(templateFile,
                              output_dir = outputDirectory,
                              params = renderParams)
        } else {
            warning("Pandoc not found in system, will not create index.html")
        }
    }

#' Generates report for all samples in 'compare'
#'
#' @description This function is needed because we are delaying the generation
#' of reports until after all threads/processes have joined. There's currently
#' an issue with rmarkdown::render() in parallel execution, see:
#' https://github.com/rstudio/rmarkdown/issues/499
#'
#' @include util.R
#' @include accessors-AbSeq.R
#' @include AbSeqRep.R
#'
#' @param root string, project root directory.
#' @param compare vector of strings, each string is a comparison defined
#' by the user (assumes that this value has been checked).
#' @param interactivePlot logical, whether or not to plot interactive plotly
#' plots.
#'
#' @return a named list of samples, each an AbSeqRep object found in "root"
.generateDelayedReport <- function(root, compare, interactivePlot) {
    # before we start creating reports, create the report directory
    reportDir <- file.path(root, ABSEQ_HTML_DIR)
    if (!dir.exists(reportDir)) {
        dir.create(reportDir)
    } else {
        warning(reportDir, " found, overriding contents.")
    }

    # create nested HTML directory for all html files except index.html
    nestedHTMLdir <- file.path(reportDir, ABSEQ_NESTED_HTML_DIR)
    if (!dir.exists(nestedHTMLdir)) {
        dir.create(nestedHTMLdir)
    } else {
        warning(nestedHTMLdir, " found, overriding contents.")
    }

    individualSamples <- list()
    individualReports <- list()
    # populate individualSample list with samples for user to browse and
    # create report if asked to.
    for (pair in compare) {
        sampleNames <- unlist(lapply(strsplit(pair, ","), trimws))
        outputDir <- file.path(root, RESULT_DIR,
                               paste(sampleNames, collapse = "_vs_"))
        samples <- .loadSamplesFromString(sampleNames, root,
                                          warnMove = TRUE)
        if (length(sampleNames) == 1) {
            individualSamples[[.asRepertoireName(samples)]] <- samples
        }
        pth <- .generateReport(
            samples,
            root = outputDir,
            outputDir = file.path(root, ABSEQ_HTML_DIR, ABSEQ_NESTED_HTML_DIR),
            interactivePlot = interactivePlot,
            .indexHTML = file.path("..", "index.html")
        )
        if (!is.na(pth)) {
            individualReports[paste(sampleNames, collapse = "_vs_")] <- pth
        }
    }

    if (length(individualReports)) {
        .collateReports(
            individualReports,
            individualSamples,
            outputDirectory = file.path(root, ABSEQ_HTML_DIR)
        )
    }
    return(individualSamples)
}


#' Loads AbSeqCRep or AbSeqRep objects from a list of sampleNames
#'
#' @include util.R
#' @include AbSeqRep.R
#' @include accessors-AbSeq.R
#'
#' @param sampleNames vector, singleton or otherwise
#' @param root string type. root directory
#' @param warnMove logical type. Warning message
#' ("message" level, not "warning" level) if the directory has been moved?
#'
#' @return AbSeqRep or AbSeqCRep object depending on sampleNames
.loadSamplesFromString <- function(sampleNames, root, warnMove = TRUE) {
    Reduce("+", lapply(sampleNames, function(sname) {
        sample <- .loadAbSeqRepFromParams(file.path(root, RESULT_DIR,
                                                    sname, ANALYSIS_PARAMS))
        if (suppressWarnings(normalizePath(.asRepertoireDir(sample))) !=
            suppressWarnings(normalizePath(root))) {
            if (warnMove) {
                message("Sample output directory ",
                        .asRepertoireDir(sample),
                        " is different from provided path ",
                        root,
                        ". Assuming directory was moved.")
            }
            sample@outdir <- root
        }
        return(sample)
    }))
}

context("'report' function on AbSeqCRep and AbSeqRep objects")

## Wed Oct 24 12:08:01 AEDT 2018
## This test file will test
##      1. abseqReport
##      2. report and (parameter report = 1)
##      3. (indirectly) the "+" operator

# Load example data -- ex -------------------------------------------------
tmpdir <- tempdir()
exdata <- system.file("extdata", "ex", package = "abseqR")
file.copy(exdata, tmpdir, recursive = TRUE)
ex <- file.path(tmpdir, "ex")

# Test report function ----------------------------------------------------
test_that("report correctly accepts AbSeqRep objects", {
    exp <- abseqReport(ex, report = 0)
    expect_length(exp, 3)
    obs <- report(exp[[1]], outputDir = tempdir(), report = 0)
    # careful not to use exp[[1]] as obs will be a singleton *named* list
    expect_equal(exp[1], obs)
})

test_that("report correctly accepts AbSeqCRep objects", {
    exp <- abseqReport(ex, report = 0)
    expect_length(exp, 3)
    obs <- report(Reduce("+", exp), outputDir = tempdir(), report = 0)
    expect_equal(exp, obs)
})


## TODO: test on report = 2, 3
test_that("report dosen't fall over when reporting one sample", {
    # we're only testing one sample because it will take way to long otherwise
    samples <- abseqReport(ex, report = 0)
    expect_length(samples, 3)
    expect_named(samples, c("PCR1", "PCR2", "PCR3"))
    obs <- report(samples[["PCR2"]], outputDir = tempdir(), report = 1)
    expect_equal(samples[2], obs)
})

context("AbSeqRep S4 class")

## Wed Oct 24 12:08:01 AEDT 2018
## This test file will test
##      1. (indirectly) accessors
##      2. abseqReport
##      3. The instantiation of AbSeqRep

# Load example data -- ex -------------------------------------------------
tmpdir <- tempdir()
exdata <- system.file("extdata", "ex", package = "abseqR")
file.copy(exdata, tmpdir, recursive = TRUE)
ex <- file.path(tmpdir, "ex")


# Test S4 class -----------------------------------------------------------
test_that("AbSeqRep is correctly instantiated with all 3 samples", {
    samples <- abseqReport(ex, report = 0)
    expect_length(samples, 3)
    expect_named(samples,
                 c("PCR1", "PCR2", "PCR3"),
                 ignore.order = FALSE,
                 ignore.case = FALSE)
})


test_that("AbSeqRep object was loaded correctly using its accessors", {
    samples <- abseqReport(ex, report = 0)
    expectedResults <- list(
        .asRepertoireName = c("PCR1", "PCR2", "PCR3"),
        .asRepertoireDir = rep("ex", 3),
        .asRepertoireChain = rep("hv", 3),
        .asRepertoireBitscore = rep("300 - Inf", 3),
        .asRepertoireQueryStart = rep("1 - Inf", 3),
        .asRepertoireAlignLen = rep("250 - Inf", 3),
        .asRepertoireSubjectStart = rep("1 - 3", 3),
        .asRepertoirePrimer5 = rep("None", 3),
        .asRepertoirePrimer3 = rep("None", 3),
        .asRepertoireUpstream = rep("None", 3)
    )
    lapply(seq_along(expectedResults), function(i) {
        functor <- names(expectedResults)[[i]]
        obs <- unlist(lapply(samples, function(x) {
            basename(do.call(functor, list(x)))
        }))
        exp <- expectedResults[[i]]
        expect_equivalent(obs, exp)
    })
})

context("abseqReport function loader and plotter")

## Wed Oct 24 12:08:01 AEDT 2018
## This test file will test
##      1. abseqReport and report = 0 with message output

# Load example data -- ex -------------------------------------------------
tmpdir <- tempdir()
exdata <- system.file("extdata", "ex", package = "abseqR")
file.copy(exdata, tmpdir, recursive = TRUE)
ex <- file.path(tmpdir, "ex")


# Test abseqReport function -----------------------------------------------
test_that("abseqReport generates a message that the directory has been moved", {
    expect_message(abseqReport(ex, report = 0), regex = ".*different.*move.*")
})

#' Title Clonotype table
#'
#' @import ggplot2
#' @import RColorBrewer
#' @import grDevices
#'
#' @param dataframes list type. List of dataframes.
#' @param sampleNames vector type. vector of strings representing sample
#' names should have one-to-one correspondence with dataframes
#' @param top int type. Top N clonotypes to plot
#'
#' @return None
.topNDist <- function(dataframes, sampleNames, top = 10) {
    nsamples <- length(dataframes)

    if (nsamples != length(sampleNames)) {
        stop("Expected equal number of sample names and dataframes, got ",
             length(sampleNames),
             " samples and ",
             nsamples, " dataframes.")
    }

    message("Plotting top ",
            top,
            " clonotype distribution for samples ",
            paste(sampleNames, collapse = ", "))

    # --- cleanup & pre-processing ---
    colNames <- c("Clonotype", "Count")
    for (i in seq_len(nsamples)) {
        df <- dataframes[[i]]
        # only need top N, also take the columns we're interested in only
        df <- head(df[colNames], top)
        # append sample name to distinguish data when merged later on
        df$sample <- sampleNames[i]
        # normalize percentage to top N
        df$normPerc <- df$Count / sum(df$Count)
        dataframes[[i]] <- df
    }

    df.union <- do.call("rbind", dataframes)
    # --- done: cleanup & pre-processing ---

    # plot!
    # colour suggestion taken from
    # https://stackoverflow.com/questions/9563711/r-color-palettes-for-many-data-classes/41230685
    # and modified
    palette <- c(
        "dodgerblue2",
        "#E31A1C",
        "green4",
        "#6A3D9A",
        "#FF7F00",
        "black",
        "gold1",
        "skyblue2",
        "#FB9A99",
        "olivedrab1",
        "#CAB2D6",
        "#FDBF6F",
        "gray70",
        "khaki2",
        "maroon",
        "orchid1",
        "deeppink1",
        "blue1",
        "steelblue4",
        "darkturquoise",
        "green1",
        "yellow4",
        "yellow3",
        "aquamarine",
        "darkorange4",
        "mediumpurple1",
        "dimgrey",
        "darkseagreen1",
        "lightyellow",
        "coral2"
    )
    if (length(unique(df.union$Clonotype)) > 30) {
        warning("Too many unique clonotypes are being plotted",
                " - extrapolating palette for top10 clonotype dist plot.")
        getPalatte <- colorRampPalette(brewer.pal(8, 'Accent'))
        palette <- getPalatte(length(unique(df.union$Clonotype)))
    }
    g <- ggplot(df.union, aes(x = sample, y = normPerc)) +
        geom_bar(stat = 'identity', aes(fill = Clonotype)) +
        theme(
            legend.position = "bottom",
            legend.box = "horizontal",
            legend.title = element_blank(),
            legend.text = element_text(size = 7)
        ) +
        labs(
            title = paste("Top", top, "clonotype across each sample"),
            subtitle = paste(
                "Colour coded clonotypes, distribution of each clonotype is scaled to top",
                top
            ),
            x = "Sample",
            y = "Distribution"
        )  +
        scale_fill_manual(values = palette)
    return(g)
}


#' Title Creates a scatter plot
#'
#' @import ggplot2
#' @include util.R
#'
#' @param df1 dataframe for sample 1
#' @param df2 dataframe for sample 2
#' @param name1 string type, Sample 1 name
#' @param name2 string type. Sample 2 name
#' @param cloneClass string type.
#' What region was used to classify clonotypes - appears in title. For example,
#' CDR3 or V region
#'
#' @return ggplot2 object
.scatterPlot <- function(df1, df2, name1, name2, cloneClass) {
    message("Generating scatter plot for ", name1, " and ", name2)

    df.union <-
        merge(df1,
              df2,
              by = "Clonotype",
              all.y = TRUE,
              all.x = TRUE)

    # replace NaN with 0
    df.union[is.na(df.union)] <- 0

    # plot!
    gg <- ggplot(df.union, aes(x = Count.x, y = Count.y)) +
        geom_point() +
        theme_bw() +
        labs(
            subtitle = paste(name2, " vs ", name1,
                             " plot based on clonotype counts"),
            y = name2,
            x = name1,
            title = paste("Scatter plot of ", cloneClass, " clonotype counts")
        )
    return(gg)
}

#' Creates a complex scatter plot
#'
#' @import ggplot2 gridExtra grid stats
#'
#' @include util.R
#'
#' @param df.union a 'lossless' dataframe created by intersecting sample1 and
#' sample2's dataframes. It should contain NAs where clones that appear in one
#' sample doesn't appear in the other. For example:
#'
#' +-------------------------------------------------+
#' | Clonotype | prop.x | prop.y | Count.x | Count.y |
#' +-------------------------------------------------+
#' | ABCDEF       NA       0.01      NA        210   |
#' | ......                                          |
#' +-------------------------------------------------+
#'
#' @param df1 dataframe for sample 1
#' @param df2 dataframe for sample 2
#' @param name1 string type, Sample 1 name
#' @param name2 string type. Sample 2 name
#' @param cloneClass string type.
#' What region was used to classify clonotypes - appears in title. For example,
#' CDR3 or V region
#'
#' this plotting techique was
#' shamelessly plagarised from
#' https://github.com/mikessh/vdjtools/blob/master/src/main/resources/rscripts/intersect_pair_scatter.r
#' (VDJTools) with minor modifications
#'
#' @return ggplot2 object
.scatterPlotComplex <-
    function(df.union,
             df1,
             df2,
             name1,
             name2,
             cloneClass) {
        message("Generating scatter plot for ", name1, " and ", name2)

        # find what the smallest percentage is so we know what to use as the
        # minimum (since log10(0) wont cut it)
        smallestPercentage <- min(df1$prop, df2$prop)

        # log10 scale the proportions (-inf, 0)
        df.union$prop.x <- log10(df.union$prop.x)
        df.union$prop.y <- log10(df.union$prop.y)
        df1$prop <- log10(df1$prop)
        df2$prop <- log10(df2$prop)


        intersectingClones <-
            df.union[complete.cases(df.union), "Clonotype"]

        # convert NAs to x and y intercept values
        df.union[is.na(df.union)] <- log10(smallestPercentage * 5e-1)

        xmin <- min(df.union$prop.x)
        ymin <- min(df.union$prop.y)

        sample1.margin <-
            .cloneDistMarginal(df1, intersectingClones, xmin, flip = FALSE)
        sample2.margin <-
            .cloneDistMarginal(df2, intersectingClones, ymin, flip = TRUE)

        g <- ggplot(df.union, aes(x = prop.x, y = prop.y)) +
            theme_bw() +
            geom_point(
                aes(size = (prop.x + prop.y / 2)),
                color = "black",
                alpha = 0.4,
                pch = 21,
                fill = BLUEHEX
            ) +
            scale_size_continuous(guide = "none", range = c(1, 10)) +
            scale_x_continuous(limits = c(xmin, 0), expand = c(0, 0.1)) +
            scale_y_continuous(limits = c(ymin, 0), expand = c(0, 0.1)) +
            # geom_smooth(method = "lm", se = TRUE, fullrange = TRUE) +
            # stat_smooth(data = df.union, aes(prop.x, prop.y,
            #                                  weight = 10^((prop.x + prop.y) / 2)),
            #             color = "blue", method = "lm", fullrange = TRUE, se = TRUE) +
            labs(y = name2, x = name1)
        grid.arrange(
            sample1.margin,
            .emptyPlot(),
            g,
            sample2.margin,
            ncol = 2,
            nrow = 2,
            widths = c(4, 1),
            heights = c(1, 4),
            top = paste(
                "Scatter plot of",
                cloneClass,
                "clonotype frequencies\n",
                name2,
                "vs",
                name1
            )
        )
    }



#' Marginal density graph of clonotypes (blue for shared, grey for total, purple
#' for exclusive clones)
#'
#' @import ggplot2
#' @include util.R
#'
#' @param df.original dataframe with all clones
#' @param otherClones clones from the other dataframe
#' @param lim.min x-axis minimum limit
#' @param flip logical type
#'
#' @return ggplot2 object
.cloneDistMarginal <-
    function(df.original, otherClones, lim.min, flip) {
        mask <- df.original$Clonotype %in% otherClones
        # clones that are shared between df.original and the other sample
        df.shared <- df.original[mask,]
        # clones that are not shared with the other sample
        df.exclusive <- df.original[!mask,]
        # grey, BLUHEX, purplish blue
        g <- ggplot() +
            stat_density(
                data = df.original,
                aes(x = prop, y = ..scaled..),
                fill = "#808080",
                alpha = 0.4,
                adjust = 1,
                size = 0.1,
                color = "black"
            ) +
            stat_density(
                data = df.shared,
                aes(x = prop, y = ..scaled..),
                fill = BLUEHEX,
                alpha = 0.4,
                adjust = 1,
                size = 0.1,
                color = "black"
            ) +
            stat_density(
                data = df.exclusive,
                aes(x = prop, y = ..scaled..),
                fill = "#e0ccff",
                alpha = 0.4,
                adjust = 1,
                size = 0.1,
                color = "black"
            ) +
            scale_x_continuous(limits = c(lim.min, 0), expand = c(0, 0.25)) +
            theme_bw() +
            theme(
                legend.position = "none",
                axis.title.x = element_blank(),
                axis.text = element_blank(),
                axis.ticks = element_blank(),
                axis.title.y = element_blank(),
                panel.grid = element_blank(),
                panel.border = element_blank()
            )
        if (flip) {
            g <- g + coord_flip()
        }
        return(g)
    }

#' Marginal histogram of clonotypes (blue for shared, grey for total). The y
#' axis is scaled by sqrt (but it doesn't really matter anyway, since we're
#' stripping away the y-ticks)
#'
#' @import ggplot2
#' @include util.R
#'
#' @param df.original dataframe with all clones
#' @param otherClones clones from the other dataframe
#' @param lim.min x-axis minimum limit
#' @param flip logical type
#'
#' @return ggplot2 object
.cloneDistHist <-
    function(df.original, otherClones, lim.min, flip) {
        df.filtered <- df.original[df.original$Clonotype %in% otherClones,]
        g <- ggplot() +
            geom_histogram(
                data = df.original,
                aes(x = prop,
                    y = sqrt(..count.. / sum(..count..))),
                fill = "#808080",
                alpha = 0.4
            ) +
            geom_histogram(
                data = df.filtered,
                aes(x = prop,
                    y = sqrt(..count.. / sum(..count..))),
                fill = BLUEHEX,
                alpha = 0.4
            ) +
            scale_x_continuous(limits = c(lim.min, 0), expand = c(0, 0.25)) +
            theme_bw() +
            theme(
                legend.position = "none",
                axis.title.x = element_blank(),
                axis.text = element_blank(),
                axis.ticks = element_blank(),
                axis.title.y = element_blank(),
                panel.grid = element_blank()
            )
        if (flip) {
            g <- g + coord_flip()
        }
        return(g)
    }



#' Title Creates Venndiagram for clonotype intersection
#'
#' @import VennDiagram grDevices
#'
#' @param dataframes list type. List of sample dataframes. Only accepts 2 - 5
#' samples. Warning message will be generated for anything outside of the range
#' @param sampleNames vector type. 1-1 with dataframes
#' @param outFile string type. Filename to be saved as
#' @param top int type. Top N cutoff, defaults to ALL clones if not specified
#'
#' @return Nothing
.vennIntersection <-
    function(dataframes, sampleNames, outFile, top = Inf) {
        nsample <- length(dataframes)

        if (nsample != length(sampleNames)) {
            stop("Expected equal number of sample names and dataframes, got ",
                 length(sampleNames),
                 " samples and ",
                 nsample, " dataframes.")
        }

        if (nsample >= 2 && nsample <= 5) {
            # output
            message("Creating Venn diagram for samples ",
                    paste(sampleNames, collapse = ", "))
            png(
                filename = outFile,
                width = 8,
                height = 7,
                units = "in",
                res = 300
            )

            # Get the top N clonotypes if specified, and only use the 2 columns
            # specified below
            colNames <- c("Clonotype", "Count")
            dataframes <- lapply(dataframes, function(df) {
                head(df[colNames], top)
            })

            # merge all dataframes
            df.union <- merge(
                dataframes[[1]],
                dataframes[[2]],
                by = "Clonotype",
                all.y = TRUE,
                all.x = TRUE
            )
            colnames(df.union) <-
                c("Clonotype", sampleNames[1], sampleNames[2])
            df.union[is.na(df.union)] <- 0

            # check if there's more
            if (nsample > 2) {
                for (i in 3:nsample) {
                    oldColNames <- colnames(df.union)
                    df.union <-
                        merge(
                            df.union,
                            dataframes[[i]],
                            by = "Clonotype",
                            all.y = TRUE,
                            all.x = TRUE
                        )
                    colnames(df.union) <- c(oldColNames, sampleNames[i])
                    df.union[is.na(df.union)] <- 0
                }
            }

            # plot!
            area1 <- sum(df.union[sampleNames[1]] > 0)
            area2 <- sum(df.union[sampleNames[2]] > 0)
            area12 <-
                sum(df.union[sampleNames[1]] > 0 & df.union[sampleNames[2]] > 0)
            if (nsample == 2) {
                draw.pairwise.venn(
                    area1,
                    area2,
                    area12,
                    category = c(sampleNames[1], sampleNames[2]),
                    cat.fontface = "bold",
                    cex = 1.7,
                    fill = 2:3,
                    alpha = 0.5,
                    filename = NULL
                )
            } else {
                area3 <- sum(df.union[sampleNames[3]] > 0)
                area13 <-
                    sum(df.union[sampleNames[1]] > 0 & df.union[sampleNames[3]] > 0)
                area23 <-
                    sum(df.union[sampleNames[2]] > 0 & df.union[sampleNames[3]] > 0)
                area123 <-
                    sum(df.union[sampleNames[1]] > 0 &
                            df.union[sampleNames[2]] > 0 & df.union[sampleNames[3]] > 0)
                if (nsample == 3) {
                    draw.triple.venn(
                        area1 = area1,
                        area2 = area2,
                        area3 = area3,
                        n12 = area12,
                        n13 = area13,
                        n23 = area23,
                        n123 = area123,
                        category = c(sampleNames[1], sampleNames[2], sampleNames[3]),
                        cat.fontface = "bold",
                        cex = 1.7,
                        fill = 2:4,
                        alpha = 0.5,
                        filename = NULL
                    )
                } else {
                    area4 <- sum(df.union[sampleNames[4]] > 0)
                    area14 <-
                        sum(df.union[sampleNames[1]] > 0 & df.union[sampleNames[4]] > 0)
                    area24 <-
                        sum(df.union[sampleNames[2]] > 0 & df.union[sampleNames[4]] > 0)
                    area34 <-
                        sum(df.union[sampleNames[3]] > 0 & df.union[sampleNames[4]] > 0)
                    area124 <-
                        sum(df.union[sampleNames[1]] > 0 &
                                df.union[sampleNames[2]] > 0 & df.union[sampleNames[4]] > 0)
                    area134 <-
                        sum(df.union[sampleNames[1]] > 0 &
                                df.union[sampleNames[3]] > 0 & df.union[sampleNames[4]] > 0)
                    area234 <-
                        sum(df.union[sampleNames[2]] > 0 &
                                df.union[sampleNames[3]] > 0 & df.union[sampleNames[4]] > 0)
                    area1234 <- sum(df.union[sampleNames[1]] > 0 &
                                        df.union[sampleNames[2]] > 0 &
                                        df.union[sampleNames[3]] > 0 &
                                        df.union[sampleNames[4]] > 0)
                    if (nsample == 4) {
                        draw.quad.venn(
                            area1 = area1,
                            area2 = area2,
                            area3 = area3,
                            area4 = area4,
                            n12 = area12,
                            n13 = area13,
                            n14 = area14,
                            n23 = area23,
                            n24 = area24,
                            n34 = area34,
                            n123 = area123,
                            n124 = area124,
                            n134 = area134,
                            n234 = area234,
                            n1234 = area1234,
                            category = c(
                                sampleNames[1],
                                sampleNames[2],
                                sampleNames[3],
                                sampleNames[4]
                            ),
                            cat.fontface = "bold",
                            cex = 1.7,
                            fill = 2:5,
                            alpha = 0.5,
                            filename = NULL
                        )
                    } else {
                        # quuntuple plot
                        area5 <- sum(df.union[sampleNames[5]] > 0)
                        area15 <-
                            sum(df.union[sampleNames[1]] > 0 & df.union[sampleNames[5]] > 0)
                        area25 <-
                            sum(df.union[sampleNames[2]] > 0 & df.union[sampleNames[5]] > 0)
                        area35 <-
                            sum(df.union[sampleNames[3]] > 0 & df.union[sampleNames[5]] > 0)
                        area45 <-
                            sum(df.union[sampleNames[4]] > 0 & df.union[sampleNames[5]] > 0)
                        area125 <-
                            sum(df.union[sampleNames[1]] > 0 &
                                    df.union[sampleNames[2]] > 0 & df.union[sampleNames[5]] > 0)
                        area135 <-
                            sum(df.union[sampleNames[1]] > 0 &
                                    df.union[sampleNames[3]] > 0 & df.union[sampleNames[5]] > 0)
                        area145 <-
                            sum(df.union[sampleNames[1]] > 0 &
                                    df.union[sampleNames[4]] > 0 & df.union[sampleNames[5]] > 0)
                        area235 <-
                            sum(df.union[sampleNames[2]] > 0 &
                                    df.union[sampleNames[3]] > 0 & df.union[sampleNames[5]] > 0)
                        area245 <-
                            sum(df.union[sampleNames[2]] > 0 &
                                    df.union[sampleNames[4]] > 0 & df.union[sampleNames[5]] > 0)
                        area345 <-
                            sum(df.union[sampleNames[3]] > 0 &
                                    df.union[sampleNames[4]] > 0 & df.union[sampleNames[5]] > 0)
                        area1235 <- sum(df.union[sampleNames[1]] > 0 &
                                            df.union[sampleNames[2]] > 0 &
                                            df.union[sampleNames[3]] > 0 &
                                            df.union[sampleNames[5]] > 0)
                        area1245 <- sum(df.union[sampleNames[1]] > 0 &
                                            df.union[sampleNames[2]] > 0 &
                                            df.union[sampleNames[4]] > 0 &
                                            df.union[sampleNames[5]] > 0)
                        area1345 <- sum(df.union[sampleNames[1]] > 0 &
                                            df.union[sampleNames[3]] > 0 &
                                            df.union[sampleNames[4]] > 0 &
                                            df.union[sampleNames[5]] > 0)
                        area2345 <- sum(df.union[sampleNames[2]] > 0 &
                                            df.union[sampleNames[3]] > 0 &
                                            df.union[sampleNames[4]] > 0 &
                                            df.union[sampleNames[5]] > 0)
                        area12345 <- sum(
                            df.union[sampleNames[1]] > 0 &
                                df.union[sampleNames[2]] > 0 &
                                df.union[sampleNames[3]] > 0 &
                                df.union[sampleNames[4]] > 0 &
                                df.union[sampleNames[5]] > 0
                        )
                        draw.quintuple.venn(
                            area1 = area1,
                            area2 = area2,
                            area3 = area3,
                            area4 = area4,
                            area5 = area5,
                            n12 = area12,
                            n13 = area13,
                            n14 = area14,
                            n15 = area15,
                            n23 = area23,
                            n24 = area24,
                            n25 = area25,
                            n34 = area34,
                            n35 = area35,
                            n45 = area45,
                            n123 = area123,
                            n124 = area124,
                            n125 = area125,
                            n134 = area134,
                            n135 = area135,
                            n145 = area145,
                            n234 = area234,
                            n235 = area235,
                            n245 = area245,
                            n345 = area345,
                            n1234 = area1234,
                            n1235 = area1235,
                            n1245 = area1245,
                            n1345 = area1345,
                            n2345 = area2345,
                            n12345 = area12345,
                            category = c(
                                sampleNames[1],
                                sampleNames[2],
                                sampleNames[3],
                                sampleNames[4],
                                sampleNames[5]
                            ),
                            cat.fontface = "bold",
                            cex = 1.7,
                            fill = 2:6,
                            alpha = 0.5,
                            filename = NULL
                        )
                    }
                }
            }
            dev.off()
        } else {
            # TODO: use heatmap when samples > 5 (calculate similarity distance)
            warning("Skipping venn diagram plot for ",
                    paste(sampleNames, collapse = ", "),
                    ". Venn diagrams are not supported for comaprisons of ",
                    "more than 5 samples.")
        }
    }


#' Conduct all vs all pairwise comparison analyses
#'
#' @include util.R
#' @include statistics.R
#'
#' @import ggplot2
#' @import ggdendro
#' @import BiocParallel
#' @import ggcorrplot
#' @import reshape2
#' @import stats
#' @import grDevices
#'
#' @param dataframes list of dataframes
#' @param sampleNames 1-1 vector corresponding to dataframes
#' @param outputPath string
#' @param .save logical
#'
#' @return nothing
.pairwiseComparison <-
    function(dataframes,
             sampleNames,
             outputPath,
             .save = TRUE) {
        stopifnot(length(dataframes) == length(sampleNames))
        # TODO: depending on memory consumption and CPU usage, can parallelize this.
        df <-
            do.call("rbind", lapply(head(seq_along(dataframes), n = -1), function(i) {
                do.call("rbind", lapply((i + 1):length(dataframes), function(j) {
                    df.union <- merge(
                        dataframes[[i]],
                        dataframes[[j]],
                        by = "Clonotype",
                        all.y = TRUE,
                        all.x = TRUE
                    )

                    # --- clonotype scatter plot ---
                    saveName <- file.path(
                        outputPath,
                        paste0(
                            sampleNames[i],
                            "_vs_",
                            sampleNames[j],
                            "_clone_scatter.png"
                        )
                    )
                    # square plot to get a evenly scaled scatter plot on both the x and y axis
                    png(
                        saveName,
                        width = V_WIDTH,
                        height = V_WIDTH,
                        units = "in",
                        res = 500,
                        pointsize = 10
                    )
                    .scatterPlotComplex(df.union,
                                        dataframes[[i]],
                                        dataframes[[j]],
                                        sampleNames[i],
                                        sampleNames[j],
                                        "CDR3")
                    dev.off()
                    # too large to save, skip this!
                    # .saveAs(.save, saveName, p)

                    # make all NAs 0 before conducting distance / similarity analyses
                    df.union <- replace(df.union, is.na(df.union), 0)

                    # --- pearson correlation of clonotype frequencies ---
                    correlations <-
                        suppressWarnings(.correlationTest(df.union))


                    # --- Morisita Horn, Jaccard, and Dice distance scores ---
                    distance <- .distanceMeasure(df.union)


                    data.frame(
                        from = sampleNames[i],
                        to = sampleNames[j],
                        morisita.horn = distance$morisita.horn,
                        jaccard = distance$jaccard,
                        bray.curtis = distance$bray.curtis,
                        pearson = correlations$pearson,
                        pearson.p = correlations$pearson.p,
                        spearman = correlations$spearman,
                        spearman.p = correlations$spearman.p
                    )
                }))
            }))
        # what df should loop like now: length(sampleNames) Choose 2 rows
        # +------------------------------------------------------------------------------------------------+
        # |from | to | morisita.horn | jaccard | bray.curtis | pearson | pearson.p | spearman | spearman.p |
        # +------------------------------------------------------------------------------------------------+
        # | ...                                                                                            |
        # +------------------------------------------------------------------------------------------------+
        # step 1. save the dataframe as a TSV file
        # NOTE: this saves the dataframe in a unidirectional format. That is,
        # from - to pairings will not repeat (since to - from will have the exact
        # same row values). Hence, to reload this table as a symmetric matrix,
        # more work will have to be done (need to reflect matrix on the diag).
        # The diagnoal must be defined during load too. (see .loadMatrixFromDF)
        write.table(
            file = file.path(outputPath, "distance_indices.tsv"),
            df,
            quote = FALSE,
            row.names = FALSE,
            sep = "\t"
        )

        # step 2. plot and save the correlograms
        lapply(c("pearson", "spearman"), function(method) {
            mat <- .loadMatrixFromDF(df, value.var = method, diag = 1)
            mat.pval <-
                .loadMatrixFromDF(df,
                                  value.var = paste0(method, ".p"),
                                  diag = 0)
            p <- ggcorrplot(
                mat,
                lab = TRUE,
                ggtheme = theme_bw,
                p.mat = mat.pval,
                title = paste(.capitalize(method), "correlation"),
                hc.order = TRUE,
                type = "lower",
                outline.color = "white",
                colors = c("#053061", "#F7F7F7", "#67001F") # see brewer.pal(11, "RdBu")
            )
            saveName <- file.path(outputPath, paste0(method, ".png"))
            ggsave(saveName,
                   plot = p,
                   width = V_WIDTH,
                   height = V_HEIGHT)
            .saveAs(.save, saveName, p)
        })

        # step 3. plot sand save the hierarchical dendrograms
        lapply(c("morisita.horn", "jaccard", "bray.curtis"), function(method) {
            mat <- .loadMatrixFromDF(df, value.var = method, diag = 0)
            g <-
                ggdendro::ggdendrogram(hclust(as.dist(mat), method = "complete"),
                                       rotate = TRUE) +
                labs(title = paste(.capitalize(sub(
                    ".", " ", method, fixed = TRUE
                )),
                "hierarchical dendrogram")) +
                theme(panel.border = element_blank(),
                      panel.grid = element_blank())

            saveName <- file.path(outputPath,
                                  paste0(sub(".", "_", method, fixed = TRUE),
                                         ".png"))
            ggsave(saveName,
                   plot = g,
                   width = V_WIDTH,
                   height = V_HEIGHT)
            .saveAs(.save, saveName, g)
        })

    }


#' Comprehensive clonotype analyses
#'
#' @include util.R
#'
#' @import ggplot2
#'
#' @param diversityDirectories list type. List of directories to diversity dir
#' @param clonotypeOut string type. Output directory
#' @param sampleNames vector type. 1-1 with diversityDirectories
#' @param mashedNames string type. Prefix for ooutput files using "mashed-up"
#' @param .save logical type. Save ggplot object?
#'
#' @return Nothing
.clonotypeAnalysis <- function(diversityDirectories,
                               clonotypeOut,
                               sampleNames,
                               mashedNames,
                               .save = TRUE) {

    message("Starting clonotype analysis on samples ",
            paste(sampleNames, collapse = ", "))

    cdr3ClonesFile <- .listFilesInOrder(path = diversityDirectories,
                                        pattern = ".*_cdr3_clonotypes_.*_over\\.csv(\\.gz)?$")
    if (length(cdr3ClonesFile) == length(sampleNames)) {
        dataframes <- lapply(cdr3ClonesFile, function(fname) {
            df <- read.csv(fname, stringsAsFactors = FALSE)
            df$prop <- df$Count / sum(df$Count)
            return(df[, c("Count", "Clonotype", "prop")])
        })

        # all vs all comparisons (scatter plot, similarity, etc ...)
        .pairwiseComparison(dataframes, sampleNames, clonotypeOut, .save = .save)

        # venn diagram
        .vennIntersection(dataframes, sampleNames,
                          file.path(clonotypeOut,
                                    paste0(mashedNames,
                                           "_cdr3_clonotypeIntersection.png")))
        # top 10 barplot
        g <- .topNDist(dataframes, sampleNames)
        saveName <- file.path(clonotypeOut,
                              paste0(mashedNames, "_top10Clonotypes.png"))
        ggsave(saveName,
               plot = g,
               width = V_WIDTH_L,
               height = V_HEIGHT_L)
        .saveAs(.save, saveName, g)
    } else {
        warning("Skipping clonotype analysis for ",
                paste(sampleNames, collpse = ", "),
                ", can't find required CSVs, expected ",
                length(sampleNames),
                " but got ",
                length(cdr3ClonesFile),
                " instead.")
    }
}

#' Conducts pearson and spearman correlation analysis on dataframe
#'
#' @import stats
#'
#' @param df dataframe with at least the following 2 columns:
#' +-----------------+
#' | prop.x | prop.y |
#' +-----------------+
#' |.....   | ....   |
#' +-----------------+
#' where prop.x and prop.y are normalized counts (i.e. frequencies) of the clones
#' They may contain 0 in a column to denote it being missing from sample x or y.
#' @return named list of pearson, pearson.p, spearman, spearman.p
.correlationTest <- function(df) {
    df <- df[, c("prop.x", "prop.y")]
    pearson <- cor.test(df$prop.x, df$prop.y, method = "pearson")
    spearman <- cor.test(df$prop.x, df$prop.y, method = "spearman")
    # return values:
    # [1] "statistic"   "parameter"   "p.value"     "estimate"    "null.value"
    # [6] "alternative" "method"      "data.name"
    list(
        pearson = as.numeric(pearson$estimate),
        pearson.p = as.numeric(pearson$p.value),
        spearman = as.numeric(spearman$estimate),
        spearman.p = as.numeric(spearman$p.value)
    )
}


#' Computes the distance between pariwise samples
#'
#' @param df dataframe with at least the following 2 columns:
#' +-----------------+
#' | prop.x | prop.y |
#' +-----------------+
#' |.....   | ....   |
#' +-----------------+
#' where prop.x and prop.y are normalized counts (i.e. frequencies) of the clones
#' They may contain 0 in a column to denote it being missing from sample x or y.
#'
#' @return named list of bray.curtis, jaccard, and morisita.horn
.distanceMeasure <- function(df) {
    # at the very minimum
    # jaccard
    # sorensen
    # morisita-horn

    df.prop <- t(df[, c("prop.x", "prop.y")])

    # sorensen:
    bray.curtis <- as.numeric(vegdist(df.prop, method = "bray"))
    # jaccard: see ?vegandist to understand this:
    jaccard <- (2 * (bray.curtis)) / (1 + bray.curtis)
    # morisita-horn:
    morisita.horn <- as.numeric(vegdist(df.prop, method = "horn"))

    list(
        bray.curtis = bray.curtis,
        jaccard = jaccard,
        morisita.horn = morisita.horn
    )

}

#' Duplication level plot
#'
#' @description bins singletons, doubletons, and higher order clonotypes
#' into a line plot
#'
#' @import ggplot2
#' @include util.R
#'
#' @param files list type. List of strings to _cdr_v_duplication.csv pathname
#' @param sampleNames vector type. Vector of strings each representing
#' sample names
#' @param regions vector type.
#'  Which regions to include in the plot. Default = c("CDR3", "V")
#'
#' @return ggplot2 object
.plotDuplication <-
    function(files, sampleNames, regions = c("CDR3", "V")) {
        nsamples <- length(files)

        if (nsamples != length(sampleNames)) {
            stop("Expected equal number of sample names and dataframes, got ",
                 length(sampleNames),
                 " samples and ",
                 nsamples, " dataframes.")
        }

        message("Creating duplication plot for samples ",
                paste(sampleNames, collapse = ", "))

        # read xticks and xlimits from first 2 row
        trimwsNoQuotes <- function(x) {
            gsub("'", "", trimws(x))
        }

        # trimwsNoQuotes strips whitespaces AND single quotes
        fp <- file(files[[1]], "r")
        xticks <-
            strtoi(unlist(lapply(strsplit(
                readLines(fp, n = 1), ","
            )[[1]],
            trimws)))
        xlabels <-
            unlist(lapply(strsplit(readLines(fp, n = 1), ",")[[1]],
                          trimwsNoQuotes))
        close(fp)

        # read files into dataframes
        dataframes <- lapply(files, read.csv, skip = 2)

        # pre-processing & cleanup
        for (i in seq_len(nsamples)) {
            df <- dataframes[[i]]
            df$sample  <- sampleNames[[i]]
            dataframes[[i]] <- df[df$region %in% regions,]
        }

        # combine!
        df.union <- do.call("rbind", dataframes)

        g <- ggplot(df.union, aes(x = x, y = y))

        if (nsamples == 1) {
            g <- g + geom_line(aes(linetype = region),
                               color = BLUEHEX,
                               size = 0.65) +
                guides(color = FALSE)
        } else {
            g <- g + geom_line(aes(linetype = region, color = sample),
                               size = 0.65)
        }

        g <- g +
            scale_linetype_manual(values = .getLineTypes(regions)) +
            scale_x_continuous(breaks = xticks, labels = xlabels) +
            labs(
                title = paste(
                    "Sequence duplication levels of",
                    paste(regions, collapse = ", "),
                    "in",
                    paste(sampleNames, collapse = ", ")
                ),
                x = "Duplication level",
                y = "Proportion of duplicated sequences"
            ) +
            theme_bw() +
            theme(axis.text.x = element_text(angle = 45, hjust = 1))
        return(g)
    }




#' Rarefaction plot
#'
#' @description Plots the number of unique clonotypes (on the y-axis)
#' drawn from a sample size on the x axis. The number of unique clonotypes
#' is averaged over 5 repeated rounds.
#'
#' @import ggplot2
#' @include util.R
#'
#' @param files list type. A list of files consisting of path to samples
#' @param sampleNames vector type. A vector of strings,
#'  each being the name of samples in files
#' @param regions vector type. A vector of strings,
#' regions to be included. Defaults to c("CDR3", "V")
#'
#' @return ggplot2 object
.plotRarefaction <-
    function(files, sampleNames, regions = c("CDR3", "V")) {
        nsamples <- length(files)
        # sanity check
        if (length(sampleNames) != nsamples) {
            stop("Expected equal number of sample names and dataframes, got ",
                 length(sampleNames),
                 " samples and ",
                 nsamples, " dataframes.")
        }

        message("Creating rarefaction plot for samples ",
                paste(sampleNames, collapse = ", "))

        # find the minimum xtick value from all the samples to plot as the
        # max xtick value on the actual graph (i.e. the graph is truncated to the
        # smallest maximum xtick value from the pool of samples)
        fp <- file(files[[1]], "r")
        xticks <-
            strtoi(unlist(lapply(strsplit(
                readLines(fp, n = 1), ","
            )[[1]],
            trimws)))
        close(fp)

        # if there are more
        if (nsamples > 1) {
            for (i in 2:nsamples) {
                fp <- file(files[[i]], "r")
                candidate <- strtoi(unlist(lapply(
                    strsplit(readLines(fp, n = 1), ",")[[1]], trimws
                )))
                close(fp)
                if (tail(candidate, n = 1) < tail(xticks, n = 1)) {
                    xticks <- candidate
                }
            }
        }

        # read files
        dataframes <- lapply(files, read.csv, skip = 1)

        # pre-processing & cleaning
        for (i in seq_len(nsamples)) {
            df <- dataframes[[i]]
            df$sample <- sampleNames[[i]]
            df <- df[df$region %in% regions,]
            dataframes[[i]] <- .summarySE(df,
                                          measurevar = 'y',
                                          groupvars = c('x', 'region', 'sample'))
        }

        # merge
        df.union <- do.call("rbind", dataframes)

        # make compound column of region . sample for geom_ribbon
        df.union$compound <- paste(df.union$sample, df.union$region)

        g <- ggplot(df.union, aes(x = x, y = y))

        if (nsamples == 1) {
            g <- g + geom_line(aes(linetype = region),
                               color = BLUEHEX,
                               size = 0.65) +
                guides(color = FALSE)
        } else {
            g <- g +
                geom_line(aes(linetype = region, color = sample), size = 0.65)
        }

        g <- g +
            scale_linetype_manual(values = .getLineTypes(regions)) +
            scale_x_continuous(breaks = xticks,
                                    limits = c(head(xticks, n = 1),
                                               tail(xticks, n = 1))) +
            geom_ribbon(
                aes(
                    ymin = y - ci,
                    ymax = y + ci,
                    fill = compound
                ),
                alpha = 0.1,
                show.legend = FALSE
            ) +
            labs(
                title = paste(
                    "Rarefaction of",
                    paste(regions, collapse = ", "),
                    "in",
                    paste(sampleNames, collapse = ", ")
                ),
                subtitle = "Mean number of deduplicated sequences with 95% confidence interval",
                x = 'Sample size',
                y = "Number of deduplicated sequences"
            ) +
            theme_bw() +
            theme(axis.text.x = element_text(angle = 90, hjust = 1))
        return(g)
    }



#' Plots capture-recapture
#'
#' @description Plots the percent of recapture clonotypes (on the y-axis)
#' drawn from a repeated (with replacement) sample size on the x axis. The
#' percentage of recaptured clonotypes is averaged over 5 recapture rounds.
#'
#' @import ggplot2
#' @include util.R
#'
#' @param files list type. List of _cdr_v_recapture.csv.gz files.
#' @param sampleNames vector type. A vector of strings each
#' representing the name of samples in files.
#' @param regions vector type. A vector of strings,
#' regions to be included in the plot. defaults to c("CDR3", "V")
#'
#' @return ggplot2 object
.plotRecapture <-
    function(files, sampleNames, regions = c("CDR3", "V")) {
        nsamples <- length(files)
        # sanity check
        if (nsamples != length(sampleNames)) {
            stop("Expected equal number of sample names and dataframes, got ",
                 length(sampleNames),
                 " samples and ",
                 nsamples, " dataframes.")
        }

        message("Creating recapture plot for samples ",
                paste(sampleNames, collapse = ", "))

        # find the minimum xtick value from all the samples to plot as the
        # max xtick value on the actual graph (i.e. the graph is truncated to the
        # smallest maximum xtick value from the pool of samples)
        fp <- file(files[[1]], "r")
        xticks <-
            strtoi(unlist(lapply(strsplit(
                readLines(fp, n = 1), ","
            )[[1]],
            trimws)))
        close(fp)

        # if there are more
        if (nsamples > 1) {
            for (i in 2:nsamples) {
                fp <- file(files[[i]], "r")
                candidate <- strtoi(unlist(lapply(
                    strsplit(readLines(fp, n = 1), ",")[[1]], trimws
                )))
                close(fp)
                if (tail(candidate, n = 1) < tail(xticks, n = 1)) {
                    xticks <- candidate
                }
            }
        }

        # read dataframes
        dataframes <- lapply(files, read.csv, skip = 1)

        # cleanup & pre-processing
        for (i in seq_len(nsamples)) {
            df <- dataframes[[i]]
            # append sample name to a new column named sample
            df$sample <- sampleNames[[i]]
            # only want selected regions - ignore others
            df <- df[df$region %in% regions, ]
            # get mean, sd, se, and ci
            dataframes[[i]] <- .summarySE(df,
                                          measurevar = 'y',
                                          groupvars = c("x", "region", "sample"))
        }

        df.union <- do.call("rbind", dataframes)

        # make compound column for geom_ribbon (region . sample)
        df.union$compound <- paste(df.union$region, df.union$sample)

        # plot!
        p <- ggplot(df.union, aes(x = x, y = y))

        if (nsamples == 1) {
            p <- p + geom_line(aes(linetype = region),
                               color = BLUEHEX,
                               size = 0.65) +
                guides(color = FALSE)
        } else {
            p <- p +
                geom_line(aes(linetype = region, color = sample), size = 0.65)
        }

        p <- p +
            scale_linetype_manual(values = .getLineTypes(regions)) +
            scale_x_continuous(breaks = xticks) +
            geom_ribbon(
                aes(
                    ymin = y - ci,
                    ymax = y + ci,
                    fill = compound
                ),
                alpha = 0.1,
                show.legend = FALSE
            ) +
            labs(
                title = paste(
                    "Percent recapture of",
                    paste(regions, collapse = ", "),
                    "in",
                    paste(sampleNames, collapse = ", ")
                ),
                subtitle = "Mean number of recaptured sequences with 95% confidence interval",
                x = "Sample size",
                y = "Percent Recapture"
            ) + theme_bw() +
            theme(axis.text.x = element_text(angle = 90, hjust = 1))

        return(p)
    }


#' Title Shows varying regions for a given clonotype defined by its CDR3
#'
#' @import reshape2
#' @import ggplot2
#'
#' @param path string type. Path to diversity folder
#' where <sampleName>_clonotype_diversity_region_analysis.csv.gz is located
#' @param sampleName string type
#' @param top int type. Top N number of clones to analyze
#'
#' @return ggplot2 object
.regionAnalysis <- function(path, sampleName, top = 15) {
    message("Starting clonotype region analysis for ", sampleName)

    df <- read.csv(
        paste0(
            path,
            sampleName,
            "_clonotype_diversity_region_analysis.csv.gz"
        ),
        stringsAsFactors = FALSE
    )

    headers <- c("fr1", "cdr1", "fr2", "cdr2", "fr3", "fr4")
    # sort the df with decreasing counts of CDR3 occurance
    df <- df[with(df, order(-count)),]

    # add new column to sum the "unique" regions
    df$sumcounts = rowSums(df[, headers])

    # grab only those whos V-domain will differ.
    #  This means sumcounts != 6 (> 6) where 6 = length(headers)
    df <- df[df$sumcounts > 6,]

    # grab top N
    df <- head(df, top)

    # add new row as reference of "unique regions"
    de <- data.frame("REFERENCE", Inf, 1, 1, 1, 1, 1, 1, 6)
    names(de) <- names(df)
    df <- rbind(df, de)


    # reshape to multi-row
    df.mel <- melt(df, measure.vars = headers)
    df.mel[, "value"] = df.mel[, "value"] / df.mel[, "sumcounts"]


    # plot!
    g <- ggplot(df.mel,
                aes(
                    x = cdr3,
                    y = value,
                    fill = variable,
                    label = sprintf("%0.2f%%",
                                    round(value * 100, digits = 2))
                )) +
        geom_bar(stat = 'identity') +
        theme(text = element_text(size = 10),
              axis.text.x = element_text(angle = 65, hjust = 1)) +
        #geom_text(position = position_stack(vjust = 0.5)) +
        #stat_summary(fun.y = sum, aes(label = sumcounts, group=cdr3),
        #             geom='text', vjust=-.2) +
        labs(
            title = paste(
                sampleName,
                "varying levels of FRs and CDRs of top",
                top,
                "CDR3 clonotype"
            ),
            subtitle = "Counts of unique regions for a given CDR3",
            x = "CDR3",
            y = "Proportion"
        ) +
        guides(fill = guide_legend(title = "Region")) +
        scale_x_discrete(limits = c("REFERENCE", head(df, -1)$cdr3))
    return(g)
}

#' Composition logo plot
#'
#' @description Plots 2 kinds: scaled and unscaled composition logos
#'
#' @param compositionDirectory string type.
#' @param outdir string type.
#' @param sampleName string type.
#' @param regions logical type. vector of FR/CDR regions to plot
#' @param .save logical type. save ggplot object
#'
#' @import stringr
#'
#' @return none
.aminoAcidPlot <- function(compositionDirectory,
                           outdir,
                           sampleName,
                           regions = c("FR1", "CDR1", "FR2", "CDR2", "FR3", "CDR3", "FR4"),
                           .save = TRUE) {
    for (region in regions) {
        dirName <- file.path(compositionDirectory, region)
        outputPath <- file.path(outdir, region)
        if (!dir.exists(outputPath)) {
            dir.create(outputPath)
        }

        summaryPlot <-
            file.path(dirName, paste0(sampleName, "_cumulative_logo.csv"))
        df <- read.csv(summaryPlot)
        g1 <- .aminoAcidBar(df, scale = FALSE, region)
        g2 <- .aminoAcidBar(df, scale = TRUE, region)
        fname <-
            file.path(outputPath,
                      paste0(sampleName, "_cumulative_logo.png"))
        fnameScaled <-
            file.path(outputPath,
                      paste0(sampleName, "_cumulative_logo_scaled.png"))
        ggsave(fname, plot = g1, width = V_WIDTH, height = V_HEIGHT)
        ggsave(fnameScaled, plot = g2, width = V_WIDTH, height = V_HEIGHT)
        .saveAs(.save, fname, g1)
        .saveAs(.save, fnameScaled, g2)

        germlineSpecific <-
            list.files(
                path = dirName,
                pattern = paste0(sampleName,
                                 "_.+_cumulative_logo\\.csv(\\.gz)?$"),
                full.names = TRUE
            )

        lapply(germlineSpecific, function(gLogoFile) {
            germName <- sub(
                "_cumulative_logo\\.csv(\\.gz)?$",
                "",
                stringr::str_extract(gLogoFile, "IG[HKL][VDJ].*")
            )
            df <- read.csv(gLogoFile)
            g1 <-
                .aminoAcidBar(df, scale = FALSE, region, germ = germName)
            g2 <-
                .aminoAcidBar(df, scale = TRUE, region, germ = germName)
            fname <-
                file.path(outputPath,
                          paste0(sampleName, "_", germName, "_cumulative_logo.png"))
            fnameScaled <-
                file.path(
                    outputPath,
                    paste0(
                        sampleName,
                        "_",
                        germName,
                        "_cumulative_logo_scaled.png"
                    )
                )
            ggsave(fname, plot = g1, width = V_WIDTH, height = V_HEIGHT)
            ggsave( fnameScaled, plot = g2, width = V_WIDTH, height = V_HEIGHT)
            .saveAs(.save, fname, g1)
            .saveAs(.save, fnameScaled, g2)
        })
    }
}

#' Plots amino acid composition logo
#'
#' @import ggplot2 stats
#'
#' @param df dataframe
#' @param scale logical. scale to proportion?
#' @param region string. which region is this
#' @param germ string. V germline family
#'
#' @return ggplot2 object
.aminoAcidBar <- function(df, scale, region, germ = "") {
    # oranges(G - T), greens(C - W), purples (N - H), reds (D, E), blues (K, R)
    group.colors <-
        c(
            G = "#e65c00",
            A = "#ff751a",
            S = "#ff8533",
            T = "#ff944d",
            C = "#003300",
            V = "#145214",
            I = "#006622",
            L = "#1f7a1f",
            P = "#009933",
            F = "#29a329",
            Y = "#00b33c",
            M = "#2eb82e",
            W = "#33cc33",
            N = "#330066",
            Q = "#4d0099",
            H = "#6600cc",
            D = "#990000",
            E = "#b30000",
            K = "#000099",
            R = "#0000cc"
        )
    df.agg <- aggregate(count ~ position, df, sum)

    # get the max counts for each position - then xlabel will contain
    # the amino acid character for that position - break ties on first occurance
    df.max <- merge(aggregate(count ~ position, df, max), df)
    df.max <- df.max[!duplicated(df.max[c(1, 2)]),]
    xlabels <-
        lapply(df.max[with(df.max, order(position)),]$aa, as.character)

    total <- max(df.agg$count)
    if (scale) {
        df$proportion <- df$count / total
        subs <- "Scaled to proportion"
    } else {
        df.tmp <- merge(df, df.agg, by = "position")
        df.tmp <- df.tmp[with(df.tmp, order(position)),]
        # if not scaled, divide within its own position rather than
        # overall (i.e. the max)
        df$proportion <- df.tmp$count.x / df.tmp$count.y
        subs <- ""
    }

    df$aa <-
        factor(
            df$aa,
            levels = c(
                "G",
                "A",
                "S",
                "T",
                "C",
                "V",
                "I",
                "L",
                "P",
                "F",
                "Y",
                "M",
                "W",
                "N",
                "Q",
                "H",
                "D",
                "E",
                "K",
                "R"
            )
        )
    g <- ggplot(df, aes(x = position, y = proportion)) +
        geom_bar(stat = "identity", aes(fill = aa)) +
        labs(
            title = paste0(germ, " ", region, " (", total, ")"),
            subtitle = subs,
            x = "amino acid",
            y = "proportion"
        ) +
        scale_x_continuous(breaks = df.agg$position, labels = xlabels) +
        scale_fill_manual(values = group.colors, drop = FALSE) +
        theme(legend.title = element_blank(),
              legend.text = element_text(size = 5))
    return(g)
}

##  dataframe is something like:
##  +--------------------------+
##  | Clonotype | Count | prop |
##  +--------------------------+
##  |           |       |      |
##  |           |       |      |
##  |           |       |      |
##  |  .......  |  ...  | .... |
##  +--------------------------+
#' Reports abundance-based (Lower bound) diversity estimates using the Vegan package
#'
#' @import vegan
#'
#' @param df clonotype dataframe. Vegan format:
#' +---------------------------+
#' | S.1| S.2| S.3 | S.4 | ... |   (each species should have its own column)
#' +---------------------------+
#' | v1 |v2  | v3  | ....      |   (each species' count values are placed in the corresponding column)
#' +---------------------------+
#'
#' @return dataframe with the format:
#' +----------------------------------------------------------------+
#' | S.obs | S.chao1 | se.chao1 | S.ACE | se.ACE | s.jack1 | s.jack2|
#' +----------------------------------------------------------------+
#' | v1    |  v2 ....                                               |
#' +----------------------------------------------------------------+
.reportLBE <- function(df) {
    f1.f2 <- unlist(lapply(seq_len(2), function(i) {
        sum(df[1,] == i)
    }))

    lbe <- estimateR(df)
    s.obs <- lbe[1]
    s.jack1 <- s.obs + f1.f2[1]
    s.jack2 <- s.obs + 2 * f1.f2[1] - f1.f2[2]

    lbe <-
        rbind(as.data.frame(lbe),
              S.jack1 = s.jack1,
              S.jack2 = s.jack2)

    df.out <- as.data.frame(t(lbe[, 1]))
    names(df.out) <- rownames(lbe)
    return(df.out)
}

#' Calculates the "standard" diversity indices
#'
#' @import vegan
#'
#' @param df clonotype dataframe. Vegan format:
#' +---------------------------+
#' | S.1| S.2| S.3 | S.4 | ... |   (each species should have its own column)
#' +---------------------------+
#' | v1 |v2  | v3  | ....      |   (each species' count values are placed in the corresponding column)
#' +---------------------------+
#'
#' @return dataframe with the column headers:
#' shannon , simpson.con , simpson.inv , simpson.gini , renyi.0 ,
#' renyi.1 , renyi.2 , renyi.Inf , hill.0 , hill.1 , hill.2 , hill.Inf
#'
#' renyi.0 => species richness
#' renyi.1 => shannon entropy
#' renyi.2 => inv.gini
#' renyi.Inf => min.entropy
#'
#' finally:
#'    hill_a = exp(renyi_a)
#'
.calculateDInd <- function(df) {
    renyi.scales = c(0, 1, 2, Inf)
    renyi <- renyi(df, scales = renyi.scales)
    hill <- exp(renyi)
    shannon <- vegan::diversity(df, index = "shannon")
    simpson <- vegan::diversity(df, index = "simpson")
    n.species <- ncol(df)

    as.data.frame(
        cbind(
            shannon = shannon,
            shannon.norm = shannon / log(n.species),
            simpson.gini = simpson,
            simpson.inv = vegan::diversity(df, index = "invsimpson"),
            simpson.con = 1 - simpson,
            renyi.0 = renyi['0'],
            renyi.1 = renyi['1'],
            renyi.2 = renyi['2'],
            renyi.Inf = renyi['Inf'],
            hill.0 = hill['0'],
            hill.1 = hill['1'],
            hill.2 = hill['2'],
            hill.Inf = hill['Inf']
        )
    )
}


#' Title Diversity analysis
#'
#' @import ggplot2
#' @include util.R
#' @include distributions.R
#'
#' @param diversityDirectories list type. List of directories to diversity dir
#' @param diversityOut string type. Output directory
#' @param sampleNames vector type. 1-1 with diversityDirectories
#' @param mashedNames string type. Prefix for output files using "mashed-up"
#' sample names
#' @param .save logical type. Save ggplot object?
#'
#' @return None
.diversityAnalysis <- function(diversityDirectories,
                               diversityOut,
                               sampleNames,
                               mashedNames,
                               .save = TRUE) {
    message("Starting diversity analysis on samples ",
            paste(sampleNames, collapse = ", "))

    # fr/cdr plots --------------------------------------------------------
    # plot duplication, rarefaction, recapture
    lapply(c("cdr", "cdr_v", "fr"), function(region) {
        .plotDiversityCurves(region, diversityDirectories,
                             sampleNames, mashedNames,
                             diversityOut, .save = .save)
    })

    # generate FR1-4, CDR1-3, CDR3 no outliers, and V spectratypes -------
    .generateAllSpectratypes(diversityDirectories,
                             diversityOut,
                             sampleNames,
                             mashedNames,
                             .save = .save)

    # generate composition logos -----------------------------------------
    # not applicable to multi-sample scenario
    if (length(sampleNames) == 1) {
        compDir <- file.path(diversityDirectories[[1]], "composition_logos")
        compOut <- file.path(diversityOut, "composition_logos")
        if (!file.exists(compOut)) {
            dir.create(compOut)
        }
        message("Plotting composition logos on samples ",
                paste(sampleNames, collapse = ", "))
        .aminoAcidPlot(compDir, compOut, sampleNames[1])
    }

    # we can plot region analysis if there's only one sample
    # this feature is disabled until the backend has been optimized
    #if (length(sampleNames) == 1) {
    #  # default = top 15
    #  g <- .regionAnalysis(diversityOut, sampleNames[1])
    #  ggsave(paste0(diversityOut, mashedNames, "_region_analysis.png"),
    #         plot = g, width = V_WIDTH, height = V_HEIGHT)
    #}

    # Calculate Lower Bound Estimate and diversity indices --------------------
    .calculateDiversityEstimates(diversityDirectories,
                                 diversityOut,
                                 sampleNames)
}

#' Plots rarefaction, recapture, and de-dup plots for specified \code{region}
#'
#' @import ggplot2
#' @include util.R
#' @include distributions.R
#'
#' @param region string type. One of: "cdr", "cdr_v", and "fr". "cdr" means
#' CDR1-3, "cdr_v" means CDR3 and V only, and finally "fr" means FR1-4.
#' @param diversityDirectories list type. List of directories to diversity dir
#' @param sampleNames vector type. 1-1 with diversityDirectories
#' @param mashedNames string type. Prefix for output files using "mashed-up"
#' @param diversityOut string type. Output directory sample names
#' @param .save logical type. Save ggplot object?
#'
#' @return Nothing
.plotDiversityCurves <- function(region,
                                 diversityDirectories,
                                 sampleNames,
                                 mashedNames,
                                 diversityOut,
                                 .save = TRUE) {
    if (region == "cdr") {
        includedRegions <- c("CDR1", "CDR2", "CDR3")
    } else if (region == "cdr_v") {
        includedRegions <- c("CDR3", "V")
    } else {
        includedRegions <- c("FR1", "FR2", "FR3")
    }

    plotTypes <- c("duplication" = .plotDuplication,
                   "rarefaction" = .plotRarefaction,
                   "recapture" = .plotRecapture)

    lapply(seq_along(plotTypes), function(i) {
        functor <- plotTypes[[i]]
        ptype <- names(plotTypes)[[i]]

        searchFiles <-
            .listFilesInOrder(path = diversityDirectories,
                              pattern =  paste0(".*_", region,
                                                "_", ptype, "\\.csv(\\.gz)?$"))
        if (length(searchFiles) > 0) {
            g <- functor(searchFiles, sampleNames, includedRegions)
            saveName <-
                file.path(diversityOut,
                          paste0(mashedNames, "_", region, "_", ptype, ".png"))
            ggsave(saveName,
                   plot = g,
                   width = V_WIDTH,
                   height = V_HEIGHT)
            .saveAs(.save, saveName, g)
        } else {
            warning("Could not find ", ptype, " files in ",
                    paste(diversityDirectories, collapse = ", "))
        }
    })
}



#' Generates all FR/CDR spectratypes
#'
#' @import ggplot2
#' @include util.R
#' @include distributions.R
#'
#' @param diversityDirectories list type. List of directories to diversity dir
#' @param diversityOut string type. Output directory
#' @param sampleNames vector type. 1-1 with diversityDirectories
#' @param mashedNames string type. Prefix for output files using "mashed-up"
#' sample names
#' @param .save logical type. Save ggplot object?
#'
#' @return Nothing
.generateAllSpectratypes <- function(diversityDirectories,
                                     diversityOut,
                                     sampleNames,
                                     mashedNames,
                                     .save = TRUE) {
    specOut <- file.path(diversityOut, "spectratypes")
    if (!file.exists(specOut)) {
        dir.create(specOut)
    }
    message("Plotting spectratypes on samples ",
            paste(sampleNames, collapse = ", "))

    regionTypes <- list("cdr" = seq_len(3), "fr" = seq_len(4))
    lapply(seq_along(regionTypes), function(i) {
        # grab the region (CDR/FR)
        region <- names(regionTypes)[[i]]
        # for CDR, 1-3, else 1-4
        lapply(regionTypes[[i]], function(j) {
            specFiles <-
                .listFilesInOrder(path = diversityDirectories,
                                  pattern = paste0(".*_",
                                                   region,
                                                   j,
                                                   "_spectratype\\.csv(\\.gz)?$"))
            if (length(specFiles) > 0) {
                g <- .plotSpectratype(lapply(specFiles, read.csv,
                                             stringsAsFactors = FALSE),
                                      sampleNames,
                                      paste0(toupper(region), j))
                saveName <- file.path(specOut,
                                      paste0(mashedNames,
                                             "_",
                                             region,
                                             j,
                                             "_spectratype.png"))
                ggsave(saveName,plot = g, width = V_WIDTH, height = V_HEIGHT)
                .saveAs(.save, saveName, g)
            } else {
                warning("Could not find ",
                        region, j, " spectratype files in ",
                        paste(diversityDirectories, collapse = ", "))
            }
        })
    })

    # special case, no outliers plot for CDR3 only
    specFiles <-
        .listFilesInOrder(path = diversityDirectories,
                          pattern = ".*_cdr3_spectratype_no_outliers\\.csv(\\.gz)?$")

    if (length(specFiles) > 0) {
        g <-
            .plotSpectratype(lapply(specFiles, read.csv, stringsAsFactors = FALSE),
                             sampleNames,
                             "CDR3")
        saveName <-
            file.path(specOut,
                      paste0(mashedNames, "_cdr3_spectratype_no_outliers.png"))
        ggsave(saveName, plot = g, width = V_WIDTH, height = V_HEIGHT)
        .saveAs(.save, saveName, g)
    } else {
        warning("Could not find CDR3 spectratype (no outlier) files in ",
                paste(diversityDirectories, collapse = ", "))
    }

    # entire V-domain
    specFiles <- .listFilesInOrder(path = diversityDirectories,
                                   pattern = ".*_v_spectratype\\.csv(\\.gz)?$")
    if (length(specFiles) > 0) {
        g <-
            .plotSpectratype(
                lapply(specFiles, read.csv, stringsAsFactors = FALSE),
                sampleNames,
                "V domain")
        saveName <-
            file.path(specOut, paste0(mashedNames, "_v_spectratype.png"))
        ggsave(saveName, plot = g, width = V_WIDTH, height = V_HEIGHT)
        .saveAs(.save, saveName, g)
    } else {
        warning("Cound not find V spectratype files in ",
                paste(diversityDirectories, collapse = ", "))
    }
}


#' Calculates Lower Bound Estimates for unseen species and Common Diversity
#' Indices from clonotype tables
#'
#' @description Employ common techniques to calculate LBE for unseen species
#' and commonly used diversity indices
#'
#' @import tools
#' @include util.R
#' @include distributions.R
#'
#' @param diversityDirectories list type. List of directories to diversity dir
#' @param diversityOut string type. Output directory
#' @param sampleNames vector type. 1-1 with diversityDirectories sample names
#'
#' @return None
.calculateDiversityEstimates <- function(diversityDirectories,
                                         diversityOut,
                                         sampleNames) {
    cdr3ClonesFile <- .listFilesInOrder(path = diversityDirectories,
                                        pattern = ".*_cdr3_clonotypes_.*_over\\.csv(\\.gz)?$")

    if (length(cdr3ClonesFile) != length(sampleNames)) {
        warning(paste(sampleNames, collapse = ", "),
                " is missing CDR3 clonotype counts file, ",
                "skipping LBE and IND analysis.")
        return()
    }

    # dataframes is in vegan input format, the clonotypes are
    # now column headers instead of column values
    dataframes <- lapply(cdr3ClonesFile, function(fname) {
        df <- read.csv(fname, stringsAsFactors = FALSE)
        d.trans <- as.data.frame(t(df[, "Count"]))
        return(d.trans)
    })

    lb.fname <- "lower_bound_estimate.tsv"
    ind.fname <- "diversity_indices.tsv"

    estimateTypes <- list(.reportLBE, .calculateDInd)
    names(estimateTypes) <- c(lb.fname, ind.fname)
    outputFiles <- c(file.path(diversityOut, lb.fname),
                     file.path(diversityOut, ind.fname))

    lapply(seq_along(estimateTypes), function(i) {
        if (!file.exists(outputFiles[[i]])) {
            fileName <- names(estimateTypes)[[i]]
            fileNameSansExt <- tools::file_path_sans_ext(fileName)
            functor <- estimateTypes[[i]]

            files <-
                .listFilesInOrder(path = diversityDirectories,
                                  pattern = paste0(fileNameSansExt,
                                                   "\\.tsv(\\.gz)?$"))

            if (length(files) != length(sampleNames)) {
                # if even one of the tsv file doesn't exist
                # (which means we haven't generated it, or if it was deleted,
                # we re-generate them)
                message("Calculating ",
                        sub("_", " ", fileNameSansExt, fixed = TRUE),
                        " for ",
                        paste(sampleNames, collapse = ", "))
                df.ests <- lapply(dataframes, functor)
            } else {
                # the rare occasion when all individual samples have already been
                # analyzed and the TSVs are all available, we only need to reload
                # them rather than re-computing the values
                message("Loading precomputed ",
                        sub("_", " ", fileNameSansExt, fixed = TRUE),
                        " from ",
                        paste(sampleNames, collapse = ", "))
                df.ests <- lapply(files, read.table, header = TRUE)
            }
            stopifnot(length(diversityDirectories) == length(sampleNames) &&
                          length(df.ests) == length(sampleNames))

            dfs <- do.call("rbind", Map(cbind, df.ests, sample = sampleNames))
            write.table(dfs, file = outputFiles[[i]],
                        sep = "\t", quote = FALSE,
                        row.names = FALSE)

        } else {
            message("Found ", names(estimateTypes)[[i]], ", skipping ...")
        }
    })
}

#' S4 class - AbSeqCompositeRepertoire analysis object
#'
#' @description  AbSeqCRep is a collection of \linkS4class{AbSeqRep} S4 objects.
#' This S4 class contains multiple samples(repertoires) and it can be
#' "combined" with other samples by using the \code{+} operator to
#' create an extended \linkS4class{AbSeqCRep} object.
#' This value, in turn, can be used as the first argument to
#' \link{report} which generates a comparison between all samples included
#' in the \code{+} operation.
#'
#' Users do not manually construct this class, but rather indirectly obtain
#' this class object as a return value from the \code{+} operation between two
#' \linkS4class{AbSeqRep} objects, which are in turn, obtained indirectly from
#' \link{abseqReport} and \link{report} functions. It is also possible to
#' obtain this class object by \code{+} (adding) \linkS4class{AbSeqCRep} objects.
#'
#' @slot repertoires list of \linkS4class{AbSeqRep} objects.
#'
#' @return AbSeqCRep
#'
#' @export
#'
#' @seealso \linkS4class{AbSeqRep}
#'
#' @examples
#' # Use example data from abseqR as abseqPy's output, substitute this
#' # with your own abseqPy output directory
#' abseqPyOutput <- tempdir()
#' file.copy(system.file("extdata", "ex", package = "abseqR"), abseqPyOutput, recursive=TRUE)
#' samples <- abseqReport(file.path(abseqPyOutput, "ex"), report = 0)
#'
#' # The provided example data has PCR1, PCR2, and PCR3 samples contained within
#' # pcr12 and pcr13 are instances of AbSeqCRep
#' pcr12 <- samples[["PCR1"]] + samples[["PCR2"]]
#' pcr13 <- samples[["PCR1"]] + samples[["PCR3"]]
#'
#' # all_S is also an instance of AbSeqCRep
#' all_S <- pcr12 + pcr13
AbSeqCRep <-
    setClass("AbSeqCRep", slots = c(repertoires = "list"))


#' Combines 2 \linkS4class{AbSeqCRep} objects together for comparison
#'
#' @include accessors-AbSeq.R
#'
#' @param e1 AbSeqCRep.
#' @param e2 AbSeqCRep.
#'
#' @return \linkS4class{AbSeqCRep} object. Calling \code{abseqR}'s
#' functions on this object will always result in a comparison.
#'
#' @export
#'
#' @seealso \code{\link{abseqReport}} returns a \code{list} of \code{AbSeqRep}s
#'
#' @examples
#' # Use example data from abseqR as abseqPy's output, substitute this
#' # with your own abseqPy output directory
#' abseqPyOutput <- tempdir()
#' file.copy(system.file("extdata", "ex", package = "abseqR"), abseqPyOutput, recursive=TRUE)
#' samples <- abseqReport(file.path(abseqPyOutput, "ex"), report = 0)
#'
#' # The provided example data has PCR1, PCR2, and PCR3 samples contained within
#' # pcr12 and pcr13 are instances of AbSeqCRep
#' pcr12 <- samples[["PCR1"]] + samples[["PCR2"]]
#' pcr13 <- samples[["PCR1"]] + samples[["PCR3"]]
#'
#' # all_S is also an instance of AbSeqCRep
#' all_S <- pcr12 + pcr13
#'
#' # you can now call the report function on this object
#' # report(all_S)           # uncomment this line to execute report
setMethod("+",
          signature(e1 = "AbSeqCRep",
                    e2 = "AbSeqCRep"),
          function(e1, e2) {
              new("AbSeqCRep",
                  repertoires = unique(c(.asRepertoireList(e1),
                                         .asRepertoireList(e2))))

          })

## ----setup, include=FALSE-----------------------------------------------------
library(abseqR)
library(png)
library(plotly)
library(grid)
library(gridExtra)
library(BiocStyle)
# knitr::opts_chunk$set(tidy = TRUE)
knitr::opts_chunk$set(message = FALSE)

## ----abseqR_vignette_helper_functions, include=FALSE--------------------------
sabseqR <- function() { return(Biocpkg("abseqR")); }
#sabseqR <- function() { return("`abseqR`"); }
sabseqPy <- function() { return("[abseqPy](https://github.com/malhamdoosh/abseqPy)"); }
sabseq <- function() { return("`AbSeq`"); }
read_png <- function(path) {
    if (file.exists(path)) {
        #rasterGrob(as.raster(readPNG(path)), interpolate = TRUE)
        # in windows, the path is \ but LaTEX does not appreciate these slashes
        knitr::include_graphics(gsub("\\", "/",
                                     normalizePath(path),
                                     fixed = TRUE))
    } else {
        stop("File at ", path, " not found, fatal.")
    }
}


## ----abseq-wf, fig.cap="AbSeq workflow. Comprehensive analyses and visualizations are generated from input sequencing files using abseqPy and abseqR.", echo=FALSE, out.width="100%"----
read_png("abseq_workflow_MA.jpg")

## ----abseq-sim-data, fig.cap="Generation of the three simulated datasets. The flowchart on the left shows the generation of the datasets in `\"./ex/\"` while the folder structure on the right shows the output generated by `abseqPy` on the three datasets.", echo=FALSE, out.width="100%"----
read_png("simulation_flowchart_full.jpg")

## ----abseqR_copy_data_files, results=FALSE------------------------------------
# substitute with any directory that you have read/write access to
sandboxDirectory <- tempdir()

# path to provided data (comes installed with abseqR)
exdata <- system.file("extdata", "ex", package = "abseqR")

# copy the provided data to sandboxDirectory
file.copy(exdata, sandboxDirectory, recursive = TRUE)

## ----abseqR_data_contents-----------------------------------------------------
# dataPath now holds the path to a local copy of the data
dataPath <- file.path(sandboxDirectory, "ex")
# the sample names can be found inside the auxiliary directory
list.files(path = file.path(dataPath, "auxiliary"))

## ----abseqR_quick_run, results=FALSE, warning=FALSE---------------------------
# This section will visualize all the datasets individually
# and compare PCR1 with PCR2 with PCR3

# Interim solution
if (Sys.info()["sysname"] == "Darwin") {
    BPPARAM <- BiocParallel::SerialParam()
} else {
    BPPARAM <- BiocParallel::bpparam()
}

# you should use report = 3 to generate a HTML report
samples <- abseqReport(dataPath,
                       compare = c("PCR1, PCR2, PCR3"),
                       report = 1,
                       BPPARAM = BPPARAM)

# ignore the message:
# "Sample output directory <path> is different from provided path
#   <path> assuming directory was moved"
# This warning message tells us that the directory has
# been moved (we copied the provided examples to "dataPath")

## ----abseq-final-folder-structure, fig.cap="Folder structure after `abseqR` completes. The landing page `index.html` provides a convenient way to navigate around the standalone HTML reports in `html\\_files/`.", echo=FALSE----
grid.raster(readPNG("post_report_fs.png"))

## ----abseqR_abseqReport_compare_argument, results=FALSE, warning=FALSE--------
# Example of 1 comparison
# Analyze all samples, but only compare PCR1 with PCR2
pcr1.pcr2 <- abseqReport(dataPath,
                         compare = c("PCR1, PCR2"),
                         report = 0)

# Example of 2 comparisons
# Analyze all samples. In addition, compare:
#  * PCR1 with PCR2
#  * PCR2 with PCR3
multiComparison <- abseqReport(dataPath,
                               compare = c("PCR1, PCR2", "PCR2, PCR3"),
                               report = 0)

## ----abseqR_show_return_of_abseqReport, results='hold'------------------------
# compare = c("PCR1,PCR2")
names(pcr1.pcr2)

# compare = c("PCR1, PCR2", "PCR2 ,PCR3")
names(multiComparison)

## ----abseqR_refine_comparison_simple, results=FALSE, warning=FALSE------------
# recall that samples is a named list where each element's name
# is the sample's own name (see names(samples))

# use report = 3 if the results should be collated in a HTML document
pcr1.pcr3 <- samples[["PCR1"]] + samples[["PCR3"]]
refinedComparison <- report(pcr1.pcr3,
                            outputDir = file.path(sandboxDirectory,
                                                  "refined_comparison"),
                            report = 1)

## ----abseqR_refine_comparison_sample_return_value, eval=TRUE------------------
names(refinedComparison)

## ----abseqR_adv_load_samples, eval=FALSE--------------------------------------
# SRRControl <- abseqReport("SRR_CTRL")
# SRRExp <- abseqReport("SRR_EXP")

## ----abseqR_adv_compare_old_new, eval=FALSE-----------------------------------
# # short for SRRControl[[1]] + SRRControl[[2]] + ... + SRRExp[[1]] + ...
# all.samples <- Reduce("+", c(SRRControl, SRRExp))
# report(all.samples, outputDir = "SRRControl_vs_SRRExp")

## ----abseqR_adv_lazy_load, eval=FALSE-----------------------------------------
# # in essence, this is identical to SRRControl <- abseqReport("SRR_CTRL"),
# # but will not regenerate plots and reports!
# SRRControl.lazy <- abseqReport("SRR_CTRL", report = 0)
# 
# # exactly the same return value
# stopifnot(names(SRRControl.lazy) == names(SRRControl))

## ----abseqR_adv_bpparam, eval=FALSE-------------------------------------------
# 
# # use 4 CPU cores
# nproc <- 4
# samples <- abseqReport(dataPath,
#                        BPPARAM = BiocParallel::MulticoreParam(nproc))
# 
# 
# # run sequentially - no multiprocessing
# samples <- abseqReport(dataPath,
#                        BPPARAM = BiocParallel::SerialParam())

## ----abseqR_plot_path_setup, include=FALSE------------------------------------
# [s]ingle sample [dir]ectory
sdir <- file.path(dataPath, "auxiliary", "PCR1")
# [m]ulti sample [dir]ectory
mdir <- file.path(dataPath, "auxiliary", "PCR1_vs_PCR2_vs_PCR3")

## ----seq-len, fig.cap="Sequence length distribution of PCR1. Histogram of (merged) sequence lengths.", echo=FALSE, out.width="100%"----
read_png(file.path(sdir, "annot", "PCR1_all_clones_len_dist.png"))

## ----align-qual, fig.cap="Bitscore vs V germline alignment length in PCR1. Heatmap of bitscore vs alignment length shows percentage of sequences in a given value range.", echo=FALSE, out.width="100%"----
read_png(file.path(sdir, "abundance", "PCR1_igv_align_quality_bitscore_hm_static.png"))

## ----indel, fig.cap="Rate of insertions and deletions in PCR1. The percentage of indels found within the V germlines of PCR1.", echo=FALSE, out.width="100%"----
read_png(file.path(sdir, "abundance", "PCR1_igv_gaps_dist.png"))

## ----vgermline, fig.cap="V family germline distribution in PCR1. The percentage of IGHV families after germline annotation using IgBLAST.", echo=FALSE, out.width="100%"----
read_png(file.path(sdir, "abundance", "PCR1_igv_dist_family_level.png"))

## ----vjassoc, fig.cap="V-J family germline association in PCR1. Segment size represents germline proportion while the thickness of the arcs shows the proportion of associations between V and J germline families. This plot was heavily inspired by [VDJTools](https://github.com/mikessh/vdjtools/))", echo=FALSE, out.width="100%"----
read_png(file.path(sdir, "abundance", "PCR1_vjassoc.png"))

## ----prod-summ, fig.cap="Productivity rate of sequences in PCR1. This plot shows the percentage of productive and unproductive sequences, the reason for unproductive sequences are colour coded.", echo=FALSE, out.width="100%"----
read_png(file.path(sdir, "productivity", "PCR1_productivity.png"))

## ----frameshift, fig.cap="Rate of in-frame and out-of-frame sequences in PCR1. Misaligned V-J frame or non-multiple of 3 indels in either one of the framework or complementarity-determining regions causes a frameshift and therefore renders the sequence unproductive.", echo=FALSE, out.width="100%"----
read_png(file.path(sdir, "productivity", "PCR1_vjframe_dist.png"))

## ----stopcod, fig.cap="Proportion of stop codons in any given CDR or FR of out-of-frame sequences in PCR1. The percentages show the frequency of stop codons in a given region relative to the total number of stop codons present.", echo=FALSE, out.width="100%"----
read_png(file.path(sdir, "productivity", "PCR1_stopcodon_region_outframe.png"))

## ----mismatches, fig.cap="Proportion of mismatches in productive sequences of PCR1.", echo=FALSE, out.width="100%"----
read_png(file.path(sdir, "productivity", "PCR1_fr3_mismatches_dist.png"))

## ----gaps, fig.cap="Proportion of indels in productive sequences of PCR1.", echo=FALSE, out.width="100%"----
read_png(file.path(sdir, "productivity", "PCR1_fr3_gaps_dist.png"))

## ----gaps-out, fig.cap="Proportion of indels in out-of-frame sequences of PCR1.", echo=FALSE, out.width="100%"----
read_png(file.path(sdir, "productivity", "PCR1_fr3_gaps_dist_out_of_frame.png"))

## ----duplication, fig.cap="Proportion of duplicated clonotypes in PCR1. Higher-order duplication levels starting from 10 are binned.", echo=FALSE, out.width="100%"----
read_png(file.path(sdir, "diversity", "PCR1_cdr_duplication.png"))

## ----rarefaction, fig.cap="Rarefaction curve of clonotypes in PCR1. The number of deduplicated sequences are taken over the mean of 5 resampling rounds, where the shaded areas indicate 95\\% confidence interval.", echo=FALSE, out.width="100%"----
read_png(file.path(sdir, "diversity", "PCR1_cdr_rarefaction.png"))

## ----recapture, fig.cap="Capture-recapture of clonotypes in PCR1. The number of recaptured sequences are taken over the mean of 5 resampling rounds, where the shaded areas indicate 95\\% confidence interval.", echo=FALSE, out.width="100%"----
read_png(file.path(sdir, "diversity", "PCR1_cdr_recapture.png"))

## ----spectra, fig.cap="CDR3 amino acid spectratype for PCR1 with outliers removed.", echo=FALSE, out.width="100%"----
read_png(file.path(sdir, "diversity", "spectratypes", "PCR1_cdr3_spectratype_no_outliers.png"))

## ----comp, fig.cap="Amino acid composition logo for PCR1's CDR3. The unscaled (left) and the scaled (right) composition logos are colour coded and grouped by their physicochemical properties.", echo=FALSE, fig.wide=TRUE----
unscaled <- file.path(sdir, "diversity", "composition_logos", "CDR3", "PCR1_cumulative_logo.png")
scaled <- file.path(sdir, "diversity", "composition_logos", "CDR3", "PCR1_cumulative_logo_scaled.png")
img1 <-  rasterGrob(as.raster(readPNG(unscaled)), interpolate = TRUE)
img2 <- rasterGrob(as.raster(readPNG(scaled)), interpolate = TRUE)
grid.arrange(img1, img2, ncol = 2)

## ----topclones, fig.cap="Top 10 clonotypes from PCR1, PCR2, and PCR3. The clonotype proportions displayed are scaled relative to the top 10 clones in each sample.", echo=FALSE, out.width="100%"----
read_png(file.path(mdir, "clonotype_analysis", "PCR1_PCR2_PCR3_top10Clonotypes.png"))

## ----overlap, fig.cap="Number of unique overlapping clones found in PCR1, PCR2, and PCR3. The numbers in an intersection denotes the number of unique clones that are shared between the samples involved in the said intersection.", echo=FALSE, out.width="100%"----
read_png(file.path(mdir, "clonotype_analysis", "PCR1_PCR2_PCR3_cdr3_clonotypeIntersection.png"))

## ----scatter, fig.cap="Log-scaled scatter plot of clonotype frequencies in PCR1 and PCR2. Point size denotes mean frequency of the 2 samples and marginal density plots are colour coded by overlapping (blue), non-overlapping (purple), and all (grey) clonotypes.", echo=FALSE, out.width="100%"----
read_png(file.path(mdir, "clonotype_analysis", "PCR1_vs_PCR2_clone_scatter.png"))

## ----corr, fig.cap="Pearson correlation between PCR1, PCR2, and PCR3. Values denote the pearson correlation coefficient of the clonotypes frequencies between the samples. These values will appear with a cross 'x' to signify an insignificant coefficient if the p-value of the coefficient is larger than 0.05.", echo=FALSE, out.width="100%"----
read_png(file.path(mdir, "clonotype_analysis", "pearson.png"))

## ----cluster, fig.cap="Morisita-Horn distances of PCR1, PCR2, and PCR3. The distances are calculated using clonotype frequencies and are visualized as the length of the lines connecting samples or clusters.", echo=FALSE, out.width="100%"----
read_png(file.path(mdir, "clonotype_analysis", "morisita_horn.png"))

## ----mixr-test-params, echo=FALSE, message=FALSE, warnings=FALSE, results='asis'----
tabl <- "
| Parameter     | sample 1      | sample 2      | sample 3      |
|---------------|---------------|---------------|---------------|
| reads         |  10000        |  10000        | 10000         |
| clones        |  5000         |  5000         | 2000          |
| seed          |  4228         |  2428         | 2842          |
| conf          | MiSeq-300-300 | MiSeq-300-300 | MiSeq-300-300 |
| loci          |  IGH          | IGH           | IGH           |
| species       | hsa           | hsa           | hsa           |
"
cat(tabl)

## ----abseqR_session_info, echo=FALSE------------------------------------------
sessionInfo()

#' S4 class - AbSeqRepertoire analysis object
#'
#' @import methods
#'
#' @description The AbSeqRep object contains all metadata associated with
#' the AbSeq (python backend) run conducted on it. This S4 class represents
#' a single sample(repertoire) and it can be "combined" with other samples
#' by using the \code{+} operator to create an \linkS4class{AbSeqCRep} object.
#' This value, in turn, can be used as the first argument to
#' \link{report} which generates a comparison between all samples included
#' in the \code{+} operation.
#'
#' Users do not manually construct this class, but rather indirectly
#' obtain this class object as a return value
#' from the \link{abseqReport} and \link{report} functions.
#'
#' @slot f1 character. Path to FASTA/FASTQ file 1.
#' @slot f2 character. Path to FASTA/FASTQ file 2.
#' @slot chain character. Type of chain, possible values:
#' \itemize{
#'   \item{hv}
#'   \item{lv}
#'   \item{kv}
#'   \item{klv}
#' }
#' each representing \bold{H}eavy, \bold{L}ambda and \bold{K}appa respectively.
#' @slot task character. Type of analysis conducted, possible values:
#' \itemize{
#'   \item{all}
#'   \item{annotate}
#'   \item{abundance}
#'   \item{diversity}
#'   \item{productivity}
#'   \item{fastqc}
#'   \item{primer}
#'   \item{5utr}
#'   \item{rsasimple}
#'   \item{seqlen}
#'   \item{secretion}
#'   \item{seqlenclass}
#' }
#' @slot name character. Name of analysis.
#' @slot bitscore numeric. Part of filtering criteria: V gene bitscore filter value.
#' @slot qstart numeric. Part of filtering criteria: V gene query start filter value.
#' @slot sstart numeric. Part of filtering criteria: V gene subject start filter value.
#' @slot alignlen numeric. Part of filtering criteria: V gene alignment length filter value.
#' @slot clonelimit numeric. Number of clones to export into csv file. This is
#' only relevant in \code{-t all} or \code{-t diversity} where clonotypes
#' are exported into \code{<outdir>/<name>/diversity/clonotypes}
#' @slot detailedComposition logical. Plots composition logo by IGHV families if
#' set to true, otherwise, plots logos by FR/CDRs.
#' @slot log character. Path to log file.
#' @slot merger character. Merger used to merge paired-end reads.
#' @slot fmt character. File format of \code{file1} and (if present) \code{file2}.
#' Possible values are FASTA or FASTQ.
#' @slot sites character. Path to restriction sites \code{txt} file.
#' This option is only used if \code{-t rsasimple}
#' @slot primer5end ANY. Path to 5' end primer FASTA file.
#' @slot primer3end ANY. Path to 3' end primer FASTA file.
#' @slot trim5 numeric. Number of nucleotides to trimd at the 5' end;
#' @slot trim3 numeric. Number of nucleotides to trimd at the 3' end;
#' @slot outdir character. Path to output directory
#' @slot primer5endoffset numeric. Number of nucleotides to offset before aligning
#' 5' end primers in \code{primer5end} FASTA file.
#' @slot threads numeric. Number of threads to run.
#' @slot upstream character. Index (range) of upstream nucleotides to analyze.
#' This option is only used if \code{-t 5utr} or \code{-t secretion}.
#' @slot seqtype character. Sequence type, possible values are either \code{dna}
#' or \code{protein}.
#' @slot database character. Path to IgBLAST database.
#' @slot actualqstart numeric. Query sequence's starting index (indexing starts from 1).
#' This value overrides the inferred query start position by AbSeq.
#' @slot fr4cut logical. The end of FR4 is marked as the end of the sequence if
#' set to TRUE, otherwise the end of the sequence is either the end of the read
#' itself, or trimmed to \code{--trim3 <num>}.
#' @slot domainSystem character. Domain system to use in IgBLAST, possible
#' values are either \code{imgt} or \code{kabat}.
#'
#' @seealso \code{\link{abseqReport}} returns a \code{list} of \code{AbSeqRep}
#' objects.
#' @return AbSeqRep
#' @export
#'
#' @examples
#' # this class is not directly constructed by users, but as a return
#' # value from the abseqReport method.
#'
#' # Use example data from abseqR as abseqPy's output, substitute this
#' # with your own abseqPy output directory
#' abseqPyOutput <- tempdir()
#' file.copy(system.file("extdata", "ex", package = "abseqR"), abseqPyOutput, recursive=TRUE)
#' samples <- abseqReport(file.path(abseqPyOutput, "ex"), report = 0)
AbSeqRep <- setClass(
    "AbSeqRep",
    slots = c(
        f1 = "character",
        f2 = "character",
        chain = "character",
        task = "character",
        name = "character",
        bitscore = "numeric",
        qstart = "numeric",
        sstart = "numeric",
        alignlen = "numeric",
        clonelimit = "numeric",
        detailedComposition = "logical",
        log = "character",
        merger = "character",
        fmt = "character",
        sites = "character",
        primer5end = "ANY",
        primer3end = "ANY",
        trim5 = "numeric",
        trim3 = "numeric",
        outdir = "character",
        primer5endoffset = "numeric",
        threads = "numeric",
        upstream = "ANY",
        seqtype = "character",
        database = "character",
        actualqstart = "numeric",
        fr4cut = "logical",
        domainSystem = "character"
    )
)


.loadAbSeqRepFromParams <- function(analysisParams) {
    con <- file(analysisParams, "r")
    lines <- readLines(con)
    close(con)
    params <- list(Class = "AbSeqRep")

    # parameters that do not provide any information - ignore them so they
    # wont be added as slots
    skip <- c("yaml")

    for (line in lines) {
        # read in parameters
        if (startsWith(line, "Parameter")) {
            tokens <- unlist(strsplit(line, "\t"))
            parameter <- trimws(strsplit(tokens[1], ":")[[1]][2])
            value <- trimws(strsplit(tokens[2], ":")[[1]][2])
            if (!(parameter %in% skip)) {
                if (!is.na(as.logical(value))) {
                    params[[parameter]] <- as.logical(value)
                } else if (!is.na(suppressWarnings(as.numeric(value)))) {
                    params[[parameter]] <- as.numeric(value)
                } else if (grepl("[", value, fixed = TRUE)) {
                    # value = [start, end]
                    newValue <- gsub("\\[|\\]", "", value)
                    # to -> c(start, end)
                    params[[parameter]] <-
                        as.numeric(unlist(strsplit(newValue, ",")))
                } else {
                    params[[parameter]] <- value
                }
            }
        }
    }
    return(do.call("new", params))
}


#' Combines 2 \linkS4class{AbSeqRep} objects together for comparison
#'
#' @include AbSeqCRep.R
#'
#' @param e1 AbSeqRep object.
#' @param e2 AbSeqRep object.
#'
#' @return \linkS4class{AbSeqCRep} object. Calling \code{abseqR}'s
#' functions on this object will always result in a comparison.
#'
#' @export
#'
#' @seealso \code{\link{abseqReport}} returns a \code{list} of \code{AbSeqRep}s
#'
#' @examples
#' # Use example data from abseqR as abseqPy's output, substitute this
#' # with your own abseqPy output directory
#' abseqPyOutput <- tempdir()
#' file.copy(system.file("extdata", "ex", package = "abseqR"), abseqPyOutput, recursive=TRUE)
#' samples <- abseqReport(file.path(abseqPyOutput, "ex"), report = 0)
#'
#' # The provided example data has PCR1, PCR2, and PCR3 samples contained within
#' # pcr1 and pcr2 are instances of AbSeqRep
#' pcr1 <- samples[["PCR1"]]
#' pcr2 <- samples[["PCR2"]]
#'
#' # pcr12 is an instance of AbSeqCRep
#' pcr12 <- pcr1 + pcr2
#'
#' # you can now call the report function on this object
#' # report(pcr12)           # uncomment this line to execute report
setMethod("+", signature(e1 = "AbSeqRep", e2 = "AbSeqRep"), function(e1, e2) {
    new("AbSeqCRep", repertoires = list(e1, e2))
})

#' Combines a \linkS4class{AbSeqCRep} object with
#' a \linkS4class{AbSeqRep} object together for comparison
#'
#' @include AbSeqCRep.R
#' @include accessors-AbSeq.R
#'
#' @param e1 AbSeqCRep.
#' @param e2 AbSeqRep.
#'
#' @return \linkS4class{AbSeqCRep} object. Calling \code{abseqR}'s
#' functions on this object will always result in a comparison.
#'
#' @export
#'
#' @seealso \code{\link{abseqReport}} returns a \code{list} of \code{AbSeqRep}s
#'
#' @examples
#' # Use example data from abseqR as abseqPy's output, substitute this
#' # with your own abseqPy output directory
#' abseqPyOutput <- tempdir()
#' file.copy(system.file("extdata", "ex", package = "abseqR"), abseqPyOutput, recursive=TRUE)
#' samples <- abseqReport(file.path(abseqPyOutput, "ex"), report = 0)
#'
#' # The provided example data has PCR1, PCR2, and PCR3 samples contained within
#' # pcr12 is an instance of AbSeqCRep
#' pcr12 <- samples[["PCR1"]] + samples[["PCR2"]]
#' # pcr3 is instance of AbSeqRep
#' pcr3 <- samples[["PCR3"]]
#'
#' # pcr123 is an instance of AbSeqCRep
#' pcr123 <- pcr12 + pcr3
#'
#' # you can now call the report function on this object
#' # report(pcr123)           # uncomment this line to execute report
setMethod("+", signature(e1 = "AbSeqCRep", e2 = "AbSeqRep"), function(e1, e2) {
    new("AbSeqCRep", repertoires = unique(c(.asRepertoireList(e1), e2)))
})

#' Combines a \linkS4class{AbSeqRep} object with
#' a \linkS4class{AbSeqCRep} object together for comparison
#'
#' @include AbSeqCRep.R
#' @include accessors-AbSeq.R
#'
#' @param e1 AbSeqRep.
#' @param e2 AbSeqCRep.
#'
#' @return \linkS4class{AbSeqCRep} object. Calling \code{abseqR}'s
#' functions on this object will always result in a comparison.
#'
#' @export
#'
#' @seealso \code{\link{abseqReport}} returns a \code{list} of \code{AbSeqRep}s
#'
#' @examples
#' # Use example data from abseqR as abseqPy's output, substitute this
#' # with your own abseqPy output directory
#' abseqPyOutput <- tempdir()
#' file.copy(system.file("extdata", "ex", package = "abseqR"), abseqPyOutput, recursive=TRUE)
#' samples <- abseqReport(file.path(abseqPyOutput, "ex"), report = 0)
#'
#' # The provided example data has PCR1, PCR2, and PCR3 samples contained within
#' # pcr1 is an instance of AbSeqRep
#' pcr1 <- samples[["PCR1"]]
#' # pcr23 is instance of AbSeqCRep
#' pcr23 <- samples[["PCR2"]] + samples[["PCR3"]]
#'
#' # pcr123 is an instance of AbSeqCRep
#' pcr123 <- pcr1 + pcr23
#'
#' # you can now call the report function on this object
#' # report(pcr123)           # uncomment this line to execute report
setMethod("+", signature(e1 = "AbSeqRep", e2 = "AbSeqCRep"), function(e1, e2) {
    new("AbSeqCRep", repertoires = unique(c(e1, .asRepertoireList(e2))))
})

#' Plots \linkS4class{AbSeqRep} or
#' \linkS4class{AbSeqCRep} object to the specfied directory
#'
#' @description Plots all samples in the \code{object} argument
#' and saves the analysis in \code{outputDir}.
#' Users can optionally specify which samples
#' in \code{object} should be compared. Doing so generates
#' additional plots for clonotype comparison and
#' the usual plots will also conveniently include these samples
#' using additional \code{aes}thetics.
#'
#' This method is analogous to \code{\link{abseqReport}}.
#' The only difference is that this method accepts \linkS4class{AbSeqRep} or
#' \linkS4class{AbSeqCRep} objects as its first parameter, and the
#' \code{outputDir} specifies where to store the result.
#'
#'
#' @include util.R
#' @include plotter.R
#' @include accessors-AbSeq.R
#' @include AbSeqCRep.R
#'
#' @param object AbSeqRep or AbSeqCRep object to plot.
#' @param outputDir string type. Directory where analysis will be saved to.
#' @param report (optional) integer type. The possible values are:
#' \itemize{
#'   \item{0 - does nothing (returns named list of \linkS4class{AbSeqRep} objects)}
#'   \item{1 - generates plots for csv files}
#'   \item{2 - generates a report that collates all plots}
#'   \item{3 - generates interactive plots in report} (default)
#' }
#' each value also does what the previous values do. For example, \code{report = 2}
#' will return a named list of \linkS4class{AbSeqRep} objects, plot csv files,
#' and generate a (non-interactive)HTML report that collates all the plots together.
#' @return named list. List of \linkS4class{AbSeqRep} objects. The names of
#' the list elements are taken directly from the repertoire object itself.
#' This return value is consistent with the return value of \code{\link{abseqReport}}.
#'
#' @export
#'
#' @seealso \code{\link{abseqReport}}. Analogus function, but takes input from
#' a string that signifies the output directory of abseqPy as the first
#' arugment instead.
#'
#' @seealso \linkS4class{AbSeqRep}
#' @seealso \linkS4class{AbSeqCRep}
#'
#' @rdname report
#'
#' @examples
#' # Use example data from abseqR as abseqPy's output, substitute this
#' # with your own abseqPy output directory
#' abseqPyOutput <- tempdir()
#' file.copy(system.file("extdata", "ex", package = "abseqR"), abseqPyOutput, recursive=TRUE)
#' samples <- abseqReport(file.path(abseqPyOutput, "ex"), report = 0)
#'
#'
#' # The provided example data has PCR1, PCR2, and PCR3 samples contained within
#' # We can use the + operator to combine samples, thus requesting the
#' # report function to compare them:
#' pcr12 <- samples[["PCR1"]] + samples[["PCR2"]]
#'
#' # generate plots and report for this new comparison
#' # report(pcr12, "PCR1_vs_PCR2")
#'
#' # generate plots only
#' # report(pcr12, "PCR1_vs_PCR2", report = 1)
#'
#' # generate plots, and a non-interactive report
#' # report(pcr12, "PCR1_vs_PCR2", report = 2)
#'
#' # generate plots, and an interactive report
#' # report(pcr12, "PCR1_vs_PCR2", report = 3)   # this is the default
setGeneric(
    name = "report",
    def = function(object, outputDir, report = 3) {
        standardGeneric("report")
    }
)



#' @rdname report
setMethod(
    f = "report",
    signature = "AbSeqRep",
    definition = function(object, outputDir, report = 3) {
        skip <- FALSE
        stopifnot(report %in% c(0, 1, 2, 3))

        # give meaningful names to numerical values
        if (report == 0) {
            report <- FALSE
            interactivePlot <- FALSE
            skip <- TRUE
        } else if (report == 1) {
            report <- FALSE
            interactivePlot <- FALSE
        } else if (report == 2) {
            report <- TRUE
            interactivePlot <- FALSE
        } else {
            report <- TRUE
            interactivePlot <- TRUE
        }

        if (!skip) {
            analysisDirectories = c(file.path(.asRepertoireDir(object),
                                              RESULT_DIR,
                                              .asRepertoireName(object)))
            # get analysis that were conducted by looking at the directory
            # structure
            analyses <-
                unlist(.inferAnalyzed(analysisDirectories[1]))
            sampleNames <- .asRepertoireName(object)
            primer5Files <- list(.asRepertoirePrimer5(object))
            primer3Files <- list(.asRepertoirePrimer3(object))
            upstreamRanges <- list(.asRepertoireUpstream(object))

            .plotSamples(
                sampleNames,
                analysisDirectories,
                analyses,
                outputDir,
                primer5Files,
                primer3Files,
                upstreamRanges,
                skipDgene = (.asRepertoireChain(object) != "hv")
            )

            if (report) {
                .generateReport(
                    object,
                    root = outputDir,
                    outputDir = outputDir,
                    interactivePlot = interactivePlot
                )
            }
        }

        # to be consistent with the return value of abseqR::abseqReport()
        lst <- list()
        lst[[.asRepertoireName(object)]] <- object
        return(lst)
    }
)

#' @rdname report
setMethod(
    f = "report",
    signature = "AbSeqCRep",
    definition = function(object, outputDir, report = 3) {
        stopifnot(report %in% c(0, 1, 2, 3))
        skip <- FALSE
        if (report == 0) {
            report <- FALSE
            interactivePlot <- FALSE
            skip <- TRUE
        } else if (report == 1) {
            report <- FALSE
            interactivePlot <- FALSE
        } else if (report == 2) {
            report <- TRUE
            interactivePlot <- FALSE
        } else {
            report <- TRUE
            interactivePlot <- TRUE
        }

        sampleNames <-
            unlist(lapply(.asRepertoireList(object), .asRepertoireName))

        if (!skip) {
            analysisDirectories <- unlist(
                lapply(
                    .asRepertoireList(object), function(x) {
                        # /a/b/c/RESULT_DIR/sample_name has
                        # all the analysis folders
                        file.path(.asRepertoireDir(x),
                                  RESULT_DIR,
                                  .asRepertoireName(x))
                    }))

            # get all analyses conducted by each repertoire by looking
            # at the directory structure created by abseqPy
            analysesConducted <- lapply(analysisDirectories, .inferAnalyzed)

            # find the intersection of all analysis, because it makes no
            # sense to compare samples if they don't have the same analysis
            similarAnalyses <- unlist(Reduce(intersect, analysesConducted))


            primer5Files <-
                unlist(lapply(.asRepertoireList(object), .asRepertoirePrimer5))

            primer3Files <-
                unlist(lapply(.asRepertoireList(object), .asRepertoirePrimer3))

            upstreamRanges <- lapply(.asRepertoireList(object),
                                     .asRepertoireUpstream)

            allChains <- lapply(.asRepertoireList(object), .asRepertoireChain)

            # only include D gene plots if all chains only contain "hv"
            skipD <- (("kv" %in% allChains) || ("lv" %in% allChains))

            .plotSamples(
                sampleNames,
                analysisDirectories,
                similarAnalyses,
                outputDir,
                primer5Files,
                primer3Files,
                upstreamRanges,
                skipDgene = skipD
            )

            if (report) {
                .generateReport(
                    object,
                    root = outputDir,
                    outputDir = outputDir,
                    interactivePlot = interactivePlot
                )
            }
        }

        lst <- .asRepertoireList(object)
        names(lst) <- sampleNames
        return(lst)
    }
)


#' Generates HTML report from \code{\linkS4class{AbSeqRep}} and
#' \code{\linkS4class{AbSeqCRep}} ojects
#'
#' @importFrom rmarkdown pandoc_available render
#' @include util.R
#' @include accessors-AbSeq.R
#'
#' @param object AbSeqCRep type.
#' @param root string type. Root directory of the sample(s)
#' @param outputDir string type. The path where the HTML will be generated
#' @param interactivePlot logical type. Interactive or not
#' @param .indexHTML character type. The back button will redirect to this link.
#' This is typically used to redirect users back to index.html page
#'
#' @return path (including HTML name) where the report (HTML file) was saved to
setGeneric(
    name = ".generateReport",
    def = function(object,
                   root,
                   outputDir,
                   interactivePlot = TRUE,
                   .indexHTML = "#") {
        standardGeneric(".generateReport")
    }
)

setMethod(
    f = ".generateReport",
    signature = "AbSeqCRep",
    definition = function(object,
                          root,
                          outputDir,
                          interactivePlot = TRUE,
                          .indexHTML = "#") {
        if (rmarkdown::pandoc_available()) {
            analysisDirectories = unlist(
                lapply(
                    .asRepertoireList(object), function(x) {
                        # /a/b/c/RESULT_DIR/sample_name has all the analysis folders
                        file.path(.asRepertoireDir(x), RESULT_DIR, .asRepertoireName(x))
                    }))

            sampleNames <-
                unlist(lapply(.asRepertoireList(object), .asRepertoireName))

            message("Generating HTML report for ",
                    paste(sampleNames, collapse = "_vs_"))

            # get all analyses conducted by each repertoire by looking
            # at the directory structure created by abseqPy
            analysesConducted <- lapply(analysisDirectories, .inferAnalyzed)

            # find the intersection of all analysis, because it makes no
            # sense to compare samples if they don't have the same analysis
            similarAnalyses <- unlist(Reduce(intersect, analysesConducted))

            # define variables for template.Rmd's param list
            allChains <-
                lapply(.asRepertoireList(object), .asRepertoireChain)

            # only include D gene plots if all chains only contain "hv"
            includeD <- !(("kv" %in% allChains) || ("lv" %in% allChains))


            # template.Rmd param list
            bitFilters <-
                lapply(.asRepertoireList(object), .asRepertoireBitscore)

            alFilters <-
                lapply(.asRepertoireList(object), .asRepertoireAlignLen)

            ssFilters <-
                lapply(.asRepertoireList(object), .asRepertoireSubjectStart)

            qsFilters <-
                lapply(.asRepertoireList(object), .asRepertoireQueryStart)

            rawReadCounts <- lapply(X = analysisDirectories,
                                    FUN = .readSummary,
                                    ABSEQ_RAW_READ_COUNT_KEY)
            annotReadCounts <- lapply(X = analysisDirectories,
                                      FUN = .readSummary,
                                      ABSEQ_ANNOT_READ_COUNT_KEY)
            filteredReadCounts <- lapply(X = analysisDirectories,
                                         FUN = .readSummary,
                                         ABSEQ_FILT_READ_COUNT_KEY)
            productiveReadCounts <- lapply(X = analysisDirectories,
                                           FUN = .readSummary,
                                           ABSEQ_PROD_READ_COUNT_KEY)
            renderParams <- list(
                rootDir = normalizePath(root),
                single = FALSE,
                interactive = interactivePlot,
                inclD = includeD,
                hasAnnot = (ABSEQ_DIR_ANNOT %in% similarAnalyses),
                hasAbun = (ABSEQ_DIR_ABUN %in% similarAnalyses),
                hasProd = (ABSEQ_DIR_PROD %in% similarAnalyses),
                hasDiv = (ABSEQ_DIR_DIV %in% similarAnalyses),
                name = paste(sampleNames, collapse = "_vs_"),
                bitfilters = paste(bitFilters, collapse = ","),
                alignfilters = paste(alFilters, collapse = ","),
                sstartfilters = paste(ssFilters, collapse = ","),
                qstartfilters = paste(qsFilters, collapse = ","),
                rawReads = paste(rawReadCounts, collapse = ","),
                annotReads = paste(annotReadCounts, collapse = ","),
                filteredReads = paste(filteredReadCounts, collapse = ","),
                productiveReads = paste(productiveReadCounts, collapse = ",")
            )

            # https://github.com/rstudio/rmarkdown/issues/861#issuecomment-326637323
            # paraphrased: just don't use output_file or output_dir
            # instead, copy to output_dir and remove it if you want to
            # as a safety measure, rename the template.Rmd file to
            # sample name so that the cache will not clash with other
            # samples it it wasn't cleared in time
            tmpTemplate <-
                file.path(outputDir, paste0(paste(sampleNames, collapse = "_vs_"), ".Rmd"))
            file.copy(
                system.file("extdata", "template.Rmd", package = "abseqR"),
                tmpTemplate,
                overwrite = TRUE
            )
            # substitute href to '#' to index.html: only when there's a landing
            # page that we do this. Calling abseqR::report() will leave href
            # as-is
            .substituteStringInFile(tmpTemplate,
                                    "href: \"#\"",
                                    paste0("href: \"", .indexHTML, "\""),
                                    fixed = TRUE)
            rmarkdown::render(tmpTemplate, params = renderParams)
            file.remove(tmpTemplate)
            return(sub(".Rmd", ".html", tmpTemplate))
        } else {
            warning("Pandoc cannot be detected on system, skipping HTML report")
            return(NA)
        }

    }
)


setMethod(
    f = ".generateReport",
    signature = "AbSeqRep",
    definition = function(object,
                          root,
                          outputDir,
                          interactivePlot = TRUE,
                          .indexHTML = "#") {
        if (rmarkdown::pandoc_available()) {
            message("Generating HTML report for ", .asRepertoireName(object))
            analysisDirectory = file.path(.asRepertoireDir(object),
                                          RESULT_DIR,
                                          .asRepertoireName(object))
            analyses <-
                unlist(.inferAnalyzed(analysisDirectory))

            # define parameters for template.Rmd's param list
            bitFilter <- .asRepertoireBitscore(object)
            qsFilter <- .asRepertoireQueryStart(object)
            ssFilter <- .asRepertoireSubjectStart(object)
            alFilter <- .asRepertoireAlignLen(object)
            rawReadCount <- .readSummary(analysisDirectory,
                                         ABSEQ_RAW_READ_COUNT_KEY)
            annotReadCount <- .readSummary(analysisDirectory,
                                           ABSEQ_ANNOT_READ_COUNT_KEY)
            filteredReadCount <-
                .readSummary(analysisDirectory,
                             ABSEQ_FILT_READ_COUNT_KEY)
            productiveReadCount <-
                .readSummary(analysisDirectory,
                             ABSEQ_PROD_READ_COUNT_KEY)

            renderParams <- list(
                rootDir = normalizePath(root),
                single = TRUE,
                interactive = interactivePlot,
                inclD = (.asRepertoireChain(object) == "hv"),
                hasAnnot = (ABSEQ_DIR_ANNOT %in% analyses),
                hasAbun = (ABSEQ_DIR_ABUN %in% analyses),
                hasProd = (ABSEQ_DIR_PROD %in% analyses),
                hasDiv = (ABSEQ_DIR_DIV %in% analyses),
                name = .asRepertoireName(object),
                bitfilters = bitFilter,
                qstartfilters = qsFilter,
                sstartfilters = ssFilter,
                alignfilters = alFilter,
                rawReads = rawReadCount,
                annotReads = annotReadCount,
                filteredReads = filteredReadCount,
                productiveReads = productiveReadCount
            )

            # https://github.com/rstudio/rmarkdown/issues/861#issuecomment-326637323
            # paraphrased: just don't use output_file or output_dir
            # instead, copy to output_dir and remove it if you want to
            # as a safety measure, rename the template.Rmd file to
            # sample name so that the cache will not clash with other
            # samples it it wasn't cleared in time
            tmpTemplate <- file.path(outputDir,
                                     paste0(.asRepertoireName(object), ".Rmd"))
            file.copy(
                system.file("extdata", "template.Rmd", package = "abseqR"),
                tmpTemplate,
                overwrite = TRUE
            )
            .substituteStringInFile(tmpTemplate,
                                    "href: \"#\"",
                                    paste0("href: \"", .indexHTML, "\""),
                                    fixed = TRUE)
            rmarkdown::render(tmpTemplate, params = renderParams)
            file.remove(tmpTemplate)
            return(sub(".Rmd", ".html", tmpTemplate))
        } else {
            warning("Pandoc cannot be detected on system, skipping HTML report")
            return(NA)
        }
    }
)

#' Abundance distribution
#'
#' @import ggplot2 utils
#' @include util.R
#' @include distributions.R
#'
#' @param files list type. list of files in abundance directory
#' @param sampleNames vector type. 1-1 correspondance to files
#' @param outputDir string type.
#' @param skipDgene logical type. Skip D germline abundance plot if TRUE.
#' @param .save logical type. Save Rdata ggplot item
#'
#' @return None
.abundancePlot <- function(files,
                           sampleNames,
                           outputDir,
                           skipDgene = FALSE,
                           .save = TRUE) {
    vdj <- if (skipDgene)
        c("v", "j")
    else
        c("v", "d", "j")

    for (expression in c("family", "gene")) {
        for (gene in vdj) {
            # correction, J has no "gene" but rather variant
            if (gene == 'j' && expression == 'gene') {
                expression <- 'variant'
            }
            reg <- paste0(".*_ig",
                          gene,
                          "_dist_",
                          expression,
                          "_level\\.csv(\\.gz)?$")
            selectedFiles <- files[grepl(reg, files)]
            if (length(selectedFiles)) {
                vert <- .checkVert(selectedFiles[1])
                if (vert) {
                    width <- V_WIDTH
                    height <- V_HEIGHT
                } else {
                    width <- H_WIDTH
                    height <- H_HEIGHT
                }
                mashedName <- paste(sampleNames, collapse = ", ")
                dataframes <- lapply(
                    selectedFiles,
                    read.csv,
                    stringsAsFactors = FALSE,
                    skip = 1
                )
                subtitle <- paste("Total is",
                                  paste(lapply(selectedFiles, function(x) {
                                      as.integer(.getTotal(x))
                                  }), collapse = ", "))
                p <- .plotDist(
                    dataframes,
                    sampleNames,
                    paste0(
                        "IG",
                        toupper(gene),
                        " abundance in ",
                        mashedName
                    ),
                    vert,
                    subs = subtitle
                )
                filename <-
                    file.path(
                        outputDir,
                        paste0(
                            paste(sampleNames, collapse = "_"),
                            "_ig",
                            gene,
                            "_dist_",
                            expression,
                            "_level.png"
                        )
                    )
                ggsave(
                    filename,
                    plot = p,
                    width = width,
                    height = height
                )
                .saveAs(.save, filename, plot = p)
            }
        }
    }
}

#' V-J association plot
#'
#' @import circlize
#' @import RColorBrewer
#' @import stats
#' @import grDevices
#' @importFrom graphics title
#'
#' @param sampleName string type
#' @param path string type. Path to _vjassoc.csv
#' @param outputdir string type
#'
#' @return None
.plotCirclize <- function(sampleName, path, outputdir) {
    filename <- file.path(path, paste0(sampleName, "_vjassoc.csv"))

    message("Plotting V-J association for ", sampleName)

    if (file.exists(filename)) {
        df <- read.csv(filename)

        # output file
        outputFileName <- file.path(outputdir, gsub(".csv",
                                                    ".png",
                                                    basename(filename),
                                                    fixed = TRUE))

        png(
            outputFileName,
            width = 3.25,
            height = 3.25,
            units = "in",
            res = 800,
            pointsize = 4
        )

        # circos theme setup
        #if (length(unique(df[[1]]))-1 < 8 && length(unique(df[[2]]))-1 < 8)  {
        #    circos.par(gap.after = c(rep(5, length(unique(df[[1]]))-1), 15,
        #                             rep(5, length(unique(df[[2]]))-1), 15))
        #}

        row = rep(brewer.pal(12, "Paired"), nrow(df))[seq_along(unique(df[[1]]))]
        col = rep(rev(brewer.pal(12, "Paired")),
                  nrow(df))[seq_along(unique(df[[2]]))]

        chordDiagram(
            df,
            annotationTrack = "grid",
            preAllocateTracks = list(track.height = 0.2),
            grid.col = c(row, col)
        )
        title(sampleName, cex = 8)
        circos.trackPlotRegion(
            track.index = 1,
            bg.border = NA,
            panel.fun = function(x, y) {
                sector.name =
                    get.cell.meta.data("sector.index")
                xlim = get.cell.meta.data("xlim")
                ylim = get.cell.meta.data("ylim")
                circos.text(
                    mean(xlim),
                    ylim[1],
                    sector.name,
                    facing = "clockwise",
                    adj = c(0, 1.5)
                )
            }
        )
        circos.clear()
        dev.off()
    } else {
        warning("Could not find file ", filename,
                ". Skipping V-J association plot")
    }
}


#' Plots a plotly heatmap from provided matrix
#'
#' @import reshape2
#' @import ggplot2
#' @importFrom plotly subplot plot_ly plotly_empty layout
#'
#' @param m matrix type
#' @param title character type
#' @param xlabel character type
#' @param ylabel character type
#'
#' @return list with keys: static and interactive (ggplot2 object and plotly
#' object respectivelyb)
.hmFromMatrix <- function(m,
                          title,
                          xlabel = "",
                          ylabel = "") {
    x <- colSums(m)
    y <- rowSums(m)

    xax <- list(title = xlabel)
    yax <- list(title = ylabel)

    interactive <-
        suppressMessages(
            subplot(
                plot_ly(
                    x = as.numeric(colnames(m)),
                    y = x,
                    type = "bar",
                    color = I("DarkBlue")
                ),
                plotly_empty(type = "scatter"),
                plot_ly(
                    x = as.numeric(colnames(m)),
                    y = as.numeric(rownames(m)),
                    z = m,
                    type = "heatmap"
                ),
                plot_ly(
                    y = as.numeric(rownames(m)),
                    x = y,
                    type = "bar",
                    orientation = "h",
                    color = I("DarkBlue")
                ),
                nrows = 2,
                heights = c(0.2, 0.8),
                widths = c(0.8, 0.2),
                margin = 0,
                shareX = TRUE,
                shareY = TRUE,
                titleX = FALSE,
                titleY = FALSE
            )
        )

    static <- ggplot(melt(m), aes(x = Var2, y = Var1)) +
        geom_tile(aes(fill = value)) +
        labs(
            title = title,
            x = xlabel,
            y = ylabel,
            fill = "percent"
        ) +
        theme_bw()

    return(list(
        interactive =  plotly::layout(
            interactive,
            title = title,
            showlegend = FALSE,
            xaxis = xax,
            yaxis = yax
        ),
        static = static
    ))
}


#' Plots all 5 alignment quality heatmaps
#'
#' @description Plots alignment quality vs:
#' \itemize{
#'   \item{mismatches}
#'   \item{gaps}
#'   \item{bitscore}
#'   \item{percent identity}
#'   \item{subject start}
#' }
#'
#' @param abundanceDirectory character type.
#' fully qualified path to abundance directory
#' @param sampleName character type. sample name
#'
#' @include util.R
#' @import utils
#'
#' @return list of ggplotly heatmaps
.alignQualityHeatMaps <- function(abundanceDirectory, sampleName) {
    qualityMeasure <-
        c("mismatches", "gaps", "bitscore", "identity", "start")
    lapply(qualityMeasure, function(qual) {
        heatmapFile <-
            file.path(
                abundanceDirectory,
                paste0(sampleName, "_igv_align_quality_", qual, "_hm.tsv")
            )
        if (file.exists(heatmapFile)) {
            mat <-
                as.matrix(read.table(
                    heatmapFile,
                    skip = 1,
                    check.names = FALSE
                ))
            xlabel <- "Alignment Length"
            if (qual == "identity") {
                qual <- "%Identity"
            } else if (qual == "start") {
                qual <- "Subject start"
                xlabel <- "Query start"
            }
            totalCount <- .getTotal(heatmapFile)
            p <- .hmFromMatrix(
                mat,
                title = paste(
                    "Alignment Quality of",
                    sampleName,
                    "\nTotal is",
                    totalCount
                ),
                xlabel = xlabel,
                ylabel = qual
            )
            .saveAs(TRUE, heatmapFile, plot = p[["interactive"]])
            .saveAs(TRUE,
                    sub(".tsv", "_static.tsv", heatmapFile, fixed = TRUE),
                    plot = p[["static"]])
            ggsave(
                sub(".tsv", "_static.png", heatmapFile, fixed = TRUE),
                plot = p[["static"]],
                width = V_WIDTH,
                height = V_HEIGHT
            )
            return(p)
        } else {
            warning("Could not find ", heatmapFile, " for sample ", sampleName)
        }
    })
}


#' Conducts abundance analysis
#'
#' @import ggplot2 utils
#' @include util.R
#' @include distributions.R
#'
#' @param abundanceDirectories list type. List of sample directories
#' @param abunOut string type. Output directory
#' @param sampleNames vector type. 1-1 correspondence with abundanceDirectories
#' @param combinedNames string type. Title "combined" sample names
#' @param mashedNames string type. File "mashed" names - avoid special chars
#' @param skipDgene logical type. Skip D gene plots?
#' @param .save logical type. Save ggplot as Rdata
#'
#' @return None
.abundanceAnalysis <- function(abundanceDirectories,
                               abunOut,
                               sampleNames,
                               combinedNames,
                               mashedNames,
                               skipDgene = FALSE,
                               .save = TRUE) {
    # where to find the files
    # 3 each from V and D, then 2 from J (no gene) or 5 (exclude the 3 from D)
    searchFiles <-
        .listFilesInOrder(path = abundanceDirectories,
                          pattern = ".*ig[vdj]_dist_[family|gene|variant].*\\.csv(\\.gz)?$",
                          expectedRet = c(8, 5))
    if (length(searchFiles) > 0) {
        message("Plotting V(D)J abundance distribution for ", combinedNames)
        .abundancePlot(searchFiles,
                       sampleNames,
                       abunOut,
                       skipDgene = skipDgene)
    } else {
        warning("Could not find V(D)J abundance CSV files in ",
                paste(abundanceDirectories, collapse = ","))
    }

    # plot igv mismatches distribution
    abunIgvMismatchFiles <-
        .listFilesInOrder(path = abundanceDirectories,
                          pattern = ".*_igv_mismatches_dist\\.csv(\\.gz)?$")

    if (length(abunIgvMismatchFiles) > 0) {
        message("Plotting IGV mismatches distribution for ", combinedNames)
        subtitle <- paste("Total is",
                          paste(lapply(abunIgvMismatchFiles, function(x) {
                              as.integer(.getTotal(x))
                          }), collapse = ", "))

        abunIgvMismatches <- .plotDist(
            lapply(abunIgvMismatchFiles, read.csv, skip = 1),
            sampleNames,
            paste("Number of mismatches in V gene in", combinedNames),
            .checkVert(abunIgvMismatchFiles[[1]]),
            subs = subtitle
        )
        saveName <-
            file.path(abunOut,
                      paste0(mashedNames, "_igv_mismatches_dist.png"))
        ggsave(saveName,
               plot = abunIgvMismatches,
               width = V_WIDTH,
               height = V_HEIGHT)
        .saveAs(.save, saveName, plot = abunIgvMismatches)
    } else {
        warning("Could not find IGV mismatches distribution CSV files in ",
                paste(abundanceDirectories, collapse = ","))
    }

    # plot igv gaps distribution
    abunIgvGapsFiles <-
        .listFilesInOrder(path = abundanceDirectories,
                          pattern = ".*_igv_gaps_dist\\.csv(\\.gz)?$")
    if (length(abunIgvGapsFiles) > 0) {
        message("Plotting IGV indels distribution for ", combinedNames)
        subtitle <- paste("Total is",
                          paste(lapply(abunIgvGapsFiles, function(x) {
                              as.integer(.getTotal(x))
                          }), collapse = ", "))
        abunIgvGaps <- .plotDist(
            lapply(abunIgvGapsFiles, read.csv, skip = 1),
            sampleNames,
            paste("Number of gaps in V gene in ", combinedNames),
            .checkVert(abunIgvGapsFiles[[1]]),
            subs = subtitle
        )
        saveName <-
            file.path(abunOut, paste0(mashedNames, "_igv_gaps_dist.png"))
        ggsave(saveName,
               plot = abunIgvGaps,
               width = V_WIDTH,
               height = V_HEIGHT)
        .saveAs(.save, saveName, plot = abunIgvGaps)
    } else {
        warning("Could not find IGV indels distribution CSV files in ",
                paste(abundanceDirectories, collapse = ","))
    }

    if (length(sampleNames) == 1) {
        # we can plot circlize if there's only one sample
        .plotCirclize(sampleNames[1], abundanceDirectories[[1]], abunOut)
        # alignment quality heatmaps
        .alignQualityHeatMaps(abundanceDirectories, sampleNames[1])
    }
}

This file describes the 'ex' directory

'ex' is a toy example for the vignette and users to play around with.
The samples PCR1, PCR2, and PCR3 are generated using synthetic datasets.

The dataset used in the above examples
was obtained from a combination of synthetic sample datasets generated
using [MiXCR](https://github.com/milaboratory/mixcr)'s program 
[here](http://files.milaboratory.com/mixcr/paper/mixcr-test-1.2-SNAPSHOT.jar). 
Firstly, three distinct samples were generated, each simulated with the following parameters
in `MiXCR`:

```{r mixr-test-params, echo=FALSE, message=FALSE, warnings=FALSE, results='asis'}
tabl <- "
| Parameter     | sample 1      | sample 2      | sample 3      |
|---------------|---------------|---------------|---------------|
| reads         |  10000        |  10000        | 10000         |
| clones        |  5000         |  5000         | 2000          |
| seed          |  4228         |  2428         | 2842          |
| conf          | MiSeq-300-300 | MiSeq-300-300 | MiSeq-300-300 |
| loci          |  IGH          | IGH           | IGH           |
| species       | hsa           | hsa           | hsa           |
"
cat(tabl)
```

Following that, an arbitrary number of sequences were randomly
drawn from each of the 3 samples and randomly amplified.
This process was repeated 3 times, resulting in a final repertoire
of 3 samples, named PCR1, PCR2, and PCR3.

Finally, these 3 samples were analyzed by sabseqPy. The command used to
analyze these samples are as follows:

```bash
abseq -y params.yml
```

where the contents of `params.yml` is:

```yaml
# params.yml
defaults:
    bitscore: 300
    sstart: 1-3
    alignlen: 250
    outdir: ex
    task: all
    threads: 1
---
file1: PCR1.fasta
name: PCR1
---
file1: PCR2.fasta
name: PCR2
---
file1: PCR3.fasta
name: PCR3
```

abseqPy's analysis output on these 3 samples are contained
within the dataset described in this vignette.

---
params:
    title: "AbSeq"
    
    # img dimensions
    width: 8
    height: 5
    
    # larger sizes (if needed)
    widthL: 12
    heightL: 7.5
    
    # ggplotly?
    interactive: TRUE
    
    # eval D-gene abundance related plots? - light chain might not want this
    inclD: TRUE
    
    # sample name
    name: "PCR2"
    
    # single sample?
    single: TRUE
    
    # root output directory
    rootDir: "/newhome/jiahong/sandbox/immulator_out/out/auxiliary/PCR2"
    
    # what analysis to display in this report
    hasAnnot: TRUE
    hasAbun: TRUE
    hasProd: TRUE
    hasDiv: TRUE
    
    # summary counts - comma separated if multiple samples
    rawReads: "3000"
    annotReads: "1000"
    filteredReads: "1231"
    productiveReads: "1203"
    
    # filtering criteria - comma separated if multiple samples
    bitfilters: "350-inf"
    alignfilters: "260-inf"
    sstartfilters: "1-3.0"
    qstartfilters: "1-inf"
header-evals:
  - \usepackage{comment}
title: "`r params$title`"
output: 
    flexdashboard::flex_dashboard:
        vertical_layout: scroll
        navbar: 
            - {title: "Home", href: "#", icon: "fa-home", align: right}
---

<style type="text/css">
.chart-title {  /* increase chart title font size */
   font-size: 24px;
}
</style>

```{r abseq_report_template_setup, include=FALSE}
# Buidling rmd using loops: https://github.com/rstudio/flexdashboard/issues/80

library(flexdashboard)
library(plotly)
library(png)
library(grid)
library(gridExtra)

.getFile <- function(path, pattern, .stop = FALSE, .callback = NULL) {
    flist <- list.files(path = path, pattern = pattern, full.names = TRUE)
    n <- length(flist)
    if (n != 1 && is.null(.callback)) {
        if (.stop) {
            stop("Expected to find one file, but found ", n, " from ",
                 paste(flist, collapse = ", "), " instead.")
        } else {
            return(NA)
        }
    } else if (!is.null(.callback)) {
        flist <- flist[lapply(flist, .callback) == TRUE]
        if (length(flist) != 1) {
            if (.stop) {
                stop("Expected to find one file, but found ", n, " from ",
                     paste(flist, collapse = ", "), " instead.")
            } else {
                return(NA)
            }
        }
    }
    return(flist[[1]])
}

.compositionNoGene <- function(x) {
    return(length(grep("-", basename(x), fixed = TRUE)) == 0)
}
```


`r if(!params$hasAnnot) {"\\begin{comment}"}`


Summary {data-orientation=rows data-icon="fa-list-ul"}
=======================================================================


Row
-----------------------------------------------------------------------

`r paste(knitr::knit(text = knitr::knit_expand(text = paste("### Overview of", params$name))))`
```{r abseq_summary_table, echo = FALSE, eval = TRUE}
sampleNames <- unlist(strsplit(params$name, "_vs_"))
# counts
splitRaw <- unlist(strsplit(params$rawReads, ","))
splitAnnot <- unlist(strsplit(params$annotReads, ","))
splitFiltered <- unlist(strsplit(params$filteredReads, ","))
splitProd <- unlist(strsplit(params$productiveReads, ","))

# filtering
splitBit <- unlist(strsplit(params$bitfilters, ","))
splitAl <- unlist(strsplit(params$alignfilters, ","))
splitSStart <- unlist(strsplit(params$sstartfilters, ","))
splitQStart <- unlist(strsplit(params$qstartfilters, ","))

overviewOut <- lapply(seq_along(sampleNames), function(i) {
    rawR <- as.numeric(splitRaw[i])
    annotR <- as.numeric(splitAnnot[i])
    filtR <- as.numeric(splitFiltered[i])
    # might be NA if productivity analysis wasn't conducted
    prodR <- suppressWarnings(as.numeric(splitProd[i]))
    line1 <- knitr::knit_expand(text = sprintf("#### %s\n\n", sampleNames[i]))
    line2 <- knitr::knit_expand(text = sprintf("* Number of raw reads %s\n", prettyNum(rawR, big.mark = ",")))
    line3 <- knitr::knit_expand(text = sprintf("* Number of annotated reads %s%% (%s/%s)\n", round((annotR/rawR)*100, 2) , prettyNum(annotR, big.mark = ","), prettyNum(rawR, big.mark = ",")))
    line4 <- knitr::knit_expand(text = sprintf("* Number of reads after filtering %s%% (%s/%s)\n",
                                               round((filtR/annotR)*100, 2), prettyNum(filtR, big.mark = ","), prettyNum(annotR, big.mark = ",")))
    line5 <- knitr::knit_expand(text = sprintf("* Number of productive reads %s%% (%s/%s)\n", round((prodR/filtR)*100, 2), prettyNum(prodR, big.mark = ","), prettyNum(filtR, big.mark = ",")))
    line6 <- knitr::knit_expand(text = "\nThe following criteria are applied on the _V gene only_\n")
    line7 <- knitr::knit_expand(text = "\n\n|Filtering criterion|Value|\n")
    line8 <- knitr::knit_expand(text = "|--------------------|:-----:|\n")
    line9 <- knitr::knit_expand(text = sprintf("|Bitscore | %s|\n", splitBit[i]))
    line10 <- knitr::knit_expand(text = sprintf("|V gene alignment length | %s|\n", splitAl[i]))
    line11 <- knitr::knit_expand(text = sprintf("|Subject start position | %s|\n", splitSStart[i]))
    line12 <- knitr::knit_expand(text = sprintf("|Query start position | %s|\n", splitQStart[i]))
    line13 <- knitr::knit_expand(text = "\n\nSequences that do not satisfy the above filtering criteria are _excluded_ from the analysis.\n\n")
    paste0(line1, line2, line3, line4, line5, line6, line7, line8, line9,
          line10, line11, line12, line13)
})
```

`r paste(knitr::knit(text = paste(overviewOut, collapse = "\n")))`


Row
-----------------------------------------------------------------------

### Sequence lengths without outlier removal

```{r abseq_seq_len, eval=params$hasAnnot, fig.width=params$width, fig.height=params$height}
fname <- .getFile(path = file.path(params$rootDir, "annot"),
                  pattern = ".*_all_clones_len_dist\\.Rdata")
if (!is.na(fname)) {
    load(fname)
    if (params$interactive) {
        ggplotly(plot)
    } else {
        plot
    }
} else {
    ggplot(data.frame()) + xlim(0, 10) + ylim(0, 10) + annotate("text", x = 5, y = 5, label = "Plot unavailable")
}
```

Row
-----------------------------------------------------------------------

### Sequence lengths __with__ outlier removal

```{r abseq_seq_len_no_out, eval=params$hasAnnot, fig.width=params$width, fig.height=params$height}
fname <- .getFile(path = file.path(params$rootDir, "annot"),
                  pattern = ".*_all_clones_len_dist_no_outliers\\.Rdata")
if (!is.na(fname)) {
    load(fname)
    if (params$interactive) {
        ggplotly(plot)
    } else {
        plot
    }
} else {
    ggplot(data.frame()) + xlim(0, 10) + ylim(0, 10) + annotate("text", x = 5, y = 5, label = "Plot unavailable")
}
```


`r if(!params$hasAnnot) {"\\end{comment}"}`


`r if(!params$hasAbun) {"\\begin{comment}"}`


Quality {data-orientation=rows data-icon="fa-clipboard-list"}
=======================================================================

Row
-----------------------------------------------------------------------

### Indels (Gaps)
```{r abseq_v_indel, eval=params$hasAbun, fig.width=params$width, fig.height=params$height}
fname <- .getFile(path = file.path(params$rootDir, "abundance"),
                  pattern = ".*_igv_gaps_dist\\.Rdata")
if (!is.na(fname)) {
    load(fname)
    if (params$interactive) {
        ggplotly(plot)
    } else {
        plot
    }
} else {
    ggplot(data.frame()) + xlim(0, 10) + ylim(0, 10) + annotate("text", x = 5, y = 5, label = "Plot unavailable")
}
```

> Plot of insertions and deletions found within the __V gene__

### Mismatches
```{r abseq_v_mismatch, eval=params$hasAbun, fig.width=params$width, fig.height=params$height}
fname <- .getFile(path = file.path(params$rootDir, "abundance"),
                  pattern = ".*_igv_mismatches_dist\\.Rdata")
if (!is.na(fname)) {
    load(fname)
    if (params$interactive) {
        ggplotly(plot)
    } else {
        plot
    }
} else {
    ggplot(data.frame()) + xlim(0, 10) + ylim(0, 10) + annotate("text", x = 5, y = 5, label = "Plot unavailable")
}
```

> Plot of nucleotide base mismatches found within the __V gene__


`r if(!params$hasAbun) {"\\end{comment}"}`

`r if(!params$hasAbun || !params$single) {"\\begin{comment}"}`

Row
-----------------------------------------------------------------------

```{r abseq_qual_heatmap_helper_function, echo = FALSE}
.renderHMText <- function(alignQual) {
    fileInteractiveness <- if (params$interactive) "" else "_static"
    alignmentQuality <- lapply(seq_along(alignQual), function(i) {
        line1 <- knitr::knit_expand(text = sprintf("### %s\n", names(alignQual)[i]))
        line2 <- knitr::knit_expand(text = sprintf("\n```{r abseq_align_qual_chunk_%s, eval=params$hasAbun, fig.width=params$width, fig.height=params$height}", alignQual[[i]]))
        line3 <- knitr::knit_expand(text = sprintf('\nfname <- .getFile(path = file.path(params$rootDir, "abundance"), pattern = ".*_igv_align_quality_%s_hm%s\\\\.Rdata")', alignQual[[i]], fileInteractiveness))
        line4 <- knitr::knit_expand(text = '\nif(!is.na(fname)) { load(fname); plot } else { ggplot(data.frame()) + xlim(0, 10) + ylim(0, 10) + annotate("text", x = 5, y = 5, label = "404!") }')
        line5 <- knitr::knit_expand(text = "\n```\n")
        paste(line1, line2, line3, line4, line5, collapse = "\n")
    })
    return(alignmentQuality)
}

```

```{r abseq_quality_heatmaps, echo = FALSE, eval =(params$single && params$hasAbun)}
alignQual <- list("Bitscore vs Alignment Length" = "bitscore",
                  "Identity vs Alignment Length" = "identity")
alignmentQuality <- .renderHMText(alignQual)
```

`r if (params$hasAbun && params$single) { paste(knitr::knit(text = paste(alignmentQuality, collapse = "\n"))) }`

Row
-----------------------------------------------------------------------

```{r abseq_quality_heatmaps_pt2, echo = FALSE, eval =(params$single && params$hasAbun)}
alignQual <- list("Gaps vs Alignment Length" = "gaps",
                  "Mismatches vs Alignment Length" = "mismatches")
alignmentQuality.pt2 <- .renderHMText(alignQual)
```

`r if (params$hasAbun && params$single) { paste(knitr::knit(text = paste(alignmentQuality.pt2, collapse = "\n"))) }`


Row
-----------------------------------------------------------------------

```{r abseq_quality_heatmaps_pt3, echo = FALSE, eval =(params$single && params$hasAbun)}
alignQual <- list("Subject Start vs Query Start" = "start")
alignmentQuality.pt3 <- .renderHMText(alignQual)
```

`r if (params$hasAbun && params$single) { paste(knitr::knit(text = paste(alignmentQuality.pt3, collapse = "\n"))) }`


### Placeholder

```{r abseq_quality_heatmaps_pt4, echo = FALSE, eval =(params$single && params$hasAbun)}
ggplot(data.frame()) + xlim(0, 10) + ylim(0, 10) + annotate("text", x = 5, y = 5, label = "Placeholder")
```


`r if(!params$hasAbun || !params$single) {"\\end{comment}"}`


`r if(!params$hasAbun) {"\\begin{comment}"}`

Abundance {data-orientation=rows data-icon="fa-chart-bar"}
=======================================================================

Row
-----------------------------------------------------------------------

### V family 

```{r abseq_v_family, eval=params$hasAbun, fig.width=params$width, fig.height=params$height}
fname <- .getFile(path = file.path(params$rootDir, "abundance"),
                  pattern = ".*igv_dist_family_level\\.Rdata")
if (!is.na(fname)) {
    load(fname)
    if (params$interactive) {
        ggplotly(plot)
    } else {
        plot
    }
} else {
    ggplot(data.frame()) + xlim(0, 10) + ylim(0, 10) + annotate("text", x = 5, y = 5, label = "Plot unavailable")
}
```

### V gene

```{r abseq_v_gene, eval=params$hasAbun, fig.width=params$height, fig.height=params$width}
fname <- .getFile(path = file.path(params$rootDir, "abundance"),
                  pattern = ".*igv_dist_gene_level\\.Rdata")
if (!is.na(fname)) {
    load(fname)
    # TODO: ggplotly is buggy with horizontal plot in tabsets
    if (params$interactive) {
        plot
        #ggplotly(plot)
    } else {
        plot
    }
} else {
    ggplot(data.frame()) + xlim(0, 10) + ylim(0, 10) + annotate("text", x = 5, y = 5, label = "Plot unavailable")
}
```

> Only the top 15 from each sample are shown

`r if(!params$hasAbun) {"\\end{comment}"}`

`r if(!params$inclD || !params$hasAbun) {"\\begin{comment}"}`


Row
-----------------------------------------------------------------------

### D family

```{r abseq_d_family, eval=(params$inclD && params$hasAbun), fig.width=params$width, fig.height=params$height}
fname <- .getFile(path = file.path(params$rootDir, "abundance"),
                  pattern = ".*igd_dist_family_level\\.Rdata")
if (!is.na(fname)) {
    load(fname)
    if (params$interactive) {
        ggplotly(plot)
    } else {
        plot
    }
} else {
    ggplot(data.frame()) + xlim(0, 10) + ylim(0, 10) + annotate("text", x = 5, y = 5, label = "Plot unavailable")
}
```

### D gene

```{r abseq_d_gene, eval=(params$inclD && params$hasAbun), fig.width=params$height, fig.height=params$width}
fname <- .getFile(path = file.path(params$rootDir, "abundance"),
                  pattern = ".*igd_dist_gene_level\\.Rdata")
if (!is.na(fname)) {
    load(fname)
    # TODO: ggplotly is buggy with horizontal plot in tabsets
    if (params$interactive) {
        plot
        #ggplotly(plot)
    } else {
        plot
    }
} else {
    ggplot(data.frame()) + xlim(0, 10) + ylim(0, 10) + annotate("text", x = 5, y = 5, label = "Plot unavailable")
}
    
```

> Only the top 15 from each sample are shown


`r if(!params$inclD || !params$hasAbun) {"\\end{comment}"}`


`r if(!params$hasAbun) {"\\begin{comment}"}`

Row
-----------------------------------------------------------------------

### J family

```{r abseq_j_family, eval=params$hasAbun, fig.width=params$width, fig.height=params$height}
fname <- .getFile(path = file.path(params$rootDir, "abundance"),
                  pattern = ".*igj_dist_family_level\\.Rdata")
if (!is.na(fname)) {
    load(fname)
    if (params$interactive) {
        ggplotly(plot)
    } else {
        plot
    }
} else {
    ggplot(data.frame()) + xlim(0, 10) + ylim(0, 10) + annotate("text", x = 5, y = 5, label = "Plot unavailable")
}
```

### J variant

```{r abseq_j_variant, eval=params$hasAbun, fig.width=params$height, fig.height=params$width}
fname <- .getFile(path = file.path(params$rootDir, "abundance"),
                  pattern = ".*igj_dist_variant_level\\.Rdata")
if (!is.na(fname)) {
    load(fname)
    # TODO: ggplotly is buggy with horizontal plot in tabsets
    if (params$interactive) {
        plot
        #ggplotly(plot)
    } else {
        plot
    }
} else {
    ggplot(data.frame()) + xlim(0, 10) + ylim(0, 10) + annotate("text", x = 5, y = 5, label = "Plot unavailable")
}
```

> Only the top 15 from each sample are shown


`r if(!params$hasAbun) {"\\end{comment}"}`

`r if(!params$hasAbun || !params$single) {"\\begin{comment}"}`



Row
-----------------------------------------------------------------------

### V-J association

```{r abseq_v_j_assoc, eval=(params$single && params$hasAbun), fig.width=params$width, fig.height=params$height}
fname <- .getFile(path = file.path(params$rootDir, "abundance"), pattern = ".*_vjassoc\\.png")
if (!is.na(fname)) {
    img <- readPNG(fname)
    grid.raster(img)
} else {
    ggplot(data.frame()) + xlim(0, 10) + ylim(0, 10) + annotate("text", x = 5, y = 5, label = "Plot unavailable")
}
```

> Plot associations between V genes and J genes on the family level



`r if(!params$hasAbun || !params$single) {"\\end{comment}"}`

`r if(!params$hasProd) {"\\begin{comment}"}`


Productivity {data-orientation=rows data-icon="fa-check"}
=======================================================================

Row
-----------------------------------------------------------------------

### Productivity summary

```{r abseq_prod, eval=params$hasProd, fig.width=params$width, fig.height=params$height}
fname <- .getFile(path = file.path(params$rootDir, "productivity"),
                  pattern = ".*_productivity\\.Rdata")
if (!is.na(fname)) {
    load(fname)
    if (params$interactive) {
        # TODO: buggy facet plot
        plot
        # ggplotly(plot)
    } else {
        plot
    }
} else {
    ggplot(data.frame()) + xlim(0, 10) + ylim(0, 10) + annotate("text", x = 5,
                                                                y = 5, label =
                                                                    "404!")
}
```

> Productivity distribution of sample based on stop codons and frameshifts

### Frameshift distribution

```{r abseq_frameshift, eval=params$hasProd, fig.width=params$width, fig.height=params$height}
fname <- .getFile(path = file.path(params$rootDir, "productivity"),
                  pattern = ".*_vjframe_dist\\.Rdata")

if (!is.na(fname)) {
    load(fname)
    if (params$interactive) {
        ggplotly(plot)
    } else {
        plot
    }
} else {
    ggplot(data.frame()) + xlim(0, 10) + ylim(0, 10) + annotate("text", x = 5,
                                                                y = 5, label =
                                                                    "404!")
}
```

> Distribution of in-frame and out-of-frame sequences

Row {.tabset .tabset-fade}
-----------------------------------------------------------------------

<!--- TODO: fix legend && beware of missing samples when doing so -->
```{r abseq_region_gaps_mismatch, echo = FALSE, eval = TRUE}
titles <- c("FR1", "CDR1", "FR2", "CDR2", "FR3", "CDR3")
frcdrMisGaps <- lapply(seq_along(titles), function(i) {
    line1 <- knitr::knit_expand(text = sprintf("### %s\n", titles[i]))
    line2 <- knitr::knit_expand(text = sprintf("\n```{r abseq_frcdr_gap_mis_chunk_%d, eval=params$hasProd, fig.width=params$width*3, fig.height=params$height}", i))
    line3 <- knitr::knit_expand(text = sprintf('\nfname <- .getFile(file.path(params$rootDir, "productivity"), pattern = ".*_%s_mismatches_dist\\\\.Rdata")', tolower(titles[i])))
    line4 <- knitr::knit_expand(text = sprintf('\nif (!is.na(fname)) { load(fname); if (params$interactive) { mismatch <- ggplotly(plot + labs(title = "Mismatches, gaps and gaps in out-of-frame sequences in %s")) } else { mismatch <- plot } } else { df <- data.frame(); mismatch <- ggplot(df) + xlim(0, 10) + ylim(0, 10) + annotate("text", x = 5, y = 5, label = "Plot unavailable") }', titles[i]))
    line5 <- knitr::knit_expand(text = sprintf('\nfname <- .getFile(file.path(params$rootDir, "productivity"), pattern = ".*_%s_gaps_dist\\\\.Rdata")', tolower(titles[i])))
    line6 <- knitr::knit_expand(text = '\nif (!is.na(fname)) { load(fname); if (params$interactive) { gaps <- ggplotly(plot + labs(title = "")) } else { gaps <- plot } } else { df <- data.frame(); gaps <- ggplot(df) + xlim(0, 10) + ylim(0, 10) + annotate("text", x = 5, y = 5, label = "Plot unavailable")}')
    line7 <- knitr::knit_expand(text = sprintf('\nfname <- .getFile(file.path(params$rootDir, "productivity"), pattern = ".*_%s_gaps_dist_out_of_frame\\\\.Rdata")', tolower(titles[i])))
    line8 <- knitr::knit_expand(text = '\nif (!is.na(fname)) { load(fname); if (params$interactive) { gapsOut <- ggplotly(plot + labs(title = "")) } else { gapsOut <- plot } } else { df <- data.frame(); gapsOut <- ggplot(df) + xlim(0, 10) + ylim(0, 10) + annotate("text", x = 5, y = 5, label = "Plot unavailable") }')
    line9 <- knitr::knit_expand(text = "\nif (params$interactive) { subplot(mismatch, gaps, gapsOut, titleX = TRUE, titleY = TRUE) } else { grid.arrange(mismatch, gaps, gapsOut, nrow = 1)}")
    line10 <- knitr::knit_expand(text = "\n```\n")
    line11 <- knitr::knit_expand(text = sprintf("\n> Proportion of mismatches in productive sequences, gaps in productive sequences, and gaps in out-of-frame sequences in %s region\n", titles[i]))
    paste(line1, line2, line3, line4, line5, line6, line7, line8, line9, line10,
          line11, collapse = "\n")
})
```


<!--- TODO: fix legend && beware of missing samples when doing so -->

```{r abseq_vdj_gap_mismatch, echo = FALSE, eval = TRUE}
if (params$inclD) {
    titles <- c("IGV", "IGD", "IGJ")
} else {
    titles <- c("IGV", "IGJ")
}
vdjMisGaps <- lapply(seq_along(titles), function(i) {
    line1 <- knitr::knit_expand(text = sprintf("### %s\n", titles[i]))
    line2 <- knitr::knit_expand(text = sprintf("\n```{r abseq_vdj_gap_mis_chunk_%d, eval=params$hasProd, fig.width=params$width*3, fig.height=params$height}", i))
    line3 <- knitr::knit_expand(text = sprintf('\nfname <- .getFile(file.path(params$rootDir, "productivity"), pattern = ".*_%s_mismatches_dist\\\\.Rdata")', tolower(titles[i])))
    line4 <- knitr::knit_expand(text = sprintf('\nif (!is.na(fname)) { load(fname); if (params$interactive) { mismatch <- ggplotly(plot + labs(title = "Mismatches and gaps in %s")) } else { mismatch <- plot } } else { df <- data.frame(); mismatch <- ggplot(df) + xlim(0, 10) + ylim(0, 10) + annotate("text", x = 5, y = 5, label = "Plot unavailable") }', titles[i]))
    line5 <- knitr::knit_expand(text = sprintf('\nfname <- .getFile(file.path(params$rootDir, "productivity"), pattern = ".*_%s_gaps_dist\\\\.Rdata")', tolower(titles[i])))
    line6 <- knitr::knit_expand(text = '\nif (!is.na(fname)) { load(fname); if (params$interactive) { gaps <- ggplotly(plot + labs(title = "")) } else { gaps <- plot } } else { df <- data.frame(); gaps <- ggplot(df) + xlim(0, 10) + ylim(0, 10) + annotate("text", x = 5, y = 5, label = "Plot unavailable") }')
    line7 <- knitr::knit_expand(text = "\nif (params$interactive) { subplot(mismatch, gaps, titleX = TRUE, titleY = TRUE) } else { grid.arrange(mismatch, gaps, nrow = 1)}")
    line8 <- knitr::knit_expand(text = "\n```\n")
    line9 <- knitr::knit_expand(text = sprintf("\n> Proportion of mismatches and gaps in productive sequences in %s\n", titles[i]))
    paste(line1, line2, line3, line4, line5, line6, line7, line8, line9, collapse = "\n")
})
```

`r paste(knitr::knit(text = paste(frcdrMisGaps, collapse = "\n")))`
`r paste(knitr::knit(text = paste(vdjMisGaps, collapse = "\n")))`



Row {.tabset .tabset-fade}
-----------------------------------------------------------------------

### IGV productive distribution

```{r abseq_v_prod, eval=params$hasProd, fig.width=params$width, fig.height=params$height}
fname <- .getFile(path = file.path(params$rootDir, "productivity"),
                  pattern = ".*_igv_dist_productive\\.Rdata")

if (!is.na(fname)) {
    load(fname)
    if (params$interactive) {
        ggplotly(plot)
    } else {
        plot
    }
} else {
    ggplot(data.frame()) + xlim(0, 10) + ylim(0, 10) + annotate("text", x = 5, y = 5, label = "Plot unavailable")
}
```

> Distribution of productive sequences from IGV family

### IGV inframe, unproductive distribution

```{r abseq_v_frame_prod, eval=params$hasProd, fig.width=params$width, fig.height=params$height}
fname <- .getFile(path = file.path(params$rootDir, "productivity"),
                  pattern = ".*_igv_dist_inframe_unproductive\\.Rdata")

if (!is.na(fname)) {
    load(fname)
    if (params$interactive) {
        ggplotly(plot)
    } else {
        plot
    }
} else {
    ggplot(data.frame()) + xlim(0, 10) + ylim(0, 10) + annotate("text", x = 5, y = 5, label = "Plot unavailable")
}
```

> Distribution of in-frame but unproductive sequences from IGV family

### IGV out-of-frame distribution

```{r abseq_v_out_frame, eval=params$hasProd, fig.width=params$width, fig.height=params$height}
fname <- .getFile(path = file.path(params$rootDir, "productivity"),
                  pattern = ".*_igv_dist_out_of_frame\\.Rdata")

if (!is.na(fname)) {
    load(fname)
    if (params$interactive) {
        ggplotly(plot)
    } else {
        plot
    }
} else {
    ggplot(data.frame()) + xlim(0, 10) + ylim(0, 10) + annotate("text", x = 5, y = 5, label = "Plot unavailable")
}
```

> Distribution of out-of-frame sequences from IGV family


Row {.tabset .tabset-fade}
-----------------------------------------------------------------------

### Inframe

```{r abseq_stop_codon_region_in, eval=params$hasProd, fig.width=params$width, fig.height=params$height}
fname <- .getFile(path = file.path(params$rootDir, "productivity"),
                  pattern = ".*_stopcodon_region_inframe\\.Rdata", .stop = FALSE)
if (is.na(fname)) {
    ggplot(data.frame()) + xlim(0, 10) + ylim(0, 10) + annotate("text", x = 5, y = 5, label = "Plot unavailable")
} else {
    load(fname)
    if (params$interactive) {
        ggplotly(plot)
    } else {
        plot
    }
}

```

> Distribution of stop codons in CDR/FR regions from in-frame sequences

### Out-of-frame
```{r abseq_stop_codon_region_out, eval=params$hasProd, fig.width=params$width, fig.height=params$height}
fname <- .getFile(path = file.path(params$rootDir, "productivity"),
                  pattern = ".*_stopcodon_region_outframe\\.Rdata", .stop = FALSE)
if (is.na(fname)) {
    ggplot(data.frame()) + xlim(0, 10) + ylim(0, 10) + annotate("text", x = 5, y = 5, label = "Plot unavailable")
} else {
    load(fname)
    if (params$interactive) {
        ggplotly(plot)
    } else {
        plot
    }
}
```

> Distribution of stop codons in CDR/FR regions from out-of-frame sequences



`r if(!params$hasProd) {"\\end{comment}"}`



`r if(!params$hasDiv) {"\\begin{comment}"}`



<!--- TODO: currently, assumes that all 3 rarefaction, duplication, and recapture
are present because of the ggplotly legend hack -->

Diversity {data-orientation=rows data-icon="fa-chart-line"}
=======================================================================

Row {.tabset .tabset-fade}
-----------------------------------------------------------------------

### CDR-V

```{r abseq_cdr_v_diversity, eval=params$hasDiv, fig.width=params$width*3, fig.height=params$height}

fname <- .getFile(path = file.path(params$rootDir, "diversity"),
                  pattern = ".*_cdr_v_duplication\\.Rdata")

if (!is.na(fname)) {
    load(fname)
    dup <- plot + labs(title = "Sequence duplication level, rarefaction, and recapture")
} else {
    dup <- ggplot(data.frame()) + xlim(0, 10) + ylim(0, 10) + annotate("text", x = 5, y = 5, label = "Plot unavailable")
}

fname <- .getFile(path = file.path(params$rootDir, "diversity"),
                  pattern = ".*_cdr_v_rarefaction\\.Rdata")

if (!is.na(fname)) {
    load(fname)
    rare <- plot + labs(title = "")
} else {
    rare <- ggplot(data.frame()) + xlim(0, 10) + ylim(0, 10) + annotate("text", x = 5, y = 5, label = "Plot unavailable")
}

fname <- .getFile(path = file.path(params$rootDir, "diversity"),
                  pattern = ".*_cdr_v_recapture\\.Rdata")
if (!is.na(fname)) {
    load(fname)
    recap <- plot + labs(title = "")
} else {
    recap <- ggplot(data.frame()) + xlim(0, 10) + ylim(0, 10) + annotate("text", x = 5, y = 5, label = "Plot unavailable")
}

if (params$interactive) {
    dup <- hide_legend(dup)
    rare <- hide_legend(rare)
    p <- subplot(hide_legend(dup), hide_legend(rare), recap,
                 titleX = TRUE, titleY = TRUE)
    .p <- plotly_build(p)
    for (i in seq_along(.p$x$data)) {
        if (length(grep(",\\d+(,NA)?\\)$", .p$x$data[[i]]$name))) {
            .p$x$data[[i]]$showlegend <- FALSE
        }
    }
    .p
} else {
    grid.arrange(dup, rare, recap, nrow = 1)
}
```

> Duplication level, rarefaction and recapture plots for CDR (regions) and
(V)ariable domain


### CDR

```{r abseq_cdr_diversity, eval=params$hasDiv, fig.width=params$width*3, fig.height=params$height}

fname <- .getFile(path = file.path(params$rootDir, "diversity"),
                  pattern = ".*_cdr_duplication\\.Rdata")

if (!is.na(fname)) {
    load(fname)
    dup <- plot + labs(title = "Sequence duplication level, rarefaction, and recapture")
} else {
    dup <- ggplot(data.frame()) + xlim(0, 10) + ylim(0, 10) + annotate("text", x = 5, y = 5, label = "Plot unavailable")
}

fname <- .getFile(path = file.path(params$rootDir, "diversity"),
                  pattern = ".*_cdr_rarefaction\\.Rdata")

if (!is.na(fname)) {
    load(fname)
    rare <- plot + labs(title = "")
} else {
    rare <- ggplot(data.frame()) + xlim(0, 10) + ylim(0, 10) + annotate("text", x = 5, y = 5, label = "Plot unavailable")
}

fname <- .getFile(path = file.path(params$rootDir, "diversity"),
                  pattern = ".*_cdr_recapture\\.Rdata")
if (!is.na(fname)) {
    load(fname)
    recap <- plot + labs(title = "")
} else {
    recap <- ggplot(data.frame()) + xlim(0, 10) + ylim(0, 10) + annotate("text", x = 5, y = 5, label = "Plot unavailable")
}

if (params$interactive) {
    dup <- hide_legend(dup)
    rare <- hide_legend(rare)
    p <- subplot(hide_legend(dup), hide_legend(rare), recap,
                 titleX = TRUE, titleY = TRUE)
    .p <- plotly_build(p)
    for (i in seq_along(.p$x$data)) {
        if (length(grep(",\\d+(,NA)?\\)$", .p$x$data[[i]]$name))) {
            .p$x$data[[i]]$showlegend <- FALSE
        }
    }
    .p
} else {
    grid.arrange(dup, rare, recap, nrow = 1)
}
```

> Duplication level, rarefaction and recapture plots for CDR (regions)


### FR

```{r abseq_fr_diversity, eval=params$hasDiv, fig.width=params$width*3, fig.height=params$height}

fname <- .getFile(path = file.path(params$rootDir, "diversity"),
                  pattern = ".*_fr_duplication\\.Rdata")

if (!is.na(fname)) {
    load(fname)
    dup <- plot + labs(title = "Sequence duplication level, rarefaction, and recapture")
} else {
    dup <- ggplot(data.frame()) + xlim(0, 10) + ylim(0, 10) + annotate("text", x = 5, y = 5, label = "Plot unavailable")
}

fname <- .getFile(path = file.path(params$rootDir, "diversity"),
                  pattern = ".*_fr_rarefaction\\.Rdata")

if (!is.na(fname)) {
    load(fname)
    rare <- plot + labs(title = "")
} else {
    rare <- ggplot(data.frame()) + xlim(0, 10) + ylim(0, 10) + annotate("text", x = 5, y = 5, label = "Plot unavailable")
}

fname <- .getFile(path = file.path(params$rootDir, "diversity"),
                  pattern = ".*_fr_recapture\\.Rdata")
if (!is.na(fname)) {
    load(fname)
    recap <- plot + labs(title = "")
} else {
    recap <- ggplot(data.frame()) + xlim(0, 10) + ylim(0, 10) + annotate("text", x = 5, y = 5, label = "Plot unavailable")
}

if (params$interactive) {
    dup <- hide_legend(dup)
    rare <- hide_legend(rare)
    p <- subplot(hide_legend(dup), hide_legend(rare), recap,
                 titleX = TRUE, titleY = TRUE)
    .p <- plotly_build(p)
    for (i in seq_along(.p$x$data)) {
        if (length(grep(",\\d+(,NA)?\\)$", .p$x$data[[i]]$name))) {
            .p$x$data[[i]]$showlegend <- FALSE
        }
    }
    .p
} else {
    grid.arrange(dup, rare, recap, nrow = 1)
}
```

> Duplication level, rarefaction and recapture plots for FR (regions)



Row {.tabset .tabset-fade}
-----------------------------------------------------------------------

```{r abseq_spectratype, echo=FALSE, eval=params$hasDiv}
regions <-
    c(
    "FR1" = "_fr1_spectratype",
    "CDR1" = "_cdr1_spectratype",
    "FR2" = "_fr2_spectratype",
    "CDR2" = "_cdr2_spectratype",
    "FR3" = "_fr3_spectratype",
    "CDR3" = "_cdr3_spectratype",
    "CDR3 without outliers" = "_cdr3_spectratype_no_outliers",
    "FR4" = "_fr4_spectratype",
    "V domain" = "_v_spectratype"
    )
specOut <- lapply(seq_along(regions), function(i) {
    line1 <- knitr::knit_expand(text = sprintf("### %s\n", names(regions)[[i]]))
    line2 <- knitr::knit_expand(text = sprintf("\n```{r abseq_spec_out_%d, eval=params$hasDiv, fig.width=params$width, fig.height=params$height}\n", i))
    line3 <- knitr::knit_expand(text = sprintf('\nfname <- .getFile(path = file.path(params$rootDir, "diversity", "spectratypes"), pattern = ".*%s\\\\.Rdata")\n', regions[[i]]))
    line4 <- knitr::knit_expand(text = '\nif (!is.na(fname)) { load(fname); if (params$interactive) { ggplotly(plot); } else { plot; } } else { ggplot(data.frame()) + xlim(0, 10) + ylim(0, 10) + annotate("text", x = 5, y = 5, label = "Plot unavailable"); }')
    line5 <- knitr::knit_expand(text = "\n```\n")
    line6 <- knitr::knit_expand(text = sprintf("\n> Amino acid length distribution for %s region\n", names(regions)[[i]]))
    paste(line1, line2, line3, line4, line5, line6, collapse = "\n")
})
```

`r if (params$hasDiv) { paste(knitr::knit(text = paste(specOut, collapse = '\n'))) }`


`r if(!params$hasDiv) {"\\end{comment}"}`


`r if(!params$hasDiv || !params$single) {"\\begin{comment}"}`


Row {.tabset .tabset-fade}
-----------------------------------------------------------------------


```{r abseq_composition_logos, echo = FALSE, eval = (params$single && params$hasDiv)}
regions = c("FR1", "CDR1", "FR2", "CDR2", "FR3", "CDR3", "FR4")
compOut <- lapply(seq_along(regions), function(i) {
    line1 <- knitr::knit_expand(text = sprintf("### %s\n", regions[i]))
    line2 <- knitr::knit_expand(text = sprintf("\n```{r abseq_comp_out_%d, eval=(params$hasDiv && params$single), fig.width=params$width*2, fig.height=params$height}\n", i))
    line3 <- knitr::knit_expand(text = sprintf('\nfname <- .getFile(file.path(params$rootDir, "diversity", "composition_logos", "%s"), pattern = ".*_cumulative_logo\\\\.Rdata", .callback = .compositionNoGene)', regions[i]))
    line4 <- knitr::knit_expand(text = '\nremoveLegend <- FALSE; if (!is.na(fname)) { load(fname); unscaled <- plot; } else { unscaled <- ggplot(data.frame()) + xlim(0, 10) + ylim(0, 10) + annotate("text", x = 5, y = 5, label = "404!"); }')
    line5 <- knitr::knit_expand(text = sprintf('\nfname <- .getFile(file.path(params$rootDir, "diversity", "composition_logos", "%s"), pattern = ".*_cumulative_logo_scaled\\\\.Rdata", .callback = .compositionNoGene)', regions[i]))
    line6 <- knitr::knit_expand(text = '\nif (!is.na(fname)) { load(fname); scaled <- plot; removeLegend <- TRUE; } else { scaled <- ggplot(data.frame()) + xlim(0, 10) + ylim(0, 10) + annotate("text", x = 5, y = 5, label = "404!"); }')
    line7 <- knitr::knit_expand(text = '\nif (params$interactive) { if (removeLegend) { unscaled <- hide_legend(ggplotly(unscaled)) }; p <- subplot(unscaled, scaled); .p <- plotly_build(p); for (i in seq_along(.p$x$data)) { if (length(grep("x\\\\d+", .p$x$data[[i]]$xaxis))) { .p$x$data[[i]]$showlegend <- FALSE } }; .p; } else { grid.arrange(unscaled, scaled, nrow = 1) }')
    line8 <- knitr::knit_expand(text = "\n```\n")
    if (regions[i] == "FR3") {
        line9 <- knitr::knit_expand(text = "\n> Composition logo plot was truncated to the first 30 amino acids.\n")
    } else {
        line9 <- knitr::knit_expand(text = sprintf("\n> Amino acid composition logos in %s - unscaled (sum to 1 in each individual position) and scaled (to the max number of sequences in a given position).\n", regions[i]))
    }
    paste(line1, line2, line3, line4, line5, line6, line7, line8, line9, collapse = "\n")
})
```

`r if (params$single && params$hasDiv) { paste(knitr::knit(text = paste(compOut, collapse = '\n'))) }`



Row {.tabset .tabset-fade}
-----------------------------------------------------------------------

```{r abseq_motifs_diversity, echo = FALSE, eval = (params$hasDiv && params$single)}
regions = c("FR1", "CDR1", "FR2", "CDR2", "FR3", "CDR3", "FR4")
motifOut <- lapply(seq_along(regions), function(i) {
    line1 <- knitr::knit_expand(text = sprintf("### %s (aligned, unaligned)\n", regions[i]))
    line2 <- knitr::knit_expand(text = sprintf("\n```{r abseq_motif_out_%d, eval=(params$hasDiv && params$single), fig.width=params$width*2, fig.height=params$height}", i))
    line3 <- knitr::knit_expand(text = sprintf('\nfname <- .getFile(path = file.path(params$rootDir, "diversity", "motifs"), pattern = ".*%s_motif_aligned_logo\\\\.png")', tolower(regions[i])))
    line4 <- knitr::knit_expand(text = '\nif (!is.na(fname)) { imgAl <- rasterGrob(as.raster(readPNG(fname)), interpolate = FALSE) } else { imgAl <- ggplot(data.frame()) + xlim(0, 10) + ylim(0, 10) + annotate("text", x = 5, y = 5, label = "Plot unavailable") }')
    line5 <- knitr::knit_expand(text = sprintf('\nfname <- .getFile(path = file.path(params$rootDir, "diversity", "motifs"), pattern = ".*%s_motif_logo\\\\.png")', tolower(regions[i])))
    line6 <- knitr::knit_expand(text = '\nif (!is.na(fname)) { img <- rasterGrob(as.raster(readPNG(fname)), interpolate = FALSE) } else { img <- ggplot(data.frame()) + xlim(0, 10) + ylim(0, 10) + annotate("text", x = 5, y = 5, label = "Plot unavailable") }')
    line7 <- knitr::knit_expand(text = "\ngrid.arrange(imgAl, img, nrow = 1)")
    line8 <- knitr::knit_expand(text = "\n```\n")
    line9 <- knitr::knit_expand(text = sprintf("\n> (Left) %s aligned using clustal-omega (Right) unaligned motif discovery\n", regions[i]))
    paste(line1, line2, line3, line4, line5, line6, line7, line8, line9, collapse = "\n")
})
```

`r if (params$single && params$hasDiv) { paste(knitr::knit(text = paste(motifOut, collapse = '\n'))) }`


`r if(!params$hasDiv || !params$single) {"\\end{comment}"}`



`r if(!params$hasDiv || params$single) {"\\begin{comment}"}`


Clonotypes {data-orientation=rows data-icon="fa-dna"}
=======================================================================

Row {.tabset .tabset-fade}
-----------------------------------------------------------------------
<!--- Always use static plot even if it's interactive - good luck rendering it
 otherwise -->
```{r abseq_scatter_clonotype, echo=FALSE, eval=(!params$single && params$hasDiv)}
files <- list.files(path = file.path(params$rootDir, "clonotype_analysis"),
                    pattern = ".*_clone_scatter\\.png",
                    full.names = TRUE)
scatterOut <- lapply(seq_along(files), function(i) {
    line1 <- knitr::knit_expand(text = sprintf("### %s\n",
                                               gsub("_", " ",
                                                    stringr::str_extract(basename(files[[i]]),
                                                                         "^.*(?=(_clone_scatter))"))))
    line2 <- knitr::knit_expand(text = sprintf("\n```{r abseq_scatter_out_%d, eval=(params$hasDiv && !params$single), fig.width=params$width, fig.height=params$height}\n", i))
    line3 <- knitr::knit_expand(text = sprintf('grid.raster(readPNG("%s"))', files[[i]]))
    line4 <- knitr::knit_expand(text = "\n```\n")
    line5 <- knitr::knit_expand(text = "\n> Clonotype frequencies from 2 samples. The axis values are scaled to log10 of the clone proportion. The marginal density plots show the density of total(grey), non-overlapping(purple), and overlapping(blue) clonotype abundances.\n")
    paste(line1, line2, line3, line4, line5, collapse = "\n")
})

```

`r if(!params$single && params$hasDiv) { paste(knitr::knit(text = paste(scatterOut, collapse = '\n'))) }`


Row
-----------------------------------------------------------------------

### Distribution of top 10 clonotypes from each sample

```{r abseq_top_10, eval=(params$hasDiv && !params$single), fig.width=params$widthL, fig.height=params$heightL}
fname <- .getFile(path = file.path(params$rootDir, "clonotype_analysis"), pattern = ".*_top10Clonotypes\\.Rdata")
if (!is.na(fname)) {
    load(fname)
    if (params$interactive) {
        ggplotly(plot)
    } else {
        plot
    }
} else {
    ggplot(data.frame()) + xlim(0, 10) + ylim(0, 10) + annotate("text", x = 5, y = 5, label = "Plot unavailable")
}
```

> Clonotype distributions are scaled to top 10


### Number of overlapping and non-overlapping clonotypes

```{r abseq_clone_venn, eval=(params$hasDiv && !params$single), fig.width=params$width, fig.height=params$height}
fname <- .getFile(path = file.path(params$rootDir, "clonotype_analysis"), pattern = ".*_cdr3_clonotypeIntersection\\.png")
if (!is.na(fname)) {
    img <- readPNG(fname)
    grid.raster(img)
} else {
    ggplot(data.frame()) +
        xlim(0, 10) +
        ylim(0, 10) +
        annotate("text", x = 5, y = 5, label = "Can't find clonotype venn diagram, you probably have > 5 samples")
}
```

> Counts show number of clonotypes


Row
-----------------------------------------------------------------------

### Pearson correlation

```{r abseq_pearson_correlation, eval=(params$hasDiv && !params$single), fig.width=params$width, fig.height=params$height}
fname <- .getFile(path = file.path(params$rootDir, "clonotype_analysis"), pattern = "pearson\\.Rdata")
if (!is.na(fname)) {
    load(fname)
    if (params$interactive) {
        ggplotly(plot)
    } else {
        plot
    }
} else {
    ggplot(data.frame()) + xlim(0, 10) + ylim(0, 10) + annotate("text", x = 5, y = 5, label = "Plot unavailable")
}
```


### Spearman correlation

```{r abseq_spearman_correlation, eval=(params$hasDiv && !params$single), fig.width=params$width, fig.height=params$height}
fname <- .getFile(path = file.path(params$rootDir, "clonotype_analysis"), pattern = "spearman\\.Rdata")
if (!is.na(fname)) {
    load(fname)
    if (params$interactive) {
        ggplotly(plot)
    } else {
        plot
    }
} else {
    ggplot(data.frame()) + xlim(0, 10) + ylim(0, 10) + annotate("text", x = 5, y = 5, label = "Plot unavailable")
}
```


Row
-----------------------------------------------------------------------

<!-- There are issues with ggplotly and ggdendro, ignore the interactiveness
for now. -->

### Morisita Horn

```{r abseq_morisita_horn_similarity, eval=(params$hasDiv && !params$single), fig.width=params$width, fig.height=params$height}
fname <- .getFile(path = file.path(params$rootDir, "clonotype_analysis"), pattern = "morisita_horn\\.Rdata")
if (!is.na(fname)) {
    load(fname)
    plot
} else {
    ggplot(data.frame()) + xlim(0, 10) + ylim(0, 10) + annotate("text", x = 5, y = 5, label = "Plot unavailable")
}
```

### Bray Curtis

```{r abseq_bray_curtis_similarity, eval=(params$hasDiv && !params$single), fig.width=params$width, fig.height=params$height}
fname <- .getFile(path = file.path(params$rootDir, "clonotype_analysis"), pattern = "bray_curtis\\.Rdata")
if (!is.na(fname)) {
    load(fname)
    plot
} else {
    ggplot(data.frame()) + xlim(0, 10) + ylim(0, 10) + annotate("text", x = 5, y = 5, label = "Plot unavailable")
}
```

### Jaccard

```{r abseq_jaccard_similarity, eval=(params$hasDiv && !params$single), fig.width=params$width, fig.height=params$height}
fname <- .getFile(path = file.path(params$rootDir, "clonotype_analysis"), pattern = "jaccard\\.Rdata")
if (!is.na(fname)) {
    load(fname)
    plot
} else {
    ggplot(data.frame()) + xlim(0, 10) + ylim(0, 10) + annotate("text", x = 5, y = 5, label = "Plot unavailable")
}
```


`r if(!params$hasDiv || params$single) {"\\end{comment}"}`

---
title: "AbSeq analysis report"
output:
    html_document:
        # using the same theme as template.Rmd
        theme: cosmo
        toc: true
        toc_float:
            collapsed: false
            smooth_scroll: false
params:
    singleSamples: "PCR1,PCR2,PCR3"
    multiSamples: "PCR1_vs_PCR2,PCR1_vs_PCR3,PCR1_vs_PCR5,PCR2_vs_PCR3"
    singleSampleLinks: "link1,link2,link3"
    multiSampleLinks: "link12,link13,link14,link15"
    chains: "hv,lv,hv"
    rawReads: "1000,1000,1000"
    annotReads: "900, 291, 987"
    filtReads: "900, 291, 987"
    prodReads: "500, 200, 123"
    filters: "bitscore: 1 - inf, alignlen: 1 - inf, sstart: 1 - inf, qstart: 1 - inf ? bitscore: 1 - inf, alignlen: 1 - inf, sstart: 1 - inf, qstart: 1 - inf ? bitscore: 1 - inf, alignlen: 1 - inf, sstart: 1 - inf, qstart: 1 - inf "
    filterSplitter: "?"
    analysisParams: "/newhome/jiahong/sandbox/immulator_out/out/report/PCR1/analysis.params"
---

```{r abseq_index_landing_setup, include=FALSE}
library(knitr)
knitr::opts_chunk$set(echo = FALSE)

.formatNumber <- function(numStr, denom) {
    n <- suppressWarnings(as.numeric(numStr))
    d <- suppressWarnings(as.numeric(denom))
    nStr <- prettyNum(n, big.mark = ",")
    dStr <- prettyNum(d, big.mark = ",")
    perc <- n / d * 100
    return(sprintf("%s%% (%s/%s)", round(perc, 2), nStr, dStr))
}
```

generated on `r format(Sys.time(), "%a %b %d %Y %H:%M:%S")`

<!-- number of samples:, indv, comp -->
# Summary

Individual samples are listed in the following table.

Click on the sample names for more details.

The comparative analysis (if any) will appear [after the table](#comparative-reports).

## Individual sample reports

Number of samples: `r length(unlist(strsplit(params$singleSampleLinks, ",")))`


```{r abseq_index_table_summary, echo=FALSE}
samples <- unlist(strsplit(params$singleSamples, ","))
links <- unlist(strsplit(params$singleSampleLinks, ","))
chains <- unlist(strsplit(params$chains, ","))
rawReads <- unlist(strsplit(params$rawReads, ","))
filtReads <- unlist(strsplit(params$filtReads, ","))
annotReads <- unlist(strsplit(params$annotReads, ","))
prodReads <- unlist(strsplit(params$prodReads, ","))
filters <- unlist(strsplit(params$filters, params$filterSplitter, fixed = TRUE))
if (length(samples) * 8 != (length(samples) + length(links) + length(chains) + length(rawReads) + length(filtReads) + length(annotReads) + length(prodReads)) + length(filters)) {
    stop(sprintf("Expected same argument length for singleSamples (%d), links (%d), chains (%d), rawReads (%d), filteredReads (%d), annotReads (%d), prodReads (%d) and filters (%d)",
                 length(samples),
                 length(links),
                 length(chains),
                 length(rawReads),
                 length(filtReads),
                 length(annotReads),
                 length(prodReads),
                 length(filters)
                 ))
}
singleTableInfo <- lapply(seq_along(samples), function(i) {
    reads <- prettyNum(rawReads[i], big.mark = ",")
    annots <- .formatNumber(annotReads[i], rawReads[i])
    filtered <- .formatNumber(filtReads[i], annotReads[i])
    prods <- .formatNumber(prodReads[i], filtReads[i])
    filts <- gsub(",", "<br>", filters[i], fixed = TRUE)
    knitr::knit_expand(text = sprintf("[%s](%s) | %s | %s | %s | %s | %s | %s", samples[i], links[i], chains[i], reads, annots, filtered, prods, filts))
})

singleTableInfo <- c("sample | chain | # reads | annotated reads | filtered(kept) reads | productive reads | filters applied",
                     "-------|-------|---------|-----------------|----------------------|------------------|---------------",
                     singleTableInfo)
```

`r paste(knitr::knit(text = paste(singleTableInfo, collapse = '\n')))`

## Comparative reports

Number of comparative reports: `r length(unlist(strsplit(params$multiSampleLinks, ",")))`

```{r abseq_comparative_show, echo=FALSE}
samples <- unlist(strsplit(params$multiSamples, ","))
links <- unlist(strsplit(params$multiSampleLinks, ","))
if (length(samples) != length(links)) {
    stop("Expected equal number of samples and links")
}

comparativePoints <- lapply(seq_along(samples), function(i) {
    knitr::knit_expand(text = sprintf("* [%s](%s)", samples[i], links[i]))
})
```

`r paste(knitr::knit(text = paste(comparativePoints, collapse = '\n')))`

<!-- R, py version - R, py packages -->
# Session information

## AbSeqR

```{r abseq_display_session_info, echo=TRUE}
# This report is generated with the following packages(and versions)
sessionInfo()
```

## AbSeqPy

```{r abseq_display_abseqPy_info, echo=FALSE}
if (file.exists(params$analysisParams)) {
    con <- file(params$analysisParams, "r")
    lines <- readLines(con)
    close(con)
    versions <- lapply(lines, function(line) {
        if (grepl(".*version.*", line)) {
            line
        } else {
            NA
        }
    })
    
    cat(paste(versions[!is.na(versions)], collapse = "\n"))
} else {
    cat(paste(params$analysisParams), "could not be found, no information",
        "available.")
}
```

---
title: "abseqR: reporting and data analysis functionalities for Rep-Seq datasets of antibody libraries"
author:
- "Jia Hong Fong"
- "Monther Alhamdoosh"

package: "abseqR"
output:
    BiocStyle::pdf_document: default
    BiocStyle::html_document:
vignette: >
    %\VignetteIndexEntry{Introduction to abseqR}
    %\VignetteEngine{knitr::rmarkdown}
    %\VignetteEncoding{UTF-8}
---

```{r setup, include=FALSE}
library(abseqR)
library(png)
library(plotly)
library(grid)
library(gridExtra)
library(BiocStyle)
# knitr::opts_chunk$set(tidy = TRUE)
knitr::opts_chunk$set(message = FALSE)
```

```{r abseqR_vignette_helper_functions, include=FALSE}
sabseqR <- function() { return(Biocpkg("abseqR")); }
#sabseqR <- function() { return("`abseqR`"); }
sabseqPy <- function() { return("[abseqPy](https://github.com/malhamdoosh/abseqPy)"); }
sabseq <- function() { return("`AbSeq`"); }
read_png <- function(path) {
    if (file.exists(path)) {
        #rasterGrob(as.raster(readPNG(path)), interpolate = TRUE)
        # in windows, the path is \ but LaTEX does not appreciate these slashes
        knitr::include_graphics(gsub("\\", "/",
                                     normalizePath(path),
                                     fixed = TRUE))
    } else {
        stop("File at ", path, " not found, fatal.")
    }
}

```

# Introduction

A plethora of high throughput sequencing (HTS) analysis pipelines are
available as open source tools to analyze and validate the quality of Rep-seq [^Repseq] datasets.
[OmicTools](https://omictools.com/search?q=repertoire)
provides a summary of repertoire sequencing tools that implements different
techniques and algorithms in analyzing and visualizing datasets from B-cell
receptors (BCR) and T-cell receptors (TCR). However, high throughput analysis pipelines of antibody library sequencing datasets are scarce.

`r sabseq()` is a comprehensive bioinformatic pipeline for the analysis of sequencing datasets generated from antibody libraries and `r sabseqR()` is one of its packages. The `r sabseq()` suite is implemented as a set of functions
in `R` and `Python` that can be used together to provide insights into the quality of antibody libraries. `r sabseqPy()` processes paired-end
or single-end _FASTA/FASTQ_ files generated from NGS sequencers and converts them into
CSV and [HDF](https://portal.hdfgroup.org/display/support) files.
`r sabseqR()` visualizes the output of `r sabseqPy()` and generates a self-contained
HTML report. Furthermore, `r sabseqR()` provides additional functionalities to
explicitly compare multiple samples and perform further downstream analyses.


`r sabseqR()` provides the following functionalities:

* Visualizations: the output from `r sabseqPy()` is summarized succintly into
  static and interactive plots. The plots are also stored in `Rdata` object files that provide flexibility for
  users to easily customize the aesthetics of any plot generated by `r sabseqR()`.
 
* Interactive reports: the plots generated by `r sabseqR()` can be collated and presented
  in a self-contained HTML document for convenience and ease of sharing.
  
* Sample comparison: `r sabseqR()` overloads the `+` operator
  via the S4 classes `AbSeqCRep` and `AbSeqRep` to compare
  multiple samples with each other. The `comparative reports` include additional
  plots, for example, sample similarity clustering, overlapping clonotypes, etc. The usual plots are also generated for all the compared samples by adding an extra layer of `aes`thetic.
  
## AbSeq core analyses

`r sabseq()` includes, but is not limited to, merging paired-end reads,
annotating V-(D)-J germlines, calculating unique clonotypes,
analyzing primer specificity, facilitating the selection of best restriction enzymes,
predicting frameshifts, identifying functional clones, and
calculating diversity indices and estimations. These analyses are seamlessly
extrapolated to analyze multiple library repertoires simultaneously when
multiple samples are present. Figure \@ref(fig:abseq-wf) depicts the complete
`r sabseq()` workflow. Sequencing files are taken as input to be annotated and
analyzed by `r sabseqPy()` before they are further analyzed and visualized
by `r sabseqR()`.


```{r abseq-wf, fig.cap="AbSeq workflow. Comprehensive analyses and visualizations are generated from input sequencing files using abseqPy and abseqR.", echo=FALSE, out.width="100%"}
read_png("abseq_workflow_MA.jpg")
```


# Installation

`r sabseqR()` can be installed from [bioconductor.org](http://bioconductor.org/) or
its GitHub repository at https://github.com/malhamdoosh/abseqR.

## Bioconductor

To install `r sabseqR()` via the `BiocManager`, type in R console:
```r
if (!require("BiocManager"))
    install.packages("BiocManager")
BiocManager::install("abseqR")
```

## GitHub

To install the development version of `r sabseqR()` from GitHub,
type in R console:
```r
if (!require("BiocManager"))
    install.packages("BiocManager")
BiocManager::install("malhamdoosh/abseqR")
```

## System prerequisites

`r sabseqR()` requires [pandoc](http://pandoc.org/) version _1.19.2.1_ or higher
to render the HTML reports. If `pandoc` cannot be detected while executing `r sabseqR()`,
the HTML report will __not__ be generated. `r sabseqR()` is a cross-platform
library and will work on any major operating system [^windows_biocparallel].

## R package dependencies

`r sabseqR()` depends on several packages from the [CRAN](https://cran.r-project.org/)
and [Bioconductor](https://bioconductor.org/) repositories:

* `r CRANpkg("RColorBrewer")` provides colour
schemes for maps and graphics. To install it, type in R console
`install.packages("RColorBrewer")`

* `r CRANpkg("VennDiagram")` provides a set of
functions to generate Venn diagrams. To install it, type in R console `install.packages("VennDiagram")`

* `r CRANpkg("circlize")` is a visualization tool
used to summarize the distributions of associations between V-J gene segments. To install it, type in R console `install.packages("circlize")`

* `r CRANpkg("flexdashboard")` is a package
that provides a template for RMarkdown that resembles a grid oriented dashboard and is used to generate the HTML reports. To
install it, type in R console `install.packages("flexdashboard")`

* `r CRANpkg("ggplot2")` is an implementation of
the "Grammar of Graphics" in R. It is used extensively to
generate plots. To install it, type in R console `install.packages("ggplot2")`

* `r CRANpkg("ggcorrplot")` is used to visualize
a correlation matrix using `r CRANpkg("ggplot2")`.
To install it, type in R console `install.packages("ggcorrplot")`

* `r CRANpkg("ggdendro")` provides a set of tools
for drawing dendrograms and tree plots using `r CRANpkg("ggplot2")`. To install it, type
`install.packages("ggdendro")`

* `r CRANpkg("grid")` is used to arrange plots.
It has been integrated into the base R package.

* `r CRANpkg("gridExtra")` provides functions
to work with "grid" graphics and used to arrange grid-based plots
in the HTML reports. To install it, type in R console `install.packages("gridExtra")`

* `r CRANpkg("knitr")` provides the capability to
dynamically generate reports in R. To install it, type in R console `install.packages("knitr")`

* `r CRANpkg("plotly")` is used to translate
`r CRANpkg("ggplot2")` graphs to interactive web-based plots. To install it, type in R console
`install.packages("plotly")`

* `r CRANpkg("plyr")` offers a set of tools used in
this package to apply operations on subsets of data in manageable pieces. To
install it, type in R console `install.packages("plyr")`

* `r CRANpkg("png")` is used to read and display PNG images.
To install it, type in R console `install.packages("png")`

* `r CRANpkg("reshape2")` allows this package to
restructure and aggregate dataframes. To install it, type in R console `install.packages("reshape2")`

* `r CRANpkg("rmarkdown")` converts R Markdown
documents into a variety of formats. To install it, type in R console `install.packages("rmarkdown")`

* `r CRANpkg("vegan")` provides a suite of functions
to calculate diversity and distance statistics between repertoires. To install it,
type in R console `install.packages("vegan")`

* `r Biocpkg("BiocParallel")` is
a package from [Bioconductor](https://bioconductor.org) used to enable parallel computing. To install it, type in R console
```r
if (!require("BiocManager"))
    install.packages("BiocManager")
BiocManager::install("BiocParallel")
```

# Quick start


To leverage all the functionalities provided by `r sabseqR()`, the main
functions to note are `abseqR::abseqReport`, `abseqR::report`, and `+`.
This section uses a small simulated dataset to walk through the use cases of each function.

## Datasets

<!-- MA: add a figure that depcits how the datasets are generated  (probably folder structure) -->

The example dataset is packaged with `r sabseqR()`.
For the sake of brevity, the dataset generation is described under the
[Appendices](#example-data) section.

Briefly, the dataset includes three samples, namely PCR1, PCR2, and PCR3, that was generated using _in silico_ simulations.
`r sabseqPy()` was then used to analyze the datasets and
the output directory argument `--outdir` specified in `r sabseqPy()` was initiated with the value `"./ex/"`.


```{r abseq-sim-data, fig.cap="Generation of the three simulated datasets. The flowchart on the left shows the generation of the datasets in `\"./ex/\"` while the folder structure on the right shows the output generated by `abseqPy` on the three datasets.", echo=FALSE, out.width="100%"}
read_png("simulation_flowchart_full.jpg")
```

### Fetch data files {#obtain-dataset}

The output of `r sabseqPy()` on the simulated datasets is first fetched into a local directory as follows:

```{r abseqR_copy_data_files, results=FALSE}
# substitute with any directory that you have read/write access to
sandboxDirectory <- tempdir()

# path to provided data (comes installed with abseqR)
exdata <- system.file("extdata", "ex", package = "abseqR")

# copy the provided data to sandboxDirectory
file.copy(exdata, sandboxDirectory, recursive = TRUE)
```

Then, the following commands can be executed in R console to verify that the three `PCR` datasets are fetched successfully:

```{r abseqR_data_contents}
# dataPath now holds the path to a local copy of the data
dataPath <- file.path(sandboxDirectory, "ex")
# the sample names can be found inside the auxiliary directory
list.files(path = file.path(dataPath, "auxiliary"))
```


## Basic analysis {#basic-analysis}

After [obtaining the datasets](#obtain-dataset), the `abseqReport` function from `r sabseqR()` is invoked to visualize the different analysis results as follows: 

```{r abseqR_quick_run, results=FALSE, warning=FALSE}
# This section will visualize all the datasets individually
# and compare PCR1 with PCR2 with PCR3

# Interim solution
if (Sys.info()["sysname"] == "Darwin") {
    BPPARAM <- BiocParallel::SerialParam()
} else {
    BPPARAM <- BiocParallel::bpparam()
}

# you should use report = 3 to generate a HTML report
samples <- abseqReport(dataPath,
                       compare = c("PCR1, PCR2, PCR3"),
                       report = 1,
                       BPPARAM = BPPARAM)

# ignore the message:
# "Sample output directory <path> is different from provided path
#   <path> assuming directory was moved"
# This warning message tells us that the directory has
# been moved (we copied the provided examples to "dataPath")
```

This creates plots for all samples included in `dataPath`.
In addition, The `compare = c("PCR1, PCR2, PCR3")` argument specifies
that samples `PCR1`, `PCR2`, and `PCR3` are explicitly
compared against each other. Other possible values for
`compare`, `report` , and `BPPARAM` will be discussed in detail
in later sections ([here](#abseqReport-compare), [here](#fine-tune),
and [here](#parallelization)).


## HTML reports' directory structure

Figure \@ref(fig:abseq-final-folder-structure) shows the folder structure of `./ex/`
after `r sabseqR()` completes.

```{r abseq-final-folder-structure, fig.cap="Folder structure after `abseqR` completes. The landing page `index.html` provides a convenient way to navigate around the standalone HTML reports in `html\\_files/`.", echo=FALSE}
grid.raster(readPNG("post_report_fs.png"))
```


Invoking `abseqReport` generates plots in the same folder as the
corresponding data files within the `auxiliary` directory. They are then
collated together in an HTML document found in the `report` directory.

The `report` directory is structured as follows:

* `index.html` file is the entry point to browse AbSeq's HTML reports. It summarizes the `r sabseq()` analysis and provides a convenient way
for navigating individual and comparative analysis results. For example, within this file, there are links to
the reports generated for `PCR1`, `PCR2`, `PCR3` and `PCR1 vs PCR2 vs PCR3`.

* `html_files` directory contains HTML files that are used build the individual and comparative reports. They can be accessed directly or via the main page `index.html`.

In conclusion, the individual sample reports in `html_files` can
be shared as-is, but `index.html` __must__ be accompanied by the `html_files` directory and thus it is recommended to share the entire `report` folder.

## Comparative analysis

### Comparative analysis using a single dataset {#abseqReport-compare}

This section describes the possible values for `abseqReport`'s
`compare` parameter. In the previous section, `abseqReport` was called with
`compare = c("PCR1, PCR2, PCR3")`. This 
compares the three samples all together. However,
it is also possible to compare only a subset of samples in the `dataPath` folder, multiple subsets of samples, or none at all.

The `compare` parameter accepts a vector of one or more strings. Each string
denotes a comparison between samples separated by commas, for example,
`compare = c("PCR1, PCR2, PCR3")`[^compare-ws].

If sample comparison is not required, then the following can be simply invoked `samples <- abseqReport(dataPath)`.

Example of other combinations:

```{r abseqR_abseqReport_compare_argument, results=FALSE, warning=FALSE}
# Example of 1 comparison
# Analyze all samples, but only compare PCR1 with PCR2
pcr1.pcr2 <- abseqReport(dataPath,
                         compare = c("PCR1, PCR2"),
                         report = 0)

# Example of 2 comparisons
# Analyze all samples. In addition, compare:
#  * PCR1 with PCR2
#  * PCR2 with PCR3
multiComparison <- abseqReport(dataPath,
                               compare = c("PCR1, PCR2", "PCR2, PCR3"),
                               report = 0)
```

<!-- using hidden chunks can cause problem for users who attempt to reproduce your results. Please remove all hidden chunks or make them visible -->

__Note__, `abseqReport` always returns S4 objects of the class __AbSeqRep__ for each sample in the `dataPath` directory regardless of the value of the `compare` argument as illustrated next:

```{r abseqR_show_return_of_abseqReport, results='hold'}
# compare = c("PCR1,PCR2")
names(pcr1.pcr2)

# compare = c("PCR1, PCR2", "PCR2 ,PCR3")
names(multiComparison)
```

<!-- MA: I guess it would be nice if you overwrite the `show` method for AbSeqRep and AbSeqCRep so that the output looks nice when an AbSeqRep object is thrown in the console, i.e.g, if you type pcr1.pcr2$PCR1 -->

The next subsection explains the motivation behind this behaviour.

### Comparative analysis using multiple datasets {#customize-cmp}

When constructing antibody libraries, users might be interested in comparing Ab repertoires from different stages of the construction process. Usually, each stage has its own sequencing runs and thus would be analyzed indepedent of others. The `report` function in `r sabseqR()` was written to enable this behaviour as illustrated next.  

[Previously](#basic-analysis), the S4 objects of three samples of our toy example loaded into a variable named `samples`. As a hypothetical example,
if the reports show an interesting observation between `PCR1` and `PCR3`,
it might be of interest to isolate the two samples from the rest. 

This code shows how the `+` operator can be used to create customized comparisons as follows:

```{r abseqR_refine_comparison_simple, results=FALSE, warning=FALSE}
# recall that samples is a named list where each element's name
# is the sample's own name (see names(samples))

# use report = 3 if the results should be collated in a HTML document
pcr1.pcr3 <- samples[["PCR1"]] + samples[["PCR3"]]
refinedComparison <- report(pcr1.pcr3,
                            outputDir = file.path(sandboxDirectory,
                                                  "refined_comparison"),
                            report = 1)
```

Here, the `+` operator creates a new comparison between `PCR1` and `PCR3` of class *AbSeqCRep*. S4 objects of this class can be passed to the `report` function to generate a standalone HTML report of this particular comparison.
Similar to `abseqReport`, this function returns S4 objects of the individual samples - `PCR1` and `PCR3`.

```{r abseqR_refine_comparison_sample_return_value, eval=TRUE}
names(refinedComparison)
```

Similarly, samples can be loaded from two different `r sabseqPy()`'s directories as illustrated in the following example: 


```{bash abseqR_different_dirs, eval=FALSE}
# first abseqPy run on SRR dataset from control group
abseq --file1 fasta/SRR_ACGT_CTRL.fasta --outdir SRR_CTRL

# second abseqPy run on SRR dataset from experiment group
abseq --file1 fasta/SRR_ACGT_EXP.fasta --outdir SRR_EXP
```

analyzing these samples in `r sabseqR()`:

```{r abseqR_adv_load_samples, eval=FALSE}
SRRControl <- abseqReport("SRR_CTRL")
SRRExp <- abseqReport("SRR_EXP")
```

then comparing _all_ samples in `SRRControl` with _all_ samples in `SRRExp`
can be done using [`+` and `report`](#customize-cmp).

```{r abseqR_adv_compare_old_new, eval=FALSE}
# short for SRRControl[[1]] + SRRControl[[2]] + ... + SRRExp[[1]] + ...
all.samples <- Reduce("+", c(SRRControl, SRRExp))
report(all.samples, outputDir = "SRRControl_vs_SRRExp")
```

> **Important**: The sample names in `SRR_CTRL` and `SRR_EXP` _must_ be unique.


In conclusion, the `+` operator along with the `report` function enables users to carry out a wide range of customized downstream analyses on the output of `r sabseqPy()`.

# Advanced Examples

## Lazy loading

In the previous section, the `SRRControl` dataset was loaded using
`SRRControl <- abseqReport("SRR_CTRL")`, which will **generate** all plots and reports by default. However, this dataset might have already been analyzed and users are interested in only loading the S4 objects of the samples. This can be efficiently carried out by using the `report=0` argument as follows: 

```{r abseqR_adv_lazy_load, eval=FALSE}
# in essence, this is identical to SRRControl <- abseqReport("SRR_CTRL"),
# but will not regenerate plots and reports!
SRRControl.lazy <- abseqReport("SRR_CTRL", report = 0)

# exactly the same return value
stopifnot(names(SRRControl.lazy) == names(SRRControl))
```

## Alternative reporting options  {#fine-tune}

In the previous section, the `report` parameter of `abseqReport` was used to
load the samples in `SRRControl` without actually plotting any data. 

The `report` argument can accept one of four possible values as follows:

1. `abseqReport("SRR_CTRL", report = 0)` does not generate plots and HTLM reports and only returns a named list of S4 objects. 

2. `abseqReport("SRR_CTRL", report = 1)` generates static plots in PNG format but **does not** generate HTML reports. 

3. `abseqReport("SRR_CTRL", report = 2)` generates static plots in PNG format in addition to HTML reports.

4. `abseqReport("SRR_CTRL", report = 3)` generates static plots in PNG format and interactive plots in the HTML reports using [plotly](https://cran.r-project.org/package=plotly). This is the default behaviour when the `report` argument is not specified.

## Parallelization {#parallelization}

One of `abseqReport`'s parameters is `BPPARAM`, which is used to pass arguments into the `BiocParallel::bplapply` function for customizing parallelization. More
information regarding the accepted values to `BPPARAM` can be found at
BiocParallel's
[page](https://bioconductor.org/packages/release/bioc/html/BiocParallel.html).

Below is a simplified example of using 4 cores and serializing the loop.

```{r abseqR_adv_bpparam, eval=FALSE}

# use 4 CPU cores
nproc <- 4
samples <- abseqReport(dataPath,
                       BPPARAM = BiocParallel::MulticoreParam(nproc))


# run sequentially - no multiprocessing
samples <- abseqReport(dataPath,
                       BPPARAM = BiocParallel::SerialParam())
```

# Interpretation of report's figures {#abseqR-interpret}

```{r abseqR_plot_path_setup, include=FALSE}
# [s]ingle sample [dir]ectory
sdir <- file.path(dataPath, "auxiliary", "PCR1")
# [m]ulti sample [dir]ectory
mdir <- file.path(dataPath, "auxiliary", "PCR1_vs_PCR2_vs_PCR3")
```

This section presents the plots generated by `r sabseqR()` on the
dataset discussed above and provides some insights on how to interpret them.

The visualizations and analyses can be broken down into 5 categories:

1. Sequence quality analysis
2. Abundance analysis
3. Productivity analysis
4. Diversity analysis
5. Comparative analysis

## Sequence quality analysis

The plots described in this section can be found in the `Summary` and `Quality` tabs of the HTML report.

### Sequence length

The sequence length distribution is a simple way of validating the quality
of a sequencing run. The histogram is expected to show a large proportion of
sequences falling within the expected lengths.

```{r seq-len, fig.cap="Sequence length distribution of PCR1. Histogram of (merged) sequence lengths.", echo=FALSE, out.width="100%"}
read_png(file.path(sdir, "annot", "PCR1_all_clones_len_dist.png"))
```

Figure \@ref(fig:seq-len) plots sequence length (x-axis) against proportion (y-axis). A similar plot with outliers removed can be found in the `Summary` tab.

### Alignment quality

`r sabseqPy()` filters low quality sequences based on the quality of the sequence alignment against germline sequence databases and thus the following parameters can be used:

1. Alignment bitscore
2. Subject start index
3. Query start index
4. Alignment length

However, setting the
optimal cut-off thresholds for these parameters is challenging. Stringent values could filter too many sequences while lenient values could retain
low quality sequences.

The alignment quality heatmaps generated in the `Quality` tab of the HTML report shows the relationship
between alignment lengths and these alignment parameters to help determine the percentage of sequences falling within a given range and thus inform the selection of cut-off thresholds.

For example, Figure \@ref(fig:align-qual) shows one of the 5 heatmaps: bitscore
against V germline alignment length. `r sabseqPy()` has some recommendations on the values of these parameters to retain good quality sequences. 

```{r align-qual, fig.cap="Bitscore vs V germline alignment length in PCR1. Heatmap of bitscore vs alignment length shows percentage of sequences in a given value range.", echo=FALSE, out.width="100%"}
read_png(file.path(sdir, "abundance", "PCR1_igv_align_quality_bitscore_hm_static.png"))
```

### Insertions, deletions, and mismatches

Indels (Insertions or deletions) and mismatches
can be used as an indicator of sequence quality. 

Figure \@ref(fig:indel) shows the proportions of indels in `PCR1`. This graph plots the 
rate of indels (y-axis) in the V germlines of `PCR1` against the number of indels (x-axis).
A similar plot for rate of mismatches in V germlines can be found in the same directory. A high rate of indels in the germline sequences might indicate a quality problem with the library because this would affect the functionality of the sequenced clones. However, this could be due to the sequencing quality depending on which sequencing technology is used. For example, long read sequencing technologies tend to produce more indel errors than short read sequencing technologies. 

```{r indel, fig.cap="Rate of insertions and deletions in PCR1. The percentage of indels found within the V germlines of PCR1.", echo=FALSE, out.width="100%"}
read_png(file.path(sdir, "abundance", "PCR1_igv_gaps_dist.png"))
```

## Abundance and association analysis

The plots generated in this section can be found in the `Abundance` tab of the HTML report.

### V-(D)-J germline abundance

The proportions of V-(D)-J germlines is essential in some experiment designs.
For example, it can be used to validate that the germline abundance of an
in-house antibody library is in-line with the donor antibody repertoire.
Experiments that artificially amplify certain germline families can also
be validated similarly using this analysis.

```{r vgermline, fig.cap="V family germline distribution in PCR1. The percentage of IGHV families after germline annotation using IgBLAST.", echo=FALSE, out.width="100%"}
read_png(file.path(sdir, "abundance", "PCR1_igv_dist_family_level.png"))
```

Figure \@ref(fig:vgermline) shows the distribution of IGHV families in `PCR1`. Similar plots can be generated for individual V germlines genes and for the D and J germlines.


### V-J germline associations

This plot visualizes the recombination process of V and J germlines.
Figure \@ref(fig:vjassoc) summarizes the associations between V
and J family germlines in a plot generated using `r CRANpkg("circlize")`.

```{r vjassoc, fig.cap="V-J family germline association in PCR1. Segment size represents germline proportion while the thickness of the arcs shows the proportion of associations between V and J germline families. This plot was heavily inspired by [VDJTools](https://github.com/mikessh/vdjtools/))", echo=FALSE, out.width="100%"}
read_png(file.path(sdir, "abundance", "PCR1_vjassoc.png"))
```

This plot can be used to check whether the Ab library is biased towards a particular combination of germline genes due to cloning errors. 

## Productivity analysis

The plots described in this section can be found in the `Productivity` tab in `PCR1`'s HTML report. The main factors affecting the productiveness of a clone by
`r sabseq()`'s interpretation are:

1. Concordance of the coding frames of V and J germline genes
3. Presence of stop codons
2. Presence of indels within a framework or complementarity-determining region

Any sequence that satisfies at least one of the above condition will be classified
as unproductive and thus it is unlikely that it will express a functional antibody.

Figure \@ref(fig:prod-summ) summarizes the productivity analysis results of `PCR1`. Factors that cause sequences to be non-functional are colour coded as follows:

1. Green -- sequences _without_ stop codons but have a frameshift
2. Cyan -- sequences that are _in-frame_ but contain at least one stop codon
3. Purple -- sequences that contain at least one stop codon _and_ have a frameshift

```{r prod-summ, fig.cap="Productivity rate of sequences in PCR1. This plot shows the percentage of productive and unproductive sequences, the reason for unproductive sequences are colour coded.", echo=FALSE, out.width="100%"}
read_png(file.path(sdir, "productivity", "PCR1_productivity.png"))
```

A good antibody library should have as low unproductive clones as possible. Cloning strategies that are used to clone sequences from the donor libraries or used to construct the Ab library play a key role in this aspect of the library quality. 

### V-J frameshifts

Figure \@ref(fig:frameshift) shows the percentage of clones that are
out-of-frame due to either misaligned V-J coding frames or to the presence of non-multiple of three-indels in one of the framework or complementarity-determining regions.

```{r frameshift, fig.cap="Rate of in-frame and out-of-frame sequences in PCR1. Misaligned V-J frame or non-multiple of 3 indels in either one of the framework or complementarity-determining regions causes a frameshift and therefore renders the sequence unproductive.", echo=FALSE, out.width="100%"}
read_png(file.path(sdir, "productivity", "PCR1_vjframe_dist.png"))
```

### Stop codons

Figure \@ref(fig:stopcod) shows the hot spots for stop codons segregated by
framework and complementarity-determining regions.

```{r stopcod, fig.cap="Proportion of stop codons in any given CDR or FR of out-of-frame sequences in PCR1. The percentages show the frequency of stop codons in a given region relative to the total number of stop codons present.", echo=FALSE, out.width="100%"}
read_png(file.path(sdir, "productivity", "PCR1_stopcodon_region_outframe.png"))
```

The figure above shows the percentage of stop codons in the FR and CDR regions of _out-of-frame_ sequences.
As discussed earlier, these stop codons may be introduced due to cloning or sequencing errors, hence
a similar plot for _in-frame_ sequences can also be found within the same tab.

### Indels and mismatches

Some sequences are productive despite having indels and mismatches. This occurs
when indels are multiple of three and mismatches do not introduce stop codons.
The following figures show the proportion of indels and mismatches for each germline,
framework region, and complementarity-determining region on _productive sequences_ (unless
specified otherwise).

Figure \@ref(fig:mismatches), Figure \@ref(fig:gaps), and Figure \@ref(fig:gaps-out)
plots the proportion of mismatches in productive sequences,
indels in productive sequences, and indels in out-of-frame (unproductive) sequences
for framework region 3 (FR3).
The motivation behind these plots is to quickly identify the quality of productive
sequences.

```{r mismatches, fig.cap="Proportion of mismatches in productive sequences of PCR1.", echo=FALSE, out.width="100%"}
read_png(file.path(sdir, "productivity", "PCR1_fr3_mismatches_dist.png"))
```

```{r gaps, fig.cap="Proportion of indels in productive sequences of PCR1.", echo=FALSE, out.width="100%"}
read_png(file.path(sdir, "productivity", "PCR1_fr3_gaps_dist.png"))
```

```{r gaps-out, fig.cap="Proportion of indels in out-of-frame sequences of PCR1.", echo=FALSE, out.width="100%"}
read_png(file.path(sdir, "productivity", "PCR1_fr3_gaps_dist_out_of_frame.png"))
```

Ideally, the number of mismatches in framework regions and IGJ
are expected to be low because they are relatively conserved regions. Similarly,
the number of indels in productive sequences are expected to be low or some
multiple of 3.

Similar plots are generated for other FR and CDR regions, IGV, IGD, and IGJ.

<!-- TODO: missing plot 1: skipped IGV productive dist,
IGV inframe unproductive dist, IGV out-of-frame dist-->


## Diversity analysis

<!-- MA: define what is a clonotype first -->

The plots described in this section can be found in the `Diversity` tab of the HTML report. `r sabseq()` only conducts diversity analysis on clones that are productive.

### Clonotype-based analysis

To estimate repertoire diversity, `r sabseqR()` employs three commonly used techniques:

**Duplication-level analysis** in which the number of times a clone appears in the sequenced sample is calculated. Figure \@ref(fig:duplication) plots the proportion of sequences (y-axis) that appear once (singletons), twice (doubletons), 
and at higher-orders (x-axis). The higher the percentage of singletones and doubletones, the more diverse the library would likely be. 

**Rarefaction analysis** in which bootstrapping is used to estimate the *richness* of a library by calculating the proportion of unique sequences at different sample sizes. Figure \@ref(fig:rarefaction) plots the number of deduplicated clonotypes (y-axis)
againse sample sizes (x-axis). For each sample size, five samples are drawn and the mean with confidence intervals are calculated. In a highly diverse library, the percentage of unique clones should significantly increase as the sample size increases. 

**Capture-recapture analysis** in Figure \@ref(fig:recapture) plots the percentage of clonotypes recaptured (y-axis) in
a capture-recapture experiment at different sample sizes (x-axis).
For each sample size, the percentage of recaptured clonotypes is calculated for five repeated capture-recapture experiments and the mean and confidence intervals are reported.

In below figures, the complementarity-determining regions (CDRs)
are used to define a "clonotype". Similar plots can be generated for the framework regions (FRs) and the entire variable domain sequences. 

```{r duplication, fig.cap="Proportion of duplicated clonotypes in PCR1. Higher-order duplication levels starting from 10 are binned.", echo=FALSE, out.width="100%"}
read_png(file.path(sdir, "diversity", "PCR1_cdr_duplication.png"))
```

```{r rarefaction, fig.cap="Rarefaction curve of clonotypes in PCR1. The number of deduplicated sequences are taken over the mean of 5 resampling rounds, where the shaded areas indicate 95\\% confidence interval.", echo=FALSE, out.width="100%"}
read_png(file.path(sdir, "diversity", "PCR1_cdr_rarefaction.png"))
```

```{r recapture, fig.cap="Capture-recapture of clonotypes in PCR1. The number of recaptured sequences are taken over the mean of 5 resampling rounds, where the shaded areas indicate 95\\% confidence interval.", echo=FALSE, out.width="100%"}
read_png(file.path(sdir, "diversity", "PCR1_cdr_recapture.png"))
```

### Spectratype analysis

Spectratypes are histograms of the clonotype lengths calculated based on the amino acid sequences. Figure \@ref(fig:spectra) shows a CDR3 spectratype.
Spectratypes for other FRs and CDRs are available in the same tab. In a good quality library, the framework regions would have quite conserved lengths while CDRs show high length diversity. CDR3 spectratype tends to follow a normal distribution in libraries cloned from naive repertoires. 

```{r spectra, fig.cap="CDR3 amino acid spectratype for PCR1 with outliers removed.", echo=FALSE, out.width="100%"}
read_png(file.path(sdir, "diversity", "spectratypes", "PCR1_cdr3_spectratype_no_outliers.png"))
```

### Position-specific analysis

This analysis examines the diversity of Ab library at each amino acid position of the variable domain by estimating the utilization of each of the 20 amino acids at each position. Position-specific frequency matrices (PSFMs) are calculated by aligning all the sequences of a region of interest to anchor at the first position and then the frequency of each amino acid is calculated accordingly. Two PSFMs are calculated: (1) the unscaled PSFM, in which the frequencies are calculated based on the total number of observed sequences per sample *at each position* and (2) the sacled PSFM, in which the frequencies are calculated based on the total number of observed sequences per sample. 

Figure \@ref(fig:comp) shows the PSFM of CDR3 in `PCR1`. Amino acids are coloured based on their physiochemical properties. The left plot shows the unscaled composition logo and the right plot
shows the scaled composition logo. Similar plots for other FRs and CDRs are available in the same tab.

```{r comp, fig.cap="Amino acid composition logo for PCR1's CDR3. The unscaled (left) and the scaled (right) composition logos are colour coded and grouped by their physicochemical properties.", echo=FALSE, fig.wide=TRUE}
unscaled <- file.path(sdir, "diversity", "composition_logos", "CDR3", "PCR1_cumulative_logo.png")
scaled <- file.path(sdir, "diversity", "composition_logos", "CDR3", "PCR1_cumulative_logo_scaled.png")
img1 <-  rasterGrob(as.raster(readPNG(unscaled)), interpolate = TRUE)
img2 <- rasterGrob(as.raster(readPNG(scaled)), interpolate = TRUE)
grid.arrange(img1, img2, ncol = 2)
```


## Comparative analysis

The plots described in this section can be found in the `Clonotypes` tab of
`PCR1 vs PCR2 vs PCR3`'s HTML report.

Since comparative analysis deals with _overlapping_ clonotypes,
this analysis only applies when `compare` was supplied with at
least one sample comparison. Earlier, the call to `abseqReport`
had `compare = c("PCR1, PCR2, PCR3")`, therefore
`PCR1`, `PCR2,` and `PCR3` are compared against each other.

Throughout this analysis, a clonotype is synonymous to its CDR3 amino acid sequence.

### Over-representation analysis

Figure \@ref(fig:topclones) offers a simple overview of the top 10 over-represented clones found
in each sample. Since the clonotypes are colour coded, overlapping clonotypes
can easily be identified within the top 10 of each samples. Note that the
proportions are scaled relative to the top 10 clones in the respective samples.

This plot complements the scatter plot mentioned above. It displays the most abundant clonotypes
in each sample with the amino acid sequence in the legend. 

```{r topclones, fig.cap="Top 10 clonotypes from PCR1, PCR2, and PCR3. The clonotype proportions displayed are scaled relative to the top 10 clones in each sample.", echo=FALSE, out.width="100%"}
read_png(file.path(mdir, "clonotype_analysis", "PCR1_PCR2_PCR3_top10Clonotypes.png"))
```


### Overlapping analysis

#### Multi-sample analysis

While Figure \@ref(fig:topclones) is capable of showing overlapping clones,
it is restricted to the top 10 over-represented clones from each sample. Figure \@ref(fig:overlap)
aims to overcome the restriction by using a venn diagram to visualize the number
of overlapping (and non-overlapping) clones from each sample. Each number within
the venn diagram shows the number of unique clonotypes that are overlapping (in
an intersection) or are non-overlapping (not in any intersection).
That is, by taking the sum of all the numbers in a sample segment,
it becomes the number of unique clonotypes found in that sample.


```{r overlap, fig.cap="Number of unique overlapping clones found in PCR1, PCR2, and PCR3. The numbers in an intersection denotes the number of unique clones that are shared between the samples involved in the said intersection.", echo=FALSE, out.width="100%"}
read_png(file.path(mdir, "clonotype_analysis", "PCR1_PCR2_PCR3_cdr3_clonotypeIntersection.png"))
```

Note that this venn diagram will __not__ be plotted if there are more than 5
samples.

#### Two-sample analysis

In order to visualize the correlation between any pair of samples, `r sabseqR()` plots
a scatter plot of every possible combination. Figure \@ref(fig:scatter) shows
one of them, plotting the clonotype frequencies in `PCR2` against `PCR1`.

The scatter plot:

* has $log_{10}$-scaled clonotype frequencies
* has a point for each clonotype
    * the coordinate of each point denotes the $log_{10}(frequency)$ in the sample
    on the x and y axis respectively
    * point sizes are mapped to the mean frequency of a clonotype
* has marginal density plots colour coded as such:
    * blue: density of _overlapping clonotypes_
    * purple: density of _non-overlapping clonotypes_
    * grey: density of _all clonotypes_
    

```{r scatter, fig.cap="Log-scaled scatter plot of clonotype frequencies in PCR1 and PCR2. Point size denotes mean frequency of the 2 samples and marginal density plots are colour coded by overlapping (blue), non-overlapping (purple), and all (grey) clonotypes.", echo=FALSE, out.width="100%"}
read_png(file.path(mdir, "clonotype_analysis", "PCR1_vs_PCR2_clone_scatter.png"))
```

This plot is heavily inspired by [VDJTools](https://github.com/mikessh/vdjtools/).

### Correlation analysis

In addition to Figure \@ref(fig:scatter), the linear correlation of clonotype frequencies
between samples can be directly quantified using Pearson's correlation coefficient.
Figure \@ref(fig:corr) shows the plot generated by `r CRANpkg("ggcorrplot")` used to visualize
pearson coefficients. A similar plot using Spearman's correlation coefficient (rank-based)
is also available in the same directory.

```{r corr, fig.cap="Pearson correlation between PCR1, PCR2, and PCR3. Values denote the pearson correlation coefficient of the clonotypes frequencies between the samples. These values will appear with a cross 'x' to signify an insignificant coefficient if the p-value of the coefficient is larger than 0.05.", echo=FALSE, out.width="100%"}
read_png(file.path(mdir, "clonotype_analysis", "pearson.png"))
```


### Clustering analysis

The `r CRANpkg("vegan")` package was used to calculate distances between samples.
The distances between samples are calculated using its clonotype frequencies by
applying methods from Morisita-Horn's overlap index, Jaccard index, and Dice's coefficient.

Figure \@ref(fig:cluster) shows a dendrogram plotted using
Morisita-Horn's overlap index. The length of each line denotes the distance
between the 2 samples or clusters it is connected to.
Other dendrograms using Jaccard and Dice's formula are available in the same directory.

```{r cluster, fig.cap="Morisita-Horn distances of PCR1, PCR2, and PCR3. The distances are calculated using clonotype frequencies and are visualized as the length of the lines connecting samples or clusters.", echo=FALSE, out.width="100%"}
read_png(file.path(mdir, "clonotype_analysis", "morisita_horn.png"))
```


# Appendices

## Datasets {#example-data}

The datasets used in the above examples
was obtained from a combination of synthetic sample datasets generated
using [MiXCR](https://github.com/milaboratory/mixcr)'s program 
[here](http://files.milaboratory.com/mixcr/paper/mixcr-test-1.2-SNAPSHOT.jar). 
Firstly, three distinct samples were generated, each simulated with the following parameters
in `MiXCR`:

```{r mixr-test-params, echo=FALSE, message=FALSE, warnings=FALSE, results='asis'}
tabl <- "
| Parameter     | sample 1      | sample 2      | sample 3      |
|---------------|---------------|---------------|---------------|
| reads         |  10000        |  10000        | 10000         |
| clones        |  5000         |  5000         | 2000          |
| seed          |  4228         |  2428         | 2842          |
| conf          | MiSeq-300-300 | MiSeq-300-300 | MiSeq-300-300 |
| loci          |  IGH          | IGH           | IGH           |
| species       | hsa           | hsa           | hsa           |
"
cat(tabl)
```

Following that, an arbitrary number of sequences were randomly
drawn from each of the three samples and randomly amplified.
This process was repeated 3 times, resulting in a final repertoire
of three samples, named PCR1, PCR2, and PCR3.

Finally, these three samples were analyzed by `r sabseqPy()`. The command used to
analyze these samples are as follows:

```{bash abseqR__data_abseqPy_run, eval=FALSE}
abseq -y params.yml
```

where the contents of `params.yml` is:

```yaml
# params.yml
defaults:
    bitscore: 300
    sstart: 1-3
    alignlen: 250
    outdir: ex
    task: all
    threads: 1
---
file1: PCR1.fasta
name: PCR1
---
file1: PCR2.fasta
name: PCR2
---
file1: PCR3.fasta
name: PCR3
```

`r sabseqPy()`'s analysis output on these three samples are contained
within the dataset described in this vignette.

## Session Info

This vignette was rendered in the following environment:
```{r abseqR_session_info, echo=FALSE}
sessionInfo()
```


# References

<!-- add some academic references about the topic, find some from our manuscript that are related to software tools so authors can understand the scopt of our work. Add a reference to our potential paper with (under preparation) -->

[^Repseq]: Repertoire sequencing.
[^windows_biocparallel]: The performace offered by
[BiocParallel](https://bioconductor.org/packages/release/bioc/html/BiocParallel.html) may differ across different operating systems.
[^compare-ws]: Trailing and leading whitespace between sample names are trimmed. That is, "PCR1,PCR2" is identical to
"PCR1 , PCR2".

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AbSeqRep.R
\docType{class}
\name{AbSeqRep-class}
\alias{AbSeqRep-class}
\alias{AbSeqRep}
\title{S4 class - AbSeqRepertoire analysis object}
\value{
AbSeqRep
}
\description{
The AbSeqRep object contains all metadata associated with
the AbSeq (python backend) run conducted on it. This S4 class represents
a single sample(repertoire) and it can be "combined" with other samples
by using the \code{+} operator to create an \linkS4class{AbSeqCRep} object.
This value, in turn, can be used as the first argument to
\link{report} which generates a comparison between all samples included
in the \code{+} operation.

Users do not manually construct this class, but rather indirectly
obtain this class object as a return value
from the \link{abseqReport} and \link{report} functions.
}
\section{Slots}{

\describe{
\item{\code{f1}}{character. Path to FASTA/FASTQ file 1.}

\item{\code{f2}}{character. Path to FASTA/FASTQ file 2.}

\item{\code{chain}}{character. Type of chain, possible values:
\itemize{
  \item{hv}
  \item{lv}
  \item{kv}
  \item{klv}
}
each representing \bold{H}eavy, \bold{L}ambda and \bold{K}appa respectively.}

\item{\code{task}}{character. Type of analysis conducted, possible values:
\itemize{
  \item{all}
  \item{annotate}
  \item{abundance}
  \item{diversity}
  \item{productivity}
  \item{fastqc}
  \item{primer}
  \item{5utr}
  \item{rsasimple}
  \item{seqlen}
  \item{secretion}
  \item{seqlenclass}
}}

\item{\code{name}}{character. Name of analysis.}

\item{\code{bitscore}}{numeric. Part of filtering criteria: V gene bitscore filter value.}

\item{\code{qstart}}{numeric. Part of filtering criteria: V gene query start filter value.}

\item{\code{sstart}}{numeric. Part of filtering criteria: V gene subject start filter value.}

\item{\code{alignlen}}{numeric. Part of filtering criteria: V gene alignment length filter value.}

\item{\code{clonelimit}}{numeric. Number of clones to export into csv file. This is
only relevant in \code{-t all} or \code{-t diversity} where clonotypes
are exported into \code{<outdir>/<name>/diversity/clonotypes}}

\item{\code{detailedComposition}}{logical. Plots composition logo by IGHV families if
set to true, otherwise, plots logos by FR/CDRs.}

\item{\code{log}}{character. Path to log file.}

\item{\code{merger}}{character. Merger used to merge paired-end reads.}

\item{\code{fmt}}{character. File format of \code{file1} and (if present) \code{file2}.
Possible values are FASTA or FASTQ.}

\item{\code{sites}}{character. Path to restriction sites \code{txt} file.
This option is only used if \code{-t rsasimple}}

\item{\code{primer5end}}{ANY. Path to 5' end primer FASTA file.}

\item{\code{primer3end}}{ANY. Path to 3' end primer FASTA file.}

\item{\code{trim5}}{numeric. Number of nucleotides to trimd at the 5' end;}

\item{\code{trim3}}{numeric. Number of nucleotides to trimd at the 3' end;}

\item{\code{outdir}}{character. Path to output directory}

\item{\code{primer5endoffset}}{numeric. Number of nucleotides to offset before aligning
5' end primers in \code{primer5end} FASTA file.}

\item{\code{threads}}{numeric. Number of threads to run.}

\item{\code{upstream}}{character. Index (range) of upstream nucleotides to analyze.
This option is only used if \code{-t 5utr} or \code{-t secretion}.}

\item{\code{seqtype}}{character. Sequence type, possible values are either \code{dna}
or \code{protein}.}

\item{\code{database}}{character. Path to IgBLAST database.}

\item{\code{actualqstart}}{numeric. Query sequence's starting index (indexing starts from 1).
This value overrides the inferred query start position by AbSeq.}

\item{\code{fr4cut}}{logical. The end of FR4 is marked as the end of the sequence if
set to TRUE, otherwise the end of the sequence is either the end of the read
itself, or trimmed to \code{--trim3 <num>}.}

\item{\code{domainSystem}}{character. Domain system to use in IgBLAST, possible
values are either \code{imgt} or \code{kabat}.}
}}

\examples{
# this class is not directly constructed by users, but as a return
# value from the abseqReport method.

# Use example data from abseqR as abseqPy's output, substitute this
# with your own abseqPy output directory
abseqPyOutput <- tempdir()
file.copy(system.file("extdata", "ex", package = "abseqR"), abseqPyOutput, recursive=TRUE)
samples <- abseqReport(file.path(abseqPyOutput, "ex"), report = 0)
}
\seealso{
\code{\link{abseqReport}} returns a \code{list} of \code{AbSeqRep}
objects.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/pairwise.R
\name{.vennIntersection}
\alias{.vennIntersection}
\title{Title Creates Venndiagram for clonotype intersection}
\usage{
.vennIntersection(dataframes, sampleNames, outFile, top = Inf)
}
\arguments{
\item{dataframes}{list type. List of sample dataframes. Only accepts 2 - 5
samples. Warning message will be generated for anything outside of the range}

\item{sampleNames}{vector type. 1-1 with dataframes}

\item{outFile}{string type. Filename to be saved as}

\item{top}{int type. Top N cutoff, defaults to ALL clones if not specified}
}
\value{
Nothing
}
\description{
Title Creates Venndiagram for clonotype intersection
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/primerAnalysis.R
\name{.primerAnalysis}
\alias{.primerAnalysis}
\title{Conducts primer specificity analysis}
\usage{
.primerAnalysis(primerDirectories, primer5Files, primer3Files, primerOut,
  sampleNames, combinedNames, mashedNames, .save = TRUE)
}
\arguments{
\item{primerDirectories}{string type. Path to primer analysis directory}

\item{primer5Files}{vector / list type. 5' end primer files}

\item{primer3Files}{vector / list type. 3' end primer files}

\item{primerOut}{string type. output directory}

\item{sampleNames}{vector type. 1-1 with primerDirectories}

\item{combinedNames}{string type. Title friendly "combined" sample names}

\item{mashedNames}{string type. File friendly "mashed-up" sample names}

\item{.save}{logical type. Save Rdata?}
}
\value{
None
}
\description{
Conducts primer specificity analysis
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/primerAnalysis.R
\name{.canonicalizeTitle}
\alias{.canonicalizeTitle}
\title{Convert file names to human friendly text}
\usage{
.canonicalizeTitle(str)
}
\arguments{
\item{str}{string type}
}
\value{
string
}
\description{
Convert file names to human friendly text
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/util.R
\name{.readSummary}
\alias{.readSummary}
\title{Return value specifed by key from AbSeq's summary file}
\usage{
.readSummary(sampleRoot, key)
}
\arguments{
\item{sampleRoot}{sample's root directory. For example,
\code{/path/to/<outputdir>/reports/<sample_name>}.}

\item{key}{character type. Possible values are (though they might change)
\itemize{
   \item{RawReads}
   \item{AnnotatedReads}
   \item{FilteredReads}
   \item{ProductiveReads}
}}
}
\value{
value associated with key from summary file. "NA" (in string) if the field
is not available refer to util.R for the key values
}
\description{
Return value specifed by key from AbSeq's summary file
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AbSeqRep.R
\docType{methods}
\name{+,AbSeqRep,AbSeqRep-method}
\alias{+,AbSeqRep,AbSeqRep-method}
\title{Combines 2 \linkS4class{AbSeqRep} objects together for comparison}
\usage{
\S4method{+}{AbSeqRep,AbSeqRep}(e1, e2)
}
\arguments{
\item{e1}{AbSeqRep object.}

\item{e2}{AbSeqRep object.}
}
\value{
\linkS4class{AbSeqCRep} object. Calling \code{abseqR}'s
functions on this object will always result in a comparison.
}
\description{
Combines 2 \linkS4class{AbSeqRep} objects together for comparison
}
\examples{
# Use example data from abseqR as abseqPy's output, substitute this
# with your own abseqPy output directory
abseqPyOutput <- tempdir()
file.copy(system.file("extdata", "ex", package = "abseqR"), abseqPyOutput, recursive=TRUE)
samples <- abseqReport(file.path(abseqPyOutput, "ex"), report = 0)

# The provided example data has PCR1, PCR2, and PCR3 samples contained within
# pcr1 and pcr2 are instances of AbSeqRep
pcr1 <- samples[["PCR1"]]
pcr2 <- samples[["PCR2"]]

# pcr12 is an instance of AbSeqCRep
pcr12 <- pcr1 + pcr2

# you can now call the report function on this object
# report(pcr12)           # uncomment this line to execute report
}
\seealso{
\code{\link{abseqReport}} returns a \code{list} of \code{AbSeqRep}s
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/pairwise.R
\name{.cloneDistMarginal}
\alias{.cloneDistMarginal}
\title{Marginal density graph of clonotypes (blue for shared, grey for total, purple
for exclusive clones)}
\usage{
.cloneDistMarginal(df.original, otherClones, lim.min, flip)
}
\arguments{
\item{df.original}{dataframe with all clones}

\item{otherClones}{clones from the other dataframe}

\item{lim.min}{x-axis minimum limit}

\item{flip}{logical type}
}
\value{
ggplot2 object
}
\description{
Marginal density graph of clonotypes (blue for shared, grey for total, purple
for exclusive clones)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/abseqReport.R
\name{.collateReports}
\alias{.collateReports}
\title{Collate all HTML reports into a single directory and cretate an entry
\code{index.html} file that redirects to all collated HTML files}
\usage{
.collateReports(reports, individualSamples, outputDirectory)
}
\arguments{
\item{reports}{list/vector type. Collection of strings that are path(s)
to <sample>_report.html}

\item{individualSamples}{list type. list of AbSeqRep objects. Used to
extract filtering information and \% read counts.}

\item{outputDirectory}{string type. Where should the report be placed.}
}
\value{
Nothing
}
\description{
Collate all HTML reports into a single directory and cretate an entry
\code{index.html} file that redirects to all collated HTML files
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/diversityAnalysis.R
\name{.generateAllSpectratypes}
\alias{.generateAllSpectratypes}
\title{Generates all FR/CDR spectratypes}
\usage{
.generateAllSpectratypes(diversityDirectories, diversityOut, sampleNames,
  mashedNames, .save = TRUE)
}
\arguments{
\item{diversityDirectories}{list type. List of directories to diversity dir}

\item{diversityOut}{string type. Output directory}

\item{sampleNames}{vector type. 1-1 with diversityDirectories}

\item{mashedNames}{string type. Prefix for output files using "mashed-up"
sample names}

\item{.save}{logical type. Save ggplot object?}
}
\value{
Nothing
}
\description{
Generates all FR/CDR spectratypes
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/statistics.R
\name{.correlationTest}
\alias{.correlationTest}
\title{Conducts pearson and spearman correlation analysis on dataframe}
\usage{
.correlationTest(df)
}
\arguments{
\item{df}{dataframe with at least the following 2 columns:
+-----------------+
| prop.x | prop.y |
+-----------------+
|.....   | ....   |
+-----------------+
where prop.x and prop.y are normalized counts (i.e. frequencies) of the clones
They may contain 0 in a column to denote it being missing from sample x or y.}
}
\value{
named list of pearson, pearson.p, spearman, spearman.p
}
\description{
Conducts pearson and spearman correlation analysis on dataframe
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/pairwise.R
\name{.scatterPlotComplex}
\alias{.scatterPlotComplex}
\title{Creates a complex scatter plot}
\usage{
.scatterPlotComplex(df.union, df1, df2, name1, name2, cloneClass)
}
\arguments{
\item{df.union}{a 'lossless' dataframe created by intersecting sample1 and
sample2's dataframes. It should contain NAs where clones that appear in one
sample doesn't appear in the other. For example:

+-------------------------------------------------+
| Clonotype | prop.x | prop.y | Count.x | Count.y |
+-------------------------------------------------+
| ABCDEF       NA       0.01      NA        210   |
| ......                                          |
+-------------------------------------------------+}

\item{df1}{dataframe for sample 1}

\item{df2}{dataframe for sample 2}

\item{name1}{string type, Sample 1 name}

\item{name2}{string type. Sample 2 name}

\item{cloneClass}{string type.
What region was used to classify clonotypes - appears in title. For example,
CDR3 or V region

this plotting techique was
shamelessly plagarised from
https://github.com/mikessh/vdjtools/blob/master/src/main/resources/rscripts/intersect_pair_scatter.r
(VDJTools) with minor modifications}
}
\value{
ggplot2 object
}
\description{
Creates a complex scatter plot
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AbSeqCRep.R
\docType{class}
\name{AbSeqCRep-class}
\alias{AbSeqCRep-class}
\alias{AbSeqCRep}
\title{S4 class - AbSeqCompositeRepertoire analysis object}
\value{
AbSeqCRep
}
\description{
AbSeqCRep is a collection of \linkS4class{AbSeqRep} S4 objects.
This S4 class contains multiple samples(repertoires) and it can be
"combined" with other samples by using the \code{+} operator to
create an extended \linkS4class{AbSeqCRep} object.
This value, in turn, can be used as the first argument to
\link{report} which generates a comparison between all samples included
in the \code{+} operation.

Users do not manually construct this class, but rather indirectly obtain
this class object as a return value from the \code{+} operation between two
\linkS4class{AbSeqRep} objects, which are in turn, obtained indirectly from
\link{abseqReport} and \link{report} functions. It is also possible to
obtain this class object by \code{+} (adding) \linkS4class{AbSeqCRep} objects.
}
\section{Slots}{

\describe{
\item{\code{repertoires}}{list of \linkS4class{AbSeqRep} objects.}
}}

\examples{
# Use example data from abseqR as abseqPy's output, substitute this
# with your own abseqPy output directory
abseqPyOutput <- tempdir()
file.copy(system.file("extdata", "ex", package = "abseqR"), abseqPyOutput, recursive=TRUE)
samples <- abseqReport(file.path(abseqPyOutput, "ex"), report = 0)

# The provided example data has PCR1, PCR2, and PCR3 samples contained within
# pcr12 and pcr13 are instances of AbSeqCRep
pcr12 <- samples[["PCR1"]] + samples[["PCR2"]]
pcr13 <- samples[["PCR1"]] + samples[["PCR3"]]

# all_S is also an instance of AbSeqCRep
all_S <- pcr12 + pcr13
}
\seealso{
\linkS4class{AbSeqRep}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/util.R
\name{.capitalize}
\alias{.capitalize}
\title{Helper function to capitalize the first letter of \code{str}}
\usage{
.capitalize(str)
}
\arguments{
\item{str}{string type}
}
\value{
string, \code{str} capitalized
}
\description{
Helper function to capitalize the first letter of \code{str}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/util.R
\name{.summarySE}
\alias{.summarySE}
\title{Summary of dataframe}
\usage{
.summarySE(data = NULL, measurevar, groupvars = NULL, na.rm = FALSE,
  conf.interval = 0.95, .drop = TRUE)
}
\arguments{
\item{data}{a data frame.}

\item{measurevar}{the name of a column that contains the variable to be summariezed}

\item{groupvars}{a vector containing names of columns that contain grouping variables}

\item{na.rm}{a boolean that indicates whether to ignore NA's}

\item{conf.interval}{the percent range of the confidence interval (default is 95\%)}

\item{.drop}{logical.}
}
\value{
dataframe
}
\description{
Gives count, mean, standard deviation,
standard error of the mean, and confidence interval (default 95\%).

adapted from http://www.cookbook-r.com/Graphs/Plotting_means_and_error_bars_(ggplot2)/#Helper functions
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/upstreamAnalysis.R
\name{.secretionSignalAnalysis}
\alias{.secretionSignalAnalysis}
\title{Secretion signal analysis}
\usage{
.secretionSignalAnalysis(secDirectories, secOut, sampleNames,
  combinedNames, mashedNames, upstreamRanges, .save = TRUE)
}
\arguments{
\item{secDirectories}{list type. Secretion signal directories where files
are located}

\item{secOut}{string type. Where to dump output}

\item{sampleNames}{vector type. 1-1 with secDirectories}

\item{combinedNames}{string type. Title friendly string}

\item{mashedNames}{string type. File name friendly string}

\item{upstreamRanges}{list type. Upstream ranges for each sample.
If length(secDirectories) > 1, the plots will only be generated for
upstream ranges that are present in ALL samples. (i.e. the intersection)}

\item{.save}{logical type, save Rdata?}
}
\value{
none
}
\description{
Generates all the required plots for Secretion signal analysis.
This includes upstream length distributions and upstream sequence validity.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AbSeqRep.R
\docType{methods}
\name{+,AbSeqCRep,AbSeqRep-method}
\alias{+,AbSeqCRep,AbSeqRep-method}
\title{Combines a \linkS4class{AbSeqCRep} object with
a \linkS4class{AbSeqRep} object together for comparison}
\usage{
\S4method{+}{AbSeqCRep,AbSeqRep}(e1, e2)
}
\arguments{
\item{e1}{AbSeqCRep.}

\item{e2}{AbSeqRep.}
}
\value{
\linkS4class{AbSeqCRep} object. Calling \code{abseqR}'s
functions on this object will always result in a comparison.
}
\description{
Combines a \linkS4class{AbSeqCRep} object with
a \linkS4class{AbSeqRep} object together for comparison
}
\examples{
# Use example data from abseqR as abseqPy's output, substitute this
# with your own abseqPy output directory
abseqPyOutput <- tempdir()
file.copy(system.file("extdata", "ex", package = "abseqR"), abseqPyOutput, recursive=TRUE)
samples <- abseqReport(file.path(abseqPyOutput, "ex"), report = 0)

# The provided example data has PCR1, PCR2, and PCR3 samples contained within
# pcr12 is an instance of AbSeqCRep
pcr12 <- samples[["PCR1"]] + samples[["PCR2"]]
# pcr3 is instance of AbSeqRep
pcr3 <- samples[["PCR3"]]

# pcr123 is an instance of AbSeqCRep
pcr123 <- pcr12 + pcr3

# you can now call the report function on this object
# report(pcr123)           # uncomment this line to execute report
}
\seealso{
\code{\link{abseqReport}} returns a \code{list} of \code{AbSeqRep}s
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/pairwise.R
\name{.pairwiseComparison}
\alias{.pairwiseComparison}
\title{Conduct all vs all pairwise comparison analyses}
\usage{
.pairwiseComparison(dataframes, sampleNames, outputPath, .save = TRUE)
}
\arguments{
\item{dataframes}{list of dataframes}

\item{sampleNames}{1-1 vector corresponding to dataframes}

\item{outputPath}{string}

\item{.save}{logical}
}
\value{
nothing
}
\description{
Conduct all vs all pairwise comparison analyses
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/diversityAnalysis.R
\name{.plotDiversityCurves}
\alias{.plotDiversityCurves}
\title{Plots rarefaction, recapture, and de-dup plots for specified \code{region}}
\usage{
.plotDiversityCurves(region, diversityDirectories, sampleNames,
  mashedNames, diversityOut, .save = TRUE)
}
\arguments{
\item{region}{string type. One of: "cdr", "cdr_v", and "fr". "cdr" means
CDR1-3, "cdr_v" means CDR3 and V only, and finally "fr" means FR1-4.}

\item{diversityDirectories}{list type. List of directories to diversity dir}

\item{sampleNames}{vector type. 1-1 with diversityDirectories}

\item{mashedNames}{string type. Prefix for output files using "mashed-up"}

\item{diversityOut}{string type. Output directory sample names}

\item{.save}{logical type. Save ggplot object?}
}
\value{
Nothing
}
\description{
Plots rarefaction, recapture, and de-dup plots for specified \code{region}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/pairwise.R
\name{.topNDist}
\alias{.topNDist}
\title{Title Clonotype table}
\usage{
.topNDist(dataframes, sampleNames, top = 10)
}
\arguments{
\item{dataframes}{list type. List of dataframes.}

\item{sampleNames}{vector type. vector of strings representing sample
names should have one-to-one correspondence with dataframes}

\item{top}{int type. Top N clonotypes to plot}
}
\value{
None
}
\description{
Title Clonotype table
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/productivityAnalysis.R
\name{.plotIGVErrors}
\alias{.plotIGVErrors}
\title{Plots the error distribution for IGV germlines}
\usage{
.plotIGVErrors(productivityDirectories, prodOut, sampleNames,
  combinedNames, mashedNames, .save = TRUE)
}
\arguments{
\item{productivityDirectories}{list type. List of directories}

\item{prodOut}{string type. Output directory}

\item{sampleNames}{vector type. 1-1 with productivity directories}

\item{combinedNames}{string type. Title friendly "combined" sample names}

\item{mashedNames}{string type. File friendly "mashed-up" sample names}

\item{.save}{logical type, save Rdata?}
}
\value{
None
}
\description{
Plots the distribution of in-frame unproductive,
out-of-frame unproductive, and productive IGV germlines.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/util.R
\name{.substituteStringInFile}
\alias{.substituteStringInFile}
\title{Substitutes the first occurance of `key` with `value` in `filename`}
\usage{
.substituteStringInFile(filename, key, value, fixed = FALSE)
}
\arguments{
\item{filename}{character type}

\item{key}{character type}

\item{value}{character type}

\item{fixed}{logical type}
}
\value{
None
}
\description{
Substitutes the first occurance of `key` with `value` in `filename`
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/productivityAnalysis.R
\name{.prodDistPlot}
\alias{.prodDistPlot}
\title{Plots a distribution plot for different productivity analysis files}
\usage{
.prodDistPlot(productivityDirectories, sampleNames, title, reg,
  outputFileName, region, .save = TRUE)
}
\arguments{
\item{productivityDirectories}{vector type.
directories where all productivity csv
files lives (usually <samplename>/productivity/)}

\item{sampleNames}{vector type.}

\item{title}{string type.}

\item{reg}{string type. Regular expression to find the right files
for this particular distribution plot}

\item{outputFileName}{string type.
Vector of file names to save in the order of \code{regions}}

\item{region}{string type. Most of the dist plots are
regional based. use "" if no regions are involved}

\item{.save}{logical type. Save Rdata?}
}
\value{
None
}
\description{
A wrapper for plotDist
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AbSeqCRep.R
\docType{methods}
\name{+,AbSeqCRep,AbSeqCRep-method}
\alias{+,AbSeqCRep,AbSeqCRep-method}
\title{Combines 2 \linkS4class{AbSeqCRep} objects together for comparison}
\usage{
\S4method{+}{AbSeqCRep,AbSeqCRep}(e1, e2)
}
\arguments{
\item{e1}{AbSeqCRep.}

\item{e2}{AbSeqCRep.}
}
\value{
\linkS4class{AbSeqCRep} object. Calling \code{abseqR}'s
functions on this object will always result in a comparison.
}
\description{
Combines 2 \linkS4class{AbSeqCRep} objects together for comparison
}
\examples{
# Use example data from abseqR as abseqPy's output, substitute this
# with your own abseqPy output directory
abseqPyOutput <- tempdir()
file.copy(system.file("extdata", "ex", package = "abseqR"), abseqPyOutput, recursive=TRUE)
samples <- abseqReport(file.path(abseqPyOutput, "ex"), report = 0)

# The provided example data has PCR1, PCR2, and PCR3 samples contained within
# pcr12 and pcr13 are instances of AbSeqCRep
pcr12 <- samples[["PCR1"]] + samples[["PCR2"]]
pcr13 <- samples[["PCR1"]] + samples[["PCR3"]]

# all_S is also an instance of AbSeqCRep
all_S <- pcr12 + pcr13

# you can now call the report function on this object
# report(all_S)           # uncomment this line to execute report
}
\seealso{
\code{\link{abseqReport}} returns a \code{list} of \code{AbSeqRep}s
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/util.R
\name{.loadMatrixFromDF}
\alias{.loadMatrixFromDF}
\title{Given a dataframe with the columns "from", "to", and value.var, return
a symmetric matrix (with diagonal values = diag). I.e. a call to
isSymmetric(return_value_of_this_function) will always be TRUE.}
\usage{
.loadMatrixFromDF(dataframe, value.var, diag, unidirectional = TRUE)
}
\arguments{
\item{dataframe}{dataframe with 3 required columns, namely:
+---------------------------------------+
| from | to | value.var | ...           |
+---------------------------------------+
|      |    |           |               |
+---------------------------------------+
where value.var is the string provided in the function parameter}

\item{value.var}{the column to use as the matrix value}

\item{diag}{what should the diagonal values be if the dataframe doesn't provide them}

\item{unidirectional}{logical type. If the dataframe provided has the reverse
pairs (i.e. a from-to pair AND a to-from pair with the save values in the
value.var column), then this should be FALSE. Otherwise, this function will
flip the from-to columns to generate a symmetric dataframe (and hence, a
symmetric matrix).}
}
\value{
a symmetric matrix with rownames(mat) == colnames(mat)
The diagonal values are filled with diag if the dataframe itself doesn't have
diagonal data
}
\description{
Given a dataframe with the columns "from", "to", and value.var, return
a symmetric matrix (with diagonal values = diag). I.e. a call to
isSymmetric(return_value_of_this_function) will always be TRUE.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/abseqReport.R
\name{.generateDelayedReport}
\alias{.generateDelayedReport}
\title{Generates report for all samples in 'compare'}
\usage{
.generateDelayedReport(root, compare, interactivePlot)
}
\arguments{
\item{root}{string, project root directory.}

\item{compare}{vector of strings, each string is a comparison defined
by the user (assumes that this value has been checked).}

\item{interactivePlot}{logical, whether or not to plot interactive plotly
plots.}
}
\value{
a named list of samples, each an AbSeqRep object found in "root"
}
\description{
This function is needed because we are delaying the generation
of reports until after all threads/processes have joined. There's currently
an issue with rmarkdown::render() in parallel execution, see:
https://github.com/rstudio/rmarkdown/issues/499
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AbSeqRep.R
\name{.generateReport}
\alias{.generateReport}
\title{Generates HTML report from \code{\linkS4class{AbSeqRep}} and
\code{\linkS4class{AbSeqCRep}} ojects}
\usage{
.generateReport(object, root, outputDir, interactivePlot = TRUE,
  .indexHTML = "#")
}
\arguments{
\item{object}{AbSeqCRep type.}

\item{root}{string type. Root directory of the sample(s)}

\item{outputDir}{string type. The path where the HTML will be generated}

\item{interactivePlot}{logical type. Interactive or not}

\item{.indexHTML}{character type. The back button will redirect to this link.
This is typically used to redirect users back to index.html page}
}
\value{
path (including HTML name) where the report (HTML file) was saved to
}
\description{
Generates HTML report from \code{\linkS4class{AbSeqRep}} and
\code{\linkS4class{AbSeqCRep}} ojects
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/upstreamAnalysis.R
\name{.UTR5Analysis}
\alias{.UTR5Analysis}
\title{5' UTR analysis}
\usage{
.UTR5Analysis(utr5Directories, utr5Out, sampleNames, combinedNames,
  mashedNames, upstreamRanges, .save = TRUE)
}
\arguments{
\item{utr5Directories}{list type. 5UTR directories where files are located}

\item{utr5Out}{string type. Where to dump output}

\item{sampleNames}{vector type. 1-1 with utr5Directories}

\item{combinedNames}{string type. Title friendly string}

\item{mashedNames}{string type. File name friendly string}

\item{upstreamRanges}{list type. Upstream ranges for each sample.
If length(utr5Directories) > 1, the plots will only be generated for
upstream ranges that are present in ALL samples. (i.e the intersection)}

\item{.save}{logical type, save Rdata?}
}
\value{
none
}
\description{
Generates all the required plots for 5' UTR analysis. This
includes upstream length distributions and upstream sequence validity.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/abundanceAnalysis.R
\name{.abundanceAnalysis}
\alias{.abundanceAnalysis}
\title{Conducts abundance analysis}
\usage{
.abundanceAnalysis(abundanceDirectories, abunOut, sampleNames,
  combinedNames, mashedNames, skipDgene = FALSE, .save = TRUE)
}
\arguments{
\item{abundanceDirectories}{list type. List of sample directories}

\item{abunOut}{string type. Output directory}

\item{sampleNames}{vector type. 1-1 correspondence with abundanceDirectories}

\item{combinedNames}{string type. Title "combined" sample names}

\item{mashedNames}{string type. File "mashed" names - avoid special chars}

\item{skipDgene}{logical type. Skip D gene plots?}

\item{.save}{logical type. Save ggplot as Rdata}
}
\value{
None
}
\description{
Conducts abundance analysis
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/diversityAnalysis.R
\name{.reportLBE}
\alias{.reportLBE}
\title{Reports abundance-based (Lower bound) diversity estimates using the Vegan package}
\usage{
.reportLBE(df)
}
\arguments{
\item{df}{clonotype dataframe. Vegan format:
+---------------------------+
| S.1| S.2| S.3 | S.4 | ... |   (each species should have its own column)
+---------------------------+
| v1 |v2  | v3  | ....      |   (each species' count values are placed in the corresponding column)
+---------------------------+}
}
\value{
dataframe with the format:
+----------------------------------------------------------------+
| S.obs | S.chao1 | se.chao1 | S.ACE | se.ACE | s.jack1 | s.jack2|
+----------------------------------------------------------------+
| v1    |  v2 ....                                               |
+----------------------------------------------------------------+
}
\description{
Reports abundance-based (Lower bound) diversity estimates using the Vegan package
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/primerAnalysis.R
\name{.allPrimerNames}
\alias{.allPrimerNames}
\title{Collect primer names from FASTA}
\usage{
.allPrimerNames(primerFile)
}
\arguments{
\item{primerFile}{string type. Path to primer file}
}
\value{
vector of primer names as seen in primerFile
}
\description{
Collect primer names from FASTA
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/util.R
\name{.emptyPlot}
\alias{.emptyPlot}
\title{Creates and returns an empty plot}
\usage{
.emptyPlot()
}
\value{
empty ggplot2 object
}
\description{
Creates and returns an empty plot
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/diversityAnalysis.R
\name{.plotDuplication}
\alias{.plotDuplication}
\title{Duplication level plot}
\usage{
.plotDuplication(files, sampleNames, regions = c("CDR3", "V"))
}
\arguments{
\item{files}{list type. List of strings to _cdr_v_duplication.csv pathname}

\item{sampleNames}{vector type. Vector of strings each representing
sample names}

\item{regions}{vector type.
Which regions to include in the plot. Default = c("CDR3", "V")}
}
\value{
ggplot2 object
}
\description{
bins singletons, doubletons, and higher order clonotypes
into a line plot
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/abundanceAnalysis.R
\name{.abundancePlot}
\alias{.abundancePlot}
\title{Abundance distribution}
\usage{
.abundancePlot(files, sampleNames, outputDir, skipDgene = FALSE,
  .save = TRUE)
}
\arguments{
\item{files}{list type. list of files in abundance directory}

\item{sampleNames}{vector type. 1-1 correspondance to files}

\item{outputDir}{string type.}

\item{skipDgene}{logical type. Skip D germline abundance plot if TRUE.}

\item{.save}{logical type. Save Rdata ggplot item}
}
\value{
None
}
\description{
Abundance distribution
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/annotationAnalysis.R
\name{.annotAnalysis}
\alias{.annotAnalysis}
\title{Annotation analysis}
\usage{
.annotAnalysis(annotDirectories, annotOut, sampleNames, mashedNames,
  .save = TRUE)
}
\arguments{
\item{annotDirectories}{list type. List of sample directories}

\item{annotOut}{string type. Output directory}

\item{sampleNames}{vector type. 1-1 with annotDirectories}

\item{mashedNames}{string type. File output "mashed" sample names}

\item{.save}{logical type. Saves ggplot object}
}
\value{
none
}
\description{
Annotation analysis
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/upstreamAnalysis.R
\name{.plotIGVUpstreamLenDistDetailed}
\alias{.plotIGVUpstreamLenDistDetailed}
\title{Plots the detailed length distribution for IGV families}
\usage{
.plotIGVUpstreamLenDistDetailed(upstreamDirectories, upstreamOut,
  upstreamLengthRange, lengthType, sampleNames, combinedNames, mashedNames,
  .save = TRUE)
}
\arguments{
\item{upstreamDirectories}{list type. List of sample directories}

\item{upstreamOut}{string type. Output directory}

\item{upstreamLengthRange}{The range of upstream sequences to be included in
this plot. This is usually determined by abseqPy and the format should be as
follows: "min_max", e.g.: 1_15 means range(1, 15) inclusive.string type.}

\item{lengthType}{string type. "" (the empty string) denotes everything
and "_short" denotes a short sequence. abseqPy dictates this because it's
used for locating the files.}

\item{sampleNames}{vector type. 1-1 with upstream directories}

\item{combinedNames}{string type. Title friendly "combined" sample names}

\item{mashedNames}{string type. File friendly "mashed-up" sample names}

\item{.save}{logical type. Save Rdata?}
}
\value{
None
}
\description{
A boxplot for each IGV families showing the IQR of upstream
lengths. In contrast to \code{\link{.plotIGVUpstreamLenDist}},
which only shows the distribution of IGV families
over \code{upstreamLengthRange}.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/abseqReport.R
\name{.loadSamplesFromString}
\alias{.loadSamplesFromString}
\title{Loads AbSeqCRep or AbSeqRep objects from a list of sampleNames}
\usage{
.loadSamplesFromString(sampleNames, root, warnMove = TRUE)
}
\arguments{
\item{sampleNames}{vector, singleton or otherwise}

\item{root}{string type. root directory}

\item{warnMove}{logical type. Warning message
("message" level, not "warning" level) if the directory has been moved?}
}
\value{
AbSeqRep or AbSeqCRep object depending on sampleNames
}
\description{
Loads AbSeqCRep or AbSeqRep objects from a list of sampleNames
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/distributions.R
\name{.plotSpectratype}
\alias{.plotSpectratype}
\title{Spectratype plotter}
\usage{
.plotSpectratype(dataframes, sampleNames, region, title = "Spectratype",
  subtitle = "", xlabel = "Length(AA)", ylabel = "Distribution",
  showLabel = FALSE)
}
\arguments{
\item{dataframes}{list type. List of dataframes.}

\item{sampleNames}{vector type. 1-1 correspondance with dataframes}

\item{region}{string type. Region that will be displayed in the plot title.
This specifies which region this spectratype belongs to. If not supplied,
a default (start, end) range will be displayed instead}

\item{title}{string type. Ignored if region is specified.}

\item{subtitle}{string type}

\item{xlabel}{string type}

\item{ylabel}{string type}

\item{showLabel}{bool type. Show geom_text? - Ignored if samples > 1}
}
\value{
ggplot2 object
}
\description{
Plots length distribution
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/util.R
\name{.inferAnalyzed}
\alias{.inferAnalyzed}
\title{Returns all samples found under \code{sampleDirectory}}
\usage{
.inferAnalyzed(sampleDirectory)
}
\arguments{
\item{sampleDirectory}{string, path to sample directory.}
}
\value{
un-normalized path to all samples under \code{sampleDirectory}
}
\description{
Returns all samples found under \code{sampleDirectory}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/util.R
\name{.findRepertoires}
\alias{.findRepertoires}
\title{Given a directory = <abseqPy_outputdir>/RESULT_DIR/, returns the directories (repositories) in
'directory'. That is, will not return any sample_vs_sample directories.
This is done by asserting that a 'repository'
must have an (analysis.params) file, and a summary.txt file.}
\usage{
.findRepertoires(directory)
}
\arguments{
\item{directory}{string. Path up until <abseqPy_outputdir>/RESULT_DIR/}
}
\value{
vector of strings that are samples in 'directory', note, this is NOT
a full path, but just the sample/repertoire name itself
}
\description{
A sample_vs_sample directory will not have these files.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/primerAnalysis.R
\name{.plotPrimerIGVStatus}
\alias{.plotPrimerIGVStatus}
\title{Plots, for a given \code{category} and \code{pend}, the \code{primer}
IGV indelled distribution in a bar plot}
\usage{
.plotPrimerIGVStatus(primer, pend, category, primerDirectories,
  sampleNames, primerOut, combinedNames, mashedNames, .save = TRUE)
}
\arguments{
\item{primer}{string, primer name}

\item{pend}{string, either 3 or 5 (primer end)}

\item{category}{string, either "all", "productive", or "outframe"}

\item{primerDirectories}{string type. Path to primer analysis directory}

\item{sampleNames}{vector type. 1-1 with primerDirectories}

\item{primerOut}{string type. output directory}

\item{combinedNames}{string type. Title friendly "combined" sample names}

\item{mashedNames}{string type. File friendly "mashed-up" sample names}

\item{.save}{logical type. Save Rdata?}
}
\value{
None
}
\description{
Plots the abundace of indelled primers relative to IGV germlines
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/pairwise.R
\name{.clonotypeAnalysis}
\alias{.clonotypeAnalysis}
\title{Comprehensive clonotype analyses}
\usage{
.clonotypeAnalysis(diversityDirectories, clonotypeOut, sampleNames,
  mashedNames, .save = TRUE)
}
\arguments{
\item{diversityDirectories}{list type. List of directories to diversity dir}

\item{clonotypeOut}{string type. Output directory}

\item{sampleNames}{vector type. 1-1 with diversityDirectories}

\item{mashedNames}{string type. Prefix for ooutput files using "mashed-up"}

\item{.save}{logical type. Save ggplot object?}
}
\value{
Nothing
}
\description{
Comprehensive clonotype analyses
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/diversityAnalysis.R
\name{.aminoAcidBar}
\alias{.aminoAcidBar}
\title{Plots amino acid composition logo}
\usage{
.aminoAcidBar(df, scale, region, germ = "")
}
\arguments{
\item{df}{dataframe}

\item{scale}{logical. scale to proportion?}

\item{region}{string. which region is this}

\item{germ}{string. V germline family}
}
\value{
ggplot2 object
}
\description{
Plots amino acid composition logo
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/diversityAnalysis.R
\name{.calculateDiversityEstimates}
\alias{.calculateDiversityEstimates}
\title{Calculates Lower Bound Estimates for unseen species and Common Diversity
Indices from clonotype tables}
\usage{
.calculateDiversityEstimates(diversityDirectories, diversityOut,
  sampleNames)
}
\arguments{
\item{diversityDirectories}{list type. List of directories to diversity dir}

\item{diversityOut}{string type. Output directory}

\item{sampleNames}{vector type. 1-1 with diversityDirectories sample names}
}
\value{
None
}
\description{
Employ common techniques to calculate LBE for unseen species
and commonly used diversity indices
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotter.R
\name{.plotSamples}
\alias{.plotSamples}
\title{Monolith AbSeq Plot function - the "driver" program}
\usage{
.plotSamples(sampleNames, directories, analysis, outputDir, primer5Files,
  primer3Files, upstreamRanges, skipDgene = FALSE)
}
\arguments{
\item{sampleNames}{vector type. Vector of sample names in strings}

\item{directories}{vector type. Vector of directories in strings, must be
1-1 with sampleNames}

\item{analysis}{vector / list type. What analysis to plot for. If sampleNames
or directories is > 1 (i.e. AbSeqCRep), then make sure that it's
an intersection of all analysis conducted by the repertoires, otherwise, it
wouldn't make sense}

\item{outputDir}{string type. Where to dump the output}

\item{primer5Files}{vector / list type. Collection of strings that the sample
used for primer5 analysis. If sample N doesn't have a primer 5 file,
leave it as anthing but a valid file path.}

\item{primer3Files}{vector / list type. Collection of strings that the sample
used for primer 3 analysis. If sample N doesn't have a primer 3 file,
leave it as anthing but a valid file path.}

\item{upstreamRanges}{list type. Collection of "None"s or vector
denoting upstreamStart and upstreamEnd for each sample.}

\item{skipDgene}{logical type. Whether or not to skip D gene distribution plot}
}
\value{
none
}
\description{
Monolith AbSeq Plot function - the "driver" program
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/diversityAnalysis.R
\name{.plotRecapture}
\alias{.plotRecapture}
\title{Plots capture-recapture}
\usage{
.plotRecapture(files, sampleNames, regions = c("CDR3", "V"))
}
\arguments{
\item{files}{list type. List of _cdr_v_recapture.csv.gz files.}

\item{sampleNames}{vector type. A vector of strings each
representing the name of samples in files.}

\item{regions}{vector type. A vector of strings,
regions to be included in the plot. defaults to c("CDR3", "V")}
}
\value{
ggplot2 object
}
\description{
Plots the percent of recapture clonotypes (on the y-axis)
drawn from a repeated (with replacement) sample size on the x axis. The
percentage of recaptured clonotypes is averaged over 5 recapture rounds.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/abundanceAnalysis.R
\name{.hmFromMatrix}
\alias{.hmFromMatrix}
\title{Plots a plotly heatmap from provided matrix}
\usage{
.hmFromMatrix(m, title, xlabel = "", ylabel = "")
}
\arguments{
\item{m}{matrix type}

\item{title}{character type}

\item{xlabel}{character type}

\item{ylabel}{character type}
}
\value{
list with keys: static and interactive (ggplot2 object and plotly
object respectivelyb)
}
\description{
Plots a plotly heatmap from provided matrix
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/accessors-AbSeq.R
\name{.asRepertoireUpstream}
\alias{.asRepertoireUpstream}
\title{Accessor for the \code{upstream} slot}
\usage{
.asRepertoireUpstream(object)
}
\arguments{
\item{object}{AbSeqRep object}
}
\value{
character type
}
\description{
Accessor for the \code{upstream} slot
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/accessors-AbSeq.R
\name{.asRepertoirePrimer3}
\alias{.asRepertoirePrimer3}
\title{Accessor for the \code{primer3end} slot}
\usage{
.asRepertoirePrimer3(object)
}
\arguments{
\item{object}{AbSeqRep object}
}
\value{
character type, the FASTA file name for primer 3' end sequences
}
\description{
Accessor for the \code{primer3end} slot
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/accessors-AbSeq.R
\name{.asRepertoireChain}
\alias{.asRepertoireChain}
\title{Accessor for \code{chain} slot}
\usage{
.asRepertoireChain(object)
}
\arguments{
\item{object}{AbSeqRep object}
}
\value{
character type, the chain type of this sample
}
\description{
Accessor for \code{chain} slot
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/abundanceAnalysis.R
\name{.alignQualityHeatMaps}
\alias{.alignQualityHeatMaps}
\title{Plots all 5 alignment quality heatmaps}
\usage{
.alignQualityHeatMaps(abundanceDirectory, sampleName)
}
\arguments{
\item{abundanceDirectory}{character type.
fully qualified path to abundance directory}

\item{sampleName}{character type. sample name}
}
\value{
list of ggplotly heatmaps
}
\description{
Plots alignment quality vs:
\itemize{
  \item{mismatches}
  \item{gaps}
  \item{bitscore}
  \item{percent identity}
  \item{subject start}
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/diversityAnalysis.R
\name{.regionAnalysis}
\alias{.regionAnalysis}
\title{Title Shows varying regions for a given clonotype defined by its CDR3}
\usage{
.regionAnalysis(path, sampleName, top = 15)
}
\arguments{
\item{path}{string type. Path to diversity folder
where <sampleName>_clonotype_diversity_region_analysis.csv.gz is located}

\item{sampleName}{string type}

\item{top}{int type. Top N number of clones to analyze}
}
\value{
ggplot2 object
}
\description{
Title Shows varying regions for a given clonotype defined by its CDR3
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/accessors-AbSeq.R
\name{.asRepertoireSubjectStart}
\alias{.asRepertoireSubjectStart}
\title{Accessor for \code{sstart} slot}
\usage{
.asRepertoireSubjectStart(object, collapse = " - ")
}
\arguments{
\item{object}{AbSeqRep object}

\item{collapse}{character type, collapse the range using this string.}
}
\value{
character type. If collapse is a string, then the ranges
are represented as `start - end` in a string, if collapse is NULL,
returns a character vector of length
two, denoting the start and end value respectively.
}
\description{
Accessor for \code{sstart} slot
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/diversityAnalysis.R
\name{.plotRarefaction}
\alias{.plotRarefaction}
\title{Rarefaction plot}
\usage{
.plotRarefaction(files, sampleNames, regions = c("CDR3", "V"))
}
\arguments{
\item{files}{list type. A list of files consisting of path to samples}

\item{sampleNames}{vector type. A vector of strings,
each being the name of samples in files}

\item{regions}{vector type. A vector of strings,
regions to be included. Defaults to c("CDR3", "V")}
}
\value{
ggplot2 object
}
\description{
Plots the number of unique clonotypes (on the y-axis)
drawn from a sample size on the x axis. The number of unique clonotypes
is averaged over 5 repeated rounds.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/primerAnalysis.R
\name{.commonPrimerNames}
\alias{.commonPrimerNames}
\title{Collect the intersection of all primer names within a collection
of primer files}
\usage{
.commonPrimerNames(primerFiles)
}
\arguments{
\item{primerFiles}{list / vector type. Collection of primer files}
}
\value{
vector type. Vector of primerNames that are present in ALL
primerFiles. NULL if there's no intersection at all
}
\description{
Collect the intersection of all primer names within a collection
of primer files
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/abundanceAnalysis.R
\name{.plotCirclize}
\alias{.plotCirclize}
\title{V-J association plot}
\usage{
.plotCirclize(sampleName, path, outputdir)
}
\arguments{
\item{sampleName}{string type}

\item{path}{string type. Path to _vjassoc.csv}

\item{outputdir}{string type}
}
\value{
None
}
\description{
V-J association plot
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/accessors-AbSeq.R
\name{.asRepertoireDir}
\alias{.asRepertoireDir}
\title{Accessor for the \code{outdir} slot}
\usage{
.asRepertoireDir(object)
}
\arguments{
\item{object}{AbSeqRep object}
}
\value{
character type, the output directory of this object
}
\description{
Accessor for the \code{outdir} slot
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/abseqReport.R
\name{abseqReport}
\alias{abseqReport}
\title{Visualize all analysis conducted by abseqPy}
\usage{
abseqReport(directory, report, compare, BPPARAM)
}
\arguments{
\item{directory}{string type. directory as specified in
\code{-o} or \code{--outdir} in abseqPy. This tells AbSeq where to look for
abseqPy's output.}

\item{report}{(optional) integer type. The possible values are:
\itemize{
  \item{0 - does nothing (returns named list of \linkS4class{AbSeqRep} objects)}
  \item{1 - generates plots for csv files}
  \item{2 - generates a report that collates all plots}
  \item{3 - generates interactive plots in report (default)}
}
each higher value also does what the previous values do. For example, \code{report = 2}
will return a named list of \linkS4class{AbSeqRep} objects, plot csv files,
and generate a (non-interactive)HTML report that collates all the plots together.}

\item{compare}{(optional) vector of strings. From the samples in found in \code{directory}
directory, they can be selected and compared against each other. For example,
 to compare "sample1" with "sample2" and "sample3" with "sample4",
 \code{compare} should be c("sample1,sample2", "sample3,sample4"). An error
 will be thrown if the samples specified in this parameter are not found in
 \code{directory}.}

\item{BPPARAM}{(optional) BiocParallel backend. Configures the parallel implementation.
Refer to \href{https://bioconductor.org/packages/release/bioc/html/BiocParallel.html}{BiocParallel}
for more information. By default, use all available cores.}
}
\value{
named list. List of \linkS4class{AbSeqRep} objects. The names of
the list elements are taken directly from the repertoire object itself.
This return value is consistent with the return value of \code{\link{report}}.
}
\description{
Plots all samples in the output directory supplied to abseqPy's
\code{--outdir} or \code{-o} argument. Users can optionally specify
which samples in \code{directory} should be compared. Doing so generates
additional plots for clonotype comparison and the usual plots will also
conveniently include these samples using additional \code{aes}thetics.

Calling this function with a valid \code{directory} will always return a
named \code{list} of objects; these individual objects can be
combined using the \code{+} operator to form a new comparison, in which the
\link{report} function accepts as its first parameter.
}
\examples{
# Use example data from abseqR as abseqPy's output, substitute this
# with your own abseqPy output directory
abseqPyOutput <- tempdir()
file.copy(system.file("extdata", "ex", package = "abseqR"), abseqPyOutput, recursive=TRUE)

### 1. The `report` parameter usage example:

# report = 0; don't plot, don't collate a HTML report, don't show anything interactive
samples <- abseqReport(file.path(abseqPyOutput, "ex"), report = 0)
# samples is now a named list of AbSeqRep objects

# report = 1; just plot pngs; don't collate a HTML report; nothing interactive
# samples <- abseqReport(file.path(abseqPyOutput, "ex"), report = 1)
# samples is now a named list of AbSeqRep objects

# report = 2; plot pngs; collate a HTML report; HTML report will NOT be interactive
# samples <- abseqReport(file.path(abseqPyOutput, "ex"), report = 2)
# samples is now a named list of AbSeqRep objects

# report = 3 (default); plot pngs; collate a HTML report; HTML report will be interactive
# samples <- abseqReport(file.path(abseqPyOutput, "ex"), report = 3)
# samples is now a named list of AbSeqRep objects

### 2. Using the return value of abseqReport:

# NOTE, often, this is used to load multiple samples from different directories
# using abseqReport (with report = 0), then the samples are added together
# before calling the report function. This is most useful when the samples
# live in different abseqPy output directory.

# Note that the provided example data has PCR1, PCR2, and PCR3
# samples contained within the directory
stopifnot(names(samples) == c("PCR1", "PCR2", "PCR3"))

# as a hypothetical example, say we found something
# interesting in PCR1 and PCR3, and we want to isolate them:
# we want to explicitly compare PCR1 with PCR3
pcr13 <- samples[["PCR1"]] + samples[["PCR3"]]

# see abseqR::report for more information.
# abseqR::report(pcr13)      # uncomment this line to run

### BPPARAM usage:

# 4 core machine, use all cores -  use whatever value that suits you
nproc <- 4
# samples <- abseqReport(file.path(abseqPyOutput, "ex"),
#                        BPPARAM = BiocParallel::MulticoreParam(nproc))


# run sequentially - no multiprocessing
# samples <- abseqReport(file.path(abseqPyOutput, "ex"),
#                        BPPARAM = BiocParallel::SerialParam())

# see https://bioconductor.org/packages/release/bioc/html/BiocParallel.html
# for more information about how to use BPPARAM and BiocParallel in general.
}
\seealso{
\linkS4class{AbSeqRep}

\code{\link{report}}. Analogous function, but takes input from
an \linkS4class{AbSeqRep} or \linkS4class{AbSeqCRep} object instead.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/util.R
\name{.getLineTypes}
\alias{.getLineTypes}
\title{Helper function to return line types by importance based on provided
CD/Fs regions}
\usage{
.getLineTypes(regions)
}
\arguments{
\item{regions}{a list/vector of strings (regions)}
}
\value{
vector of strings, each corresponding to the appropriate line type
for \code{regions}.
}
\description{
In the aesthetics of diversity plots (rarefaction, recapture,
and duplication), the line types should emphasise the most important
antibody region, they're ranked in ascending order of:
"FR4", "FR1", "FR2", "FR3", "CDR1", "CDR2", "CDR3", "V".
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/util.R
\name{.getTotal}
\alias{.getTotal}
\title{Get total number of samples (n)}
\usage{
.getTotal(filename)
}
\arguments{
\item{filename}{csv filename}
}
\value{
string, sample size.
}
\description{
Often enough, the CSV values supplied do not contain
raw counts but percentages (so this value will let us know exactly
the sample size).
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/pairwise.R
\name{.scatterPlot}
\alias{.scatterPlot}
\title{Title Creates a scatter plot}
\usage{
.scatterPlot(df1, df2, name1, name2, cloneClass)
}
\arguments{
\item{df1}{dataframe for sample 1}

\item{df2}{dataframe for sample 2}

\item{name1}{string type, Sample 1 name}

\item{name2}{string type. Sample 2 name}

\item{cloneClass}{string type.
What region was used to classify clonotypes - appears in title. For example,
CDR3 or V region}
}
\value{
ggplot2 object
}
\description{
Title Creates a scatter plot
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/productivityAnalysis.R
\name{.productivityAnalysis}
\alias{.productivityAnalysis}
\title{Conducts productivty analysis}
\usage{
.productivityAnalysis(productivityDirectories, prodOut, sampleNames,
  combinedNames, mashedNames, .save = TRUE)
}
\arguments{
\item{productivityDirectories}{list type. List of directories}

\item{prodOut}{string type. Output directory}

\item{sampleNames}{vector type. 1-1 with productivity directories}

\item{combinedNames}{string type. Title friendly "combined" sample names}

\item{mashedNames}{string type. File friendly "mashed-up" sample names}

\item{.save}{logical type. Save Rdata}
}
\value{
None
}
\description{
Conducts productivty analysis
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/distributions.R
\name{.boxPlot}
\alias{.boxPlot}
\title{Creates a box plot}
\usage{
.boxPlot(dataframes, sampleNames, plotTitle, xlabel = "", ylabel = "",
  subs = "")
}
\arguments{
\item{dataframes}{list type. List of sample dataframes}

\item{sampleNames}{vector type. 1-1 with dataframes}

\item{plotTitle}{string type}

\item{xlabel}{string type}

\item{ylabel}{string type}

\item{subs}{string type}
}
\value{
ggplot2 object
}
\description{
Creates a box plot
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/upstreamAnalysis.R
\name{.plotUpstreamLength}
\alias{.plotUpstreamLength}
\title{Plot upstream distribution}
\usage{
.plotUpstreamLength(upstreamDirectories, upstreamOut, expectedLength,
  upstreamLengthRange, sampleNames, combinedNames, mashedNames,
  .save = TRUE)
}
\arguments{
\item{upstreamDirectories}{list type. List of sample directories}

\item{upstreamOut}{string type. Output directory}

\item{expectedLength}{int type. Expected length of upstream sequences.
(i.e. upstream_end - upstream_start + 1).}

\item{upstreamLengthRange}{string type. start_end format}

\item{sampleNames}{vector type. 1-1 with upstream directories}

\item{combinedNames}{string type. Title friendly "combined" sample names}

\item{mashedNames}{string type. File friendly "mashed-up" sample names}

\item{.save}{logical type. Save Rdata?}
}
\value{
None
}
\description{
Plot upstream distribution
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/diversityAnalysis.R
\name{.aminoAcidPlot}
\alias{.aminoAcidPlot}
\title{Composition logo plot}
\usage{
.aminoAcidPlot(compositionDirectory, outdir, sampleName,
  regions = c("FR1", "CDR1", "FR2", "CDR2", "FR3", "CDR3", "FR4"),
  .save = TRUE)
}
\arguments{
\item{compositionDirectory}{string type.}

\item{outdir}{string type.}

\item{sampleName}{string type.}

\item{regions}{logical type. vector of FR/CDR regions to plot}

\item{.save}{logical type. save ggplot object}
}
\value{
none
}
\description{
Plots 2 kinds: scaled and unscaled composition logos
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/distributions.R
\name{.plotDist}
\alias{.plotDist}
\title{Bar plotter}
\usage{
.plotDist(dataframes, sampleNames, plotTitle, vert = TRUE, xlabel = "",
  ylabel = "", perc = TRUE, subs = "", sorted = TRUE,
  cutoff = 15, legendPos = "right")
}
\arguments{
\item{dataframes}{list type. List of dataframes}

\item{sampleNames}{vector type. 1-1 correspondence to dataframes.}

\item{plotTitle}{string type.}

\item{vert}{boolean type. True if the plot should be vertical}

\item{xlabel}{string type}

\item{ylabel}{string type}

\item{perc}{boolean type. True if data's axis is a percentage
proportion (instead of 0-1) only used if length(sampleNames) == 1}

\item{subs}{string type}

\item{sorted}{boolean type. True if bar plot should be sorted in descending
order}

\item{cutoff}{int type. Number of maximum ticks to show (x on vert plots,
y on hori plots).}

\item{legendPos}{string type. Where to position legend (see ggplot's theme())}
}
\value{
ggplot2 object
}
\description{
Plots barplot for all sample in dataframes.
If length(sampleNames) == 1, then the bars will also have
y-values (or x if horizontal plot) labels on them.
Use 'perc' to control if the values are percentages.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/diversityAnalysis.R
\name{.calculateDInd}
\alias{.calculateDInd}
\title{Calculates the "standard" diversity indices}
\usage{
.calculateDInd(df)
}
\arguments{
\item{df}{clonotype dataframe. Vegan format:
+---------------------------+
| S.1| S.2| S.3 | S.4 | ... |   (each species should have its own column)
+---------------------------+
| v1 |v2  | v3  | ....      |   (each species' count values are placed in the corresponding column)
+---------------------------+}
}
\value{
dataframe with the column headers:
shannon , simpson.con , simpson.inv , simpson.gini , renyi.0 ,
renyi.1 , renyi.2 , renyi.Inf , hill.0 , hill.1 , hill.2 , hill.Inf

renyi.0 => species richness
renyi.1 => shannon entropy
renyi.2 => inv.gini
renyi.Inf => min.entropy

finally:
   hill_a = exp(renyi_a)
}
\description{
Calculates the "standard" diversity indices
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/util.R
\name{.saveAs}
\alias{.saveAs}
\title{Saves ggplot object as a Rdata file.}
\usage{
.saveAs(.save, filename, plot)
}
\arguments{
\item{.save}{logical type. Whether or not we should save.}

\item{filename}{string.}

\item{plot}{ggplot object.}
}
\value{
nothing
}
\description{
It's a convinient function that does the check and saves
at the same time, for brevity within other areas of the code (to eliminate
repeated if checks).
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/accessors-AbSeq.R
\name{.asRepertoireList}
\alias{.asRepertoireList}
\title{Accessor for \linkS4class{AbSeqCRep}'s list of \linkS4class{AbSeqRep} objects}
\usage{
.asRepertoireList(object)
}
\arguments{
\item{object}{AbSeqCRep object}
}
\value{
list type, list of \linkS4class{AbSeqRep} objects that together,
compose this \linkS4class{AbSeqCRep} object.
}
\description{
Accessor for \linkS4class{AbSeqCRep}'s list of \linkS4class{AbSeqRep} objects
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AbSeqRep.R
\docType{methods}
\name{report}
\alias{report}
\alias{report,AbSeqRep-method}
\alias{report,AbSeqCRep-method}
\title{Plots \linkS4class{AbSeqRep} or
\linkS4class{AbSeqCRep} object to the specfied directory}
\usage{
report(object, outputDir, report = 3)

\S4method{report}{AbSeqRep}(object, outputDir, report = 3)

\S4method{report}{AbSeqCRep}(object, outputDir, report = 3)
}
\arguments{
\item{object}{AbSeqRep or AbSeqCRep object to plot.}

\item{outputDir}{string type. Directory where analysis will be saved to.}

\item{report}{(optional) integer type. The possible values are:
\itemize{
  \item{0 - does nothing (returns named list of \linkS4class{AbSeqRep} objects)}
  \item{1 - generates plots for csv files}
  \item{2 - generates a report that collates all plots}
  \item{3 - generates interactive plots in report} (default)
}
each value also does what the previous values do. For example, \code{report = 2}
will return a named list of \linkS4class{AbSeqRep} objects, plot csv files,
and generate a (non-interactive)HTML report that collates all the plots together.}
}
\value{
named list. List of \linkS4class{AbSeqRep} objects. The names of
the list elements are taken directly from the repertoire object itself.
This return value is consistent with the return value of \code{\link{abseqReport}}.
}
\description{
Plots all samples in the \code{object} argument
and saves the analysis in \code{outputDir}.
Users can optionally specify which samples
in \code{object} should be compared. Doing so generates
additional plots for clonotype comparison and
the usual plots will also conveniently include these samples
using additional \code{aes}thetics.

This method is analogous to \code{\link{abseqReport}}.
The only difference is that this method accepts \linkS4class{AbSeqRep} or
\linkS4class{AbSeqCRep} objects as its first parameter, and the
\code{outputDir} specifies where to store the result.
}
\examples{
# Use example data from abseqR as abseqPy's output, substitute this
# with your own abseqPy output directory
abseqPyOutput <- tempdir()
file.copy(system.file("extdata", "ex", package = "abseqR"), abseqPyOutput, recursive=TRUE)
samples <- abseqReport(file.path(abseqPyOutput, "ex"), report = 0)


# The provided example data has PCR1, PCR2, and PCR3 samples contained within
# We can use the + operator to combine samples, thus requesting the
# report function to compare them:
pcr12 <- samples[["PCR1"]] + samples[["PCR2"]]

# generate plots and report for this new comparison
# report(pcr12, "PCR1_vs_PCR2")

# generate plots only
# report(pcr12, "PCR1_vs_PCR2", report = 1)

# generate plots, and a non-interactive report
# report(pcr12, "PCR1_vs_PCR2", report = 2)

# generate plots, and an interactive report
# report(pcr12, "PCR1_vs_PCR2", report = 3)   # this is the default
}
\seealso{
\code{\link{abseqReport}}. Analogus function, but takes input from
a string that signifies the output directory of abseqPy as the first
arugment instead.

\linkS4class{AbSeqRep}

\linkS4class{AbSeqCRep}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/upstreamAnalysis.R
\name{.plotUpstreamLengthDist}
\alias{.plotUpstreamLengthDist}
\title{Plot upstream sequence length distribution for upstream sequences (5'UTR or
secretion signal) for a given \code{upstreamLengthRange}}
\usage{
.plotUpstreamLengthDist(upstreamDirectories, upstreamOut,
  upstreamLengthRange, lengthType, sampleNames, combinedNames, mashedNames,
  .save)
}
\arguments{
\item{upstreamDirectories}{list type. List of sample directories}

\item{upstreamOut}{string type. Output directory}

\item{upstreamLengthRange}{The range of upstream sequences to be included in
this plot. This is usually determined by abseqPy and the format should be as
follows: "min_max", e.g.: 1_15 means range(1, 15) inclusive.string type.}

\item{lengthType}{string type. "" (the empty string) denotes everything
and "_short" denotes a short sequence. abseqPy dictates this because it's
used for locating the files.}

\item{sampleNames}{vector type. 1-1 with upstream directories}

\item{combinedNames}{string type. Title friendly "combined" sample names}

\item{mashedNames}{string type. File friendly "mashed-up" sample names}

\item{.save}{logical type. Save Rdata?}
}
\value{
None
}
\description{
Given an upstream length range, plot the
distribution of upstream sequence lengths.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/productivityAnalysis.R
\name{.productivityPlot}
\alias{.productivityPlot}
\title{Summary of productivity}
\usage{
.productivityPlot(dataframes, sampleNames)
}
\arguments{
\item{dataframes}{list type. List of sample dataframes}

\item{sampleNames}{vector type. 1-1 with dataframes}
}
\value{
ggplot2 object
}
\description{
Shows the percentage of 1. productivity, 2. non-functional +
reason for being unproductive,
i.e. "Stop Codon" or "Out of frame" or "Stop & Out"
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/util.R
\name{.checkVert}
\alias{.checkVert}
\title{Checks if abseqPy has a metadata line that suggests
the orientation}
\usage{
.checkVert(filename)
}
\arguments{
\item{filename}{csv filename}
}
\value{
True if CSV metadata says "plot vertically"
}
\description{
Checks if abseqPy has a metadata line that suggests
the orientation
}
